unit GabeAnim;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

type
  TGabeAnim = class(TAnimate)
  private
    FCursUpHandle: Integer;
    FCursDnHandle: Integer;
    FCursDefHandle: Integer;
    FCursDisHandle: Integer;
    FCurson: boolean;
    procedure SetCursHandle(Index: Integer;const Value: Integer);
    function  GetCursHandle(Index: Integer): Integer;
    procedure CMMouseEnter(var msg:TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var msg: TMessage); message CM_MOUSELEAVE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure SetCurson(const Value: boolean);
  protected
  public
    Constructor Create(AOwner: TComponent); override;
  published
    property CursDnHandle: Integer index 0 read GetCursHandle write SetCursHandle;
    property CursUpHandle: Integer index 1 read GetCursHandle write SetCursHandle;
    property CursDefHandle: Integer index 2 read GetCursHandle write SetCursHandle;
    property CursDisHandle: Integer index 3 read GetCursHandle write SetCursHandle;
    property Curson: boolean read FCurson write SetCurson default True;
    property OnClick;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Gabes', [TGabeAnim]);
end;

{ TGabeAnim }


procedure TGabeAnim.CMMouseEnter(var msg: TMessage);
begin
   Inherited;
   If fcurson then
      Screen.Cursor := FCursUpHandle
   else
      Screen.Cursor := FCursDisHandle;
   Invalidate;
end;

procedure TGabeAnim.CMMouseLeave(var msg: TMessage);
begin
   Inherited;
   Screen.Cursor := FCursDefHandle;
   Invalidate;
end;

constructor TGabeAnim.Create(AOWner: TComponent);
begin
   Inherited Create(AOwner);
   FCurson:=true;
end;

procedure TGabeAnim.SetCursHandle(Index: Integer;const Value: Integer);
begin
   Case Index of
    0:If fcursdnhandle<>Value then FCursDnHandle := Value;
    1:If fcursuphandle<>Value then FCursUpHandle := Value;
    2:If fcursdefhandle<>Value then FCursDefHandle := Value;
    3:If fcursdishandle<>Value then FCursDisHandle := Value;
   end;
   Invalidate;
end;

function TGabeAnim.GetCursHandle(Index:Integer):integer;
begin
   Case Index of
    0:Result:=FCursDnHandle;
    1:Result:=FCursUpHandle;
    2:Result:=FCursDefHandle;
    3:Result:=FCursDisHandle;
   end;
end;

procedure TGabeAnim.SetCurson(const Value: boolean);
begin
  IF FCurson<>Value then FCurson := Value;
end;

procedure TGabeAnim.WMLButtonDown(var Message: TWMLButtonDown);
begin
   Inherited;
   If enabled then
    begin
     Screen.Cursor := FCursDnHandle;
     Invalidate;
    end;
end;

procedure TGabeAnim.WMLButtonUp(var Message: TWMLButtonUp);
begin
   Inherited;
   If enabled then
    begin
     Screen.Cursor := FCursUpHandle;
     Invalidate;
    end;
end;

end.
