unit GabeCursLoad;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,dialogs,registry,
  DsgnIntf, TypInfo, stdctrls, exptintf, VirtIntf, ToolIntf, editintf,shellapi;

type
  TGCursors = class(TPersistent)
   private
     FList:TStringlist;
   public
     constructor Create;
     destructor  Destroy; Override;
   published
     property List: TStringlist read FList write FList;
   end;

  TGabeCursLoad = class(TComponent)
  private
    FGCursors: TGCursors;
  public
    constructor Create (AOwner : TComponent); override;
    procedure Loaded; override;
    destructor Destroy; override;
  published
    property GCursors: TGCursors read FGCursors write FGCursors;
  end;

implementation

{TGabeCursLoad}

constructor TGabeCursLoad.Create (AOwner : TComponent);
var s,delph:string;
    Listit:tstringlist;

    procedure WriteToProjectEditor;
    const BUFSIZE = 3000;
          SEARCHSTR = '{$R *.DFM}';
          INSERTTEXT = '{$R Gabecurs.res}';
    var
       Module: TIModuleInterface;
       Editor: TIEditorInterface;
       Writer: TIEditWriter;
       Reader: TIEditReader;
       buf, p: PChar;
       index: Integer;
    begin
      if assigned(ToolServices) then
      try
        with ToolServices do
        try
          Module := GetModuleInterface(ChangeFileExt(GetCurrentFile, '.pas'));
          try
            Editor := Module.GetEditorInterface;
            try
              Reader:= Editor.CreateReader;
              buf := AllocMem(BUFSIZE);
              Reader.GetText(0,buf,BUFSIZE);
              Reader.Free;
              if StrPos(buf, INSERTTEXT) = nil then 
               begin
                p := StrPos(buf, SEARCHSTR); // is case sensitive!!!
                index := Integer(p) - Integer(buf);
                Writer := Editor.CreateWriter;
                Writer.CopyTo(index+(length(Searchstr)));
                Writer.Insert(#13#10#13#10 + INSERTTEXT + #13#10);
                Writer.Free;
              end;
              FreeMem(buf);
            finally
            end;
          finally
            Editor.Free;
          end;
        finally
          Module.Free;
        end;
      finally
      end;
    end;

   Function GetShortFileName(Const FileName : String) : String;
   var aTmp: array[0..255] of char;
   begin
    if GetShortPathName(PChar(FileName),aTmp,Sizeof(aTmp)-1)=0 then
     Result:= FileName else Result:=StrPas(aTmp);
   end;

begin
  inherited Create(AOwner);
  FGCursors:=TGCursors.Create;
  if (csDesigning in ComponentState) then
   begin
    WriteToProjectEditor;
    s:='';
    GetDir(0,s);
    s:=Getshortfilename(s);
    s:=(s+'\GabeCurs.RC');
    Listit:=Tstringlist.create;
    Listit.add(';Temp rc file');
    If not Fileexists(s) then
      Listit.savetofile(s);
    Delete(s,(length(s)-1),2);
    Listit.clear;
    Listit.Add('@echo off');
    Listit.Add('del '+S+'RES');
    With Tregistry.create do
     begin
      Rootkey:=HKEY_LOCAL_MACHINE;
      If OpenKey('Software\Borland\Delphi\3.0',False) then
        Delph:=Readstring('RootDir');
      If OpenKey('Software\Borland\Delphi\4.0',False) then
        Delph:=Readstring('RootDir');
      If OpenKey('Software\Borland\Delphi\5.0',False) then
        Delph:=Readstring('RootDir');
      free;
     end;
    Delph:=GetShortFilename(Delph);
    Listit.Add(Delph+'\Bin\brcc32 -32 -v '+#32+(S+'RC'));
    Listit.SaveToFile(S+'BAT');
    Listit.Free;
    ShellExecute(0, 'OPEN', PChar(S+'BAT'), '', '', SW_HIDE);
   end;
end;

procedure TGabeCursLoad.Loaded;
var RSTRM: TResourcestream;
    i: integer;
    t,s,f: string;
begin
   inherited Loaded;
   if not (csDesigning in ComponentState) then
    begin
     GetDir(0,s);
     If FGCursors.list.count<>0 then
      begin
       For i:=0 to (FGCursors.list.count-1) do
        begin
         t:=FGCursors.list.Strings[i];
         f:=Copy(t,(length(t)-3),3);
         While Pos(' ',t)<>0 do
          begin
           delete(t,(length(t)),1);
          end;
         If f='ani' then
          begin
           RSTRM:=TREsourceStream.CreateFromID(Hinstance, StrToInt(T),'ANICURSOR');
           RSTRM.SaveToFile(s+'\Tmp.Ani');
           RSTRM.free;
           Screen.Cursors[strtoint(t)]:=LoadCursorFromFile(PChar(s+'\Tmp.Ani'));
           DeleteFile(s+'\Tmp.Ani');
          end
         else
          begin
           Screen.Cursors[strtoint(t)]:=LoadCursor(hinstance,MakeIntResource(StrToInt(T)));
          end;
        end;
      end;
    end;
end;

destructor TGabeCursLoad.Destroy;

   procedure DeleteFromProjectEditor;
    const BUFSIZE = 3000;
          SEARCHSTR = '{$R Gabecurs.res}';
    var
       Module: TIModuleInterface;
       Editor: TIEditorInterface;
       Writer: TIEditWriter;
       Reader: TIEditReader;
       buf, p: PChar;
       index: Integer;
    begin
      if assigned(ToolServices) then
      try
        with ToolServices do
        try
          Module := GetModuleInterface(ChangeFileExt(GetCurrentFile, '.pas'));
          try
            Editor := Module.GetEditorInterface;
            try
              Reader:= Editor.CreateReader;
              buf := AllocMem(BUFSIZE);
              Reader.GetText(0,buf,BUFSIZE);
              Reader.free;
              p := StrPos(buf, SEARCHSTR); // is case sensitive!!!
              if p <> nil then
              begin
                index := Integer(p) - Integer(buf);
                Writer := Editor.CreateWriter;
                Writer.CopyTo(index);
                Writer.DeleteTo(index + Length(SEARCHSTR) + Length(#13#10));
                Writer.Free;
              end;
              FreeMem(buf);
            finally
            end;
          finally
            Editor.Free;
          end;
        finally
          Module.Free;
        end;
      finally
      end;
    end;

begin
   FGCursors.free;
   If (csdesigning in componentstate) then
     Deletefromprojecteditor;
   inherited Destroy;
end;

{TGCursors}

constructor TGCursors.Create;
begin
   inherited Create;
   FList:=TStringlist.Create;
end;

destructor TGCursors.Destroy;
begin
   Flist.free;
   inherited Destroy;
end;

end.

