unit GabeCursReg;

interface

uses Windows,Classes,Forms,Controls,Buttons,DsgnIntf,StdCtrls,Comctrls,ExtCtrls,
     GabeCursLoad,GabeEdit,GabeLabel,GabeCombo,GabeImage,GabeAVI,GabeRich,GabeList,
     GabeAnim,Dialogs,registry,ShellAPI;

type
  TGabeCursDlg = class(TForm)
   buttOk: TButton;
   buttCanc: TButton;
   lstCursors: TListBox;
   lbCursload: TLabel;
   lbCursname: TLabel;
   edCursname: TEdit;
   lbFilepath: TLabel;
   edFilepath: TEdit;
   buttBrowse: TButton;
   Browser: TOpenDialog;
   buttAdd: TButton;
   buttDel: TButton;
   procedure buttBrowseClick(Sender: TObject);
   procedure buttAddClick(Sender: TObject);
   procedure buttOkClick(Sender: TObject);
   procedure buttDelClick(Sender: TObject);
   procedure lstCursorsClick(Sender: TObject);
  public
   EditorGCursors: TGCursors;
  end;

  TGCursorsProperty = class(TClassProperty)
   public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
   end;

  {this pulls up the cursor editor when the property is doubleclicked}
  TGabeCursLoadEditor = class(TDefaultEditor)
   protected
    procedure EditProperty(PropertyEditor: TPropertyEditor;
     var Continue,FreeEditor: Boolean); override;
   public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
   end;


procedure Register;

implementation

uses Sysutils;

{$R *.DFM}

{ TGabeCursDlg }
procedure TGabeCursDlg.buttBrowseClick(Sender: TObject);
begin
   Browser.execute;
   edFilepath.text:=Browser.Files.CommaText;
end;

procedure TGabeCursDlg.buttAddClick(Sender: TObject);
var d:integer;
    s,t:string;
begin
   If edFilepath.text<>'' then
    begin
     t:=edfilepath.text;
     s:=Copy(t,(length(t)-3),3);
     If s='ani' then t:='ANICURSOR'
     Else t:='CURSOR';
     d:=lstCursors.items.Count;
     If d<>0 then
      begin
       s:=lstCursors.items[d-1];
       While pos(' ',s)<>0 do
        begin
         delete(s,(length(s)),1);
        end;
       lstcursors.items.add((inttostr(strtoint(s)+1))+' '+t+' '+edfilepath.text);
      end
     else
      begin
       lstCursors.Items.add('150 '+t+' '+edfilepath.text);
       s:='149';
      end;
     edCursname.text:=(inttostr(strtoint(s)+2));
     edfilepath.text:='';
    end
   else showmessage('    You must enter a cursor file path  '+#13+
                    'before adding the file to the cursor list.');
end;

procedure TGabeCursDlg.buttDelClick(Sender: TObject);
begin
   If lstCursors.Selected[lstCursors.itemindex] then
    begin
     lstCursors.items.Delete(lstCursors.itemindex);
     lstCursors.Update;
     edcursname.text:=
        Inttostr((strtoint(copy((lstcursors.items[lstcursors.items.count-1]),1,3)))+1);
     buttdel.enabled:=false;
    end;
end;

procedure TGabeCursDlg.lstCursorsClick(Sender: TObject);
begin
   If lstCursors.items.count<>0 then buttdel.enabled:=true;
end;


procedure TGabeCursDlg.buttOkClick(Sender: TObject);
var Listit,Thelist:tStringlist;
    i:integer;
    s,Delph:string;

   Function GetShortFileName(Const FileName : String) : String;
   var aTmp: array[0..255] of char;
   begin
    if GetShortPathName(PChar(FileName),aTmp,Sizeof(aTmp)-1)=0 then
     Result:= FileName else Result:=StrPas(aTmp);
   end;

begin
   s:='';
   GetDir(0,s);
   s:=Getshortfilename(s);
   Listit:=TStringlist.create;
   TheList:=TStringlist.create;
   Listit.add(';Resource File for GabeCursLoad Component');
   Listit.add(';All Rights Reserved-Gabriel Nicklas');
   Listit.add(';Add Cursors');
   For i:=0 to (lstCursors.items.Count-1) do
    begin
     Listit.add(lstCursors.items[i]);
     TheList.add(lstCursors.items[i]);
    end;
   Listit.add(';End Cursors');
   Listit.add(';Resource script ends.');
   s:=(s+'\GabeCurs.RC');
   If FileExists(s) then
    DeleteFile(s);
   Listit.SaveToFile(s);

   Listit.Clear;
   Delete(s,(length(s)-1),2);
   Listit.Add('@echo off');
   Listit.Add('del '+S+'RES');
   With Tregistry.create do
    begin
     Rootkey:=HKEY_LOCAL_MACHINE;
     If OpenKey('Software\Borland\Delphi\3.0',False) then
       Delph:=Readstring('RootDir');
     If OpenKey('Software\Borland\Delphi\4.0',False) then
       Delph:=Readstring('RootDir');
     If OpenKey('Software\Borland\Delphi\5.0',False) then
       Delph:=Readstring('RootDir');
     free;
    end;
   Delph:=GetShortFilename(Delph);
   Listit.Add(Delph+'\Bin\brcc32 -32 -v '+#32+(S+'RC'));
   Listit.SaveToFile(S+'BAT');

   EditorGCursors.list.assign(TheList);

   Listit.Free;
   TheList.free;
   ShellExecute(0, 'OPEN', PChar(S+'BAT'), '', '', SW_HIDE);
end;

{TGCursorsProperty}

procedure TGCursorsProperty.Edit;
var GCursorEditor: TGabeCursDlg;
begin
   GCursorEditor:= TGabeCursDlg.Create(Application);
   Gcursoreditor.editorgcursors:=(getcomponent(0) as TGabeCursLoad).GCursors;
   GCursoreditor.lstcursors.items.assign(Gcursoreditor.editorgcursors.List);
   IF GCursoreditor.lstcursors.items.count<>0 then
    begin
     GCursoreditor.edcursname.text:=
       Inttostr((strtoint(copy((GCursoreditor.lstcursors.
       items[GCursoreditor.lstcursors.items.count-1]),1,3)))+1);
    end
   else GCursoreditor.edcursname.text:='150';
   GCursorEditor.Showmodal;
   GCursorEditor.Release;
end;

function TGcursorsProperty.GetAttributes: TPropertyAttributes;
begin
   Result:= [paDialog];
end;

{TGabeCursLoadEditor}

procedure TGabeCursLoadEditor.EditProperty(PropertyEditor: TPropertyEditor;
   var Continue,FreeEditor: Boolean);
var PropName: String;
begin
   PropName:= PropertyEditor.GetName;
   if (CompareText(PropName, 'GCursors') = 0) then
    begin
     PropertyEditor.Edit;
     Continue:=false;
    end;
end;

function TGabeCursLoadEditor.GetVerbCount: Integer;
begin
   Result:=1;
end;

function TGabeCursLoadEditor.GetVerb(Index: Integer): string;
begin
   If Index=0 then
    Result:= 'Edit GCursors'
   Else Result:= '';
end;

procedure TGabeCursLoadEditor.ExecuteVerb(Index: Integer);
begin
   If Index=0 then Edit;
end;

{Register procedure}
procedure Register;
begin
   RegisterComponents('Gabes',[TGabeCursLoad,TGabeAVI,TGabeEdit,TGabeLabel,TGabeRich,
                     TGabeList,TGabeCombo,TGabeAnim,TGabeImage]);
   RegisterComponentEditor(TGabeCursLoad, TGabeCursLoadEditor);
   RegisterPropertyEditor(TypeInfo(TGCursors),TGabeCursLoad,'GCursors',TGCursorsProperty);
end;

end.


