unit GabeList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TOnMouseEnter = Procedure(Sender: TObject) of Object;
  TOnMouseLeave = Procedure(Sender: TObject) of Object;
  TGabeList = class(TListBox)
  private
    FOnMouseEnter: TOnMouseEnter;
    FOnMouseLeave: TOnMouseLeave;
    FCursDnHandle: Integer;
    FCursUpHandle: Integer;
    FCursDefHandle: Integer;
    FCursDisHandle: Integer;
    FCurson: Boolean;
    procedure SetCursHandle(Index: Integer;const Value: Integer);
    function  GetCursHandle(Index: Integer): Integer;
    procedure MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure CMMouseEnter(var msg:TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var msg: TMessage); message CM_MOUSELEAVE;
    procedure SetCurson(const Value: Boolean);
  protected
  public
    Constructor Create(AOwner: TComponent); override;
  published
    property CursDnHandle: Integer index 0 read GetCursHandle write SetCursHandle;
    property CursUpHandle: Integer index 1 read GetCursHandle write SetCursHandle;
    property CursDefHandle: Integer index 2 read GetCursHandle write SetCursHandle;
    property CursDisHandle: Integer index 3 read GetCursHandle write SetCursHandle;
    property Curson: boolean read FCurson write SetCurson default True;
    property OnMouseEnter: TOnMouseEnter read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TOnMouseLeave read FOnMouseLeave write FOnMouseLeave;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Gabes', [TGabeList]);
end;

procedure TGabeList.SetCursHandle(Index: Integer;const Value: Integer);
begin
   Case Index of
    0:If fcursdnhandle<>Value then FCursDnHandle := Value;
    1:If fcursuphandle<>Value then FCursUpHandle := Value;
    2:If fcursdefhandle<>Value then FCursDefHandle := Value;
    3:If fcursdishandle<>Value then FCursDisHandle := Value;
   end;
   Invalidate;
end;

function TGabeList.GetCursHandle(Index:Integer):integer;
begin
   Case Index of
    0:Result:=FCursDnHandle;
    1:Result:=FCursUpHandle;
    2:Result:=FCursDefHandle;
    3:Result:=FCursDisHandle;
   end;
end;

procedure TGabeList.MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   If enabled then
    begin
     Screen.Cursor := FCursDnHandle;
     Invalidate;
    end;
end;

procedure TGabeList.MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   If enabled then
    begin
     Screen.Cursor := FCursUpHandle;
     Invalidate;
    end;
end;

procedure TGabeList.CMMouseEnter(var msg: TMessage);
begin
   If Assigned(FOnMouseEnter) then
      FOnMouseEnter(Self);
   If fcurson then
      Screen.Cursor := FCursUpHandle
   else
      Screen.Cursor := FCursDisHandle;
end;


procedure TGabeList.CMMouseLeave(var msg: TMessage);
begin
   if Assigned(FOnMouseLeave) then
      FOnMouseLeave(Self);
   Screen.Cursor := FCursDefHandle;
end;

procedure TGabeList.SetCurson(const Value: Boolean);
begin
  IF FCurson<>Value then FCurson := Value;
end;

constructor TGabeList.Create(AOwner: TComponent);
begin
   Inherited Create(AOwner);
   FCurson:=true;
end;

end.
