unit Brett;

{$B-}

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
     Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Menus, Spin, ComCtrls, clipbrd,
     SchachProcs;

type

  TNewPositionEvent = procedure (Sender: TObject; Stellung : TSchachBrett; Zug : TZug; z : integer) of object;
  {z ist Zugnummer aus Aufbaufunktion, bei SetGrundst. ist sie 1}
  TMovetryEvent = procedure (Sender: TObject; var legal : Boolean) of object;
  TMovePartEvent = procedure (Sender: TObject; Teilfeld : byte; var Zugvorschlag : byte) of object;

  TFigurenset = (User, F16, F32, BookupF40,
   WinboardF21, WinboardF25, WinboardF29, WinboardF33, WinboardF37,
   WinboardF40, WinboardF45, WinboardF49, WinboardF54, WinboardF58,
   WinboardF64, WinboardF72, WinboardF80); {Parameter fr LadeHauptfigurensatz}

  TSchalter = class(TBitBtn)
    procedure Click;override;
  private
    Figur : shortint;
  end;

  Type TKnopf = class(TButton)
    procedure click; override;
  end;

  Type TAufbauPanel = class(TPanel) {Damit AufbauFigur auf Brett verschwindet bei Maus auf Panel}
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  end;

  Type TAufbauRadioButton = class(TRadioButton)
    procedure Click; override;
  end;

  Type TAufbauCheckBox = class(TCheckbox)
    procedure click; override;
  end;

  TBrett = class(TImage)
    constructor create(AOwner : TComponent);override;
    destructor destroy;override;
  private
    { Private-Deklarationen }
    Feld : array[0..63] of TRect;
    bewegteFigur : shortint;
    Hintergrund : TBitmap;
    AltX, AltY : Integer;
    AltRect: TRect;
    FS : TBitmap;
    FSAufbau : TBitmap;

    Woher : Byte; {Merken des Ausgangsfeldes bei Zugausfhrung mit Maus}
    dr : Boolean;  {Brett gedreht?}
    ani : boolean; {wird false bei Zugeingabe -> keine Animation}
    Zugvorschlag : Byte;
    rStellung : TSchachbrett;  {alte Stellung - bei BrettRefresh werden dann nur genderte Felder neu gezeichnet}

    FFRC : PFischerInfo;
    FFiguren : TFigurenset;
    FUserFiguren : String;
    FGroesse : shortint;
    FGrundstellung : Boolean;
    FZiehenmoeglich : boolean;
    FWhiteSquareColor : TColor;
    FBlackSquareColor : TColor;
    FWhiteSquarePattern : TBitmap;
    FBlackSquarePattern : TBitmap;
    FTon : Boolean;
    FEnglish : Boolean;
    FAnimation : byte;
    FZugVorschlagen : Boolean;
    FkeineZugpruefung : Boolean;  {true - Figuren knnen bel. versetzt werden}
    FAufbauFiguren : Boolean;     {true - fr Aufbaubrett wird der angepate 32x32-Set verwendet}
    FBlind : Boolean;
    FLockBoardUpdate : Boolean;  {Brett wird beim Setzen von Feldfarbe, Gre etc. nicht neu gezeichnet}

    FOnNewPosition: TNewPositionEvent;
    {damit Notationskomponente neue Position gemeldet werden kann (nach Aufbauen, Grundstellung, St.Manipul.}
    FOnMoveDone : TNotifyEvent;
    FOnMoveTry  : TMovetryEvent;
    FOnMovePart  : TMovePartEvent;

    BrStellung : PSchachbrett;
    BrZug : PZug;

    procedure SetFiguren(Wert : TFigurenset);
    procedure SetUserFiguren(Wert : string);
    procedure SetGroesse(Wert : shortint);
    procedure SetGrundstellung(Z : Boolean);
    procedure SetZiehenmoeglich(Z : boolean);
    procedure SetWhiteSquareColor (farbe : TColor);
    procedure SetBlackSquareColor (farbe : TColor);
    procedure SetWhiteSquarePattern (Muster : TBitmap);
    procedure SetBlackSquarePattern (Muster : TBitmap);
    procedure SetTon (Wert : Boolean);
    procedure SetEnglish (Wert : Boolean);
    procedure SetAnimation (Wert : byte);
    procedure SetZugVorschlagen (Wert : Boolean);
    procedure SetkeineZugpruefung (Wert : Boolean);

    procedure LadeFigurensatz(Dateiname : string);
    procedure LadeHauptfigurensatz (s : TFigurenset);
    procedure InitRects(Seitenlaenge : Byte);
    procedure SetzeFeld(Wo, Figur : shortint);
    procedure ZugVor;
    function  GetRect(f : integer) : TRect;
    procedure FeldZeichnen (i : byte);
    procedure ZeichneSprite(letzterOrt,neuerOrt : TRect; Figur : shortint);
    function  Umwandlung(Farbe : Shortint) : shortint;
    function  pruefe : Boolean;
    procedure BrettRefresh(alles : Boolean);
  protected
    { Protected-Deklarationen }
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MoveDone; virtual;
    function  MoveTry(von, nach : Byte; FiRochade : Boolean) : Boolean; virtual;
    function  MovePart(Teilfeld : Byte) : byte; virtual;
  public
    { Public-Deklarationen }
    property keineZugpruefung : boolean read FkeineZugpruefung write SetkeineZugpruefung;
    property FRC : PFischerInfo read FFRC write FFRC;
    property Blind : boolean read FBlind write FBlind;
    property LockBoardUpdate : Boolean read FLockBoardUpdate write FLockBoardUpdate;

    function  GetBrZug : TZug;
    function  GetBrStellung : TSchachbrett;
    procedure AddZug(Zug : TZug);
    procedure Zieh(v, n, u : integer; FiRochade : Boolean);
    procedure drehen;
    function  aufbauen(IgnoreIllegal : Boolean) : Boolean;
    function  manipuliereStellung(wie : Byte) : Boolean;
    procedure CopyPictureToClipboard;
    procedure CopyFENToClipboard;
    function  PasteFENFromClipboard : Boolean;
    procedure SetPosition(p : TSchachBrett; z : TZug);
    function  GetFigurenset : TBitmap;
    procedure SetFigurenset(b : TBitmap);
    procedure BoardRefresh;
    function  GetWhitePieces : integer;
    function  GetBlackPieces : integer;
  published
    { Published-Deklarationen }
    property AufbauFiguren : Boolean read FAufbauFiguren write FAufbauFiguren;
    property Figuren : TFigurenset read FFiguren write SetFiguren;
    property UserFiguren : string read FUserFiguren write SetUserFiguren;
    property Groesse : shortint read FGroesse write SetGroesse default 32;
    property Grundstellung : Boolean read FGrundstellung write SetGrundstellung;
    property Ziehenmoeglich : Boolean read FZiehenmoeglich write SetZiehenmoeglich;
    property WhiteSquareColor : TColor read FWhiteSquareColor write SetWhiteSquareColor default clWhite;
    property BlackSquareColor : TColor read FBlackSquareColor write SetBlackSquareColor default clSilver;
    property WhiteSquarePattern : TBitmap read FWhiteSquarePattern write SetWhiteSquarePattern stored true;
    property BlackSquarePattern : TBitmap read FBlackSquarePattern write SetBlackSquarePattern stored true;
    property Ton : Boolean read FTon write SetTon;
    property English : Boolean read FEnglish write SetEnglish;
    property Animation : byte read FAnimation write SetAnimation;
    property ZugVorschlagen : Boolean read FZugVorschlagen write SetZugVorschlagen;

    property OnNewPosition: TNewPositionEvent read FOnNewPosition write FOnNewPosition;
    property OnMoveDone: TNotifyEvent read FOnMoveDone write FOnMoveDone;
    property OnMoveTry : TMovetryEvent read FOnMoveTry write FOnMoveTry;
    property OnMovePart : TMovePartEvent read FOnMovePart write FOnMovePart;

    property Picture stored false; {damit Brettbild nicht an Exe angehngt wird}
    property Height stored false;
    property Width stored false;
  end;


implementation

uses Schachfiguren;

var
  UFigur : shortint;  {zur bergabe vom Umwandlunsfenster}

  AufbauFigur : shortint; {wenn<>0 dann fhren Mausereignisse Routinen zum Aufbauen aus}
  neueWahl : boolean;{neue Figur gewhlt - MouseMove init. Hintergrund usw. wenn Zeiger aufs Brett kommt - wird dann false}
  keineClickProz : Boolean;


procedure TBrett.LadeHauptfigurensatz (s : TFigurenset);
var p, s1, i, j : integer;

begin
 case s of
   F16 : s1 := 16;
   F32 : s1 := 32;
   BookupF40 : s1 := 40;
   WinboardF21 : s1 := 21;
   WinboardF25 : s1 := 25;
   WinboardF29 : s1 := 29;
   WinboardF33 : s1 := 33;
   WinboardF37 : s1 := 37;
   WinboardF40 : s1 := 40;
   WinboardF45 : s1 := 45;
   WinboardF49 : s1 := 49;
   WinboardF54 : s1 := 54;
   WinboardF58 : s1 := 58;
   WinboardF64 : s1 := 64;
   WinboardF72 : s1 := 72;
   WinboardF80 : s1 := 80;
   else begin s1 := 32; s := F32; end;
 end;
 screen.cursor:=crHourglass;
 try
  FS.height:=2*s1;
  FS.width:=12*s1;
  p:=0;
  For i:=0 to 12*s1 -1 do begin
    FS.canvas.pen.color := clBlack;
    j:=0;
    repeat
      inc(p);
      if FS.canvas.pen.color=clWhite then begin
        FS.canvas.pen.color := clBlack;
      end
      else begin
        FS.canvas.pen.color := clWhite;
      end;
      case s of
        F32 : begin
                FS.canvas.MoveTo(i, j);
                FS.canvas.LineTo(i, j+Figuren32[p]);
                j:=j+figuren32[p];
             end;
  BookupF40 : begin
                FS.canvas.MoveTo(i, j);
                FS.canvas.LineTo(i, j+Figuren40[p]);
                j:=j+Figuren40[p];
             end;
        F16 : begin
                FS.canvas.MoveTo(i, j);
                FS.canvas.LineTo(i, j+Figuren16[p]);
                j:=j+Figuren16[p];
             end;
WinboardF21: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren21[p]);
               j:=j+WbFiguren21[p];
             end;
WinboardF25: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren25[p]);
               j:=j+WbFiguren25[p];
             end;
WinboardF29: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren29[p]);
               j:=j+WbFiguren29[p];
             end;
WinboardF33: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren33[p]);
               j:=j+WbFiguren33[p];
             end;
WinboardF37: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren37[p]);
               j:=j+WbFiguren37[p];
             end;
WinboardF40: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren40[p]);
               j:=j+WbFiguren40[p];
             end;
WinboardF45: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren45[p]);
               j:=j+WbFiguren45[p];
             end;
WinboardF49: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren49[p]);
               j:=j+WbFiguren49[p];
             end;
WinboardF54: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren54[p]);
               j:=j+WbFiguren54[p];
             end;
WinboardF58: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren58[p]);
               j:=j+WbFiguren58[p];
             end;
WinboardF64: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren64[p]);
               j:=j+WbFiguren64[p];
             end;
WinboardF72: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren72[p]);
               j:=j+WbFiguren72[p];
             end;
WinboardF80: begin
               FS.canvas.MoveTo(i, j);
               FS.canvas.LineTo(i, j+WbFiguren80[p]);
               j:=j+WbFiguren80[p];
             end;
      end;
    until j>=2*s1;
  end;
 finally
  screen.cursor:=crDefault;
 end;
end;

procedure TBrett.LadeFigurenSatz (Dateiname : String);
Var
    Temp : TBitmap;
    Seite : word;
begin
  if FileExists(Dateiname) then begin
    Temp:=TBitmap.Create;
    try
      try
        Temp.LoadFromFile(Dateiname);
      except
        MessageDlg('Bitmap konnte nicht geladen werden.',mtError,[mbOk],0);
        exit;
      end;
      seite:=trunc(temp.height/2);
      if (seite<10) or (seite>100) or (seite*12>temp.width) then begin
        MessageDlg('Ungltige Mae der Bitmap.',mtError,[mbOk],0);
        exit;
      end;
 {     FS.Assign(Temp);}
      fs.LoadFromFile(Dateiname);
    finally
      Temp.free;
    end;
  end
  else MessageDlg('Datei wurde nicht gefunden.',mtError,[mbOk],0);
end;


Procedure TSchalter.Click;
Var i : byte;
begin
  if aufbauFigur<>0 then begin
    AufbauFigur:=Figur;
    if neueWahl=false then begin
      for i:=0 to Owner.ComponentCount-1 do begin  {Damit Figurenrest verschwindet, falls beim Aufbauen Brett verlassen wurde}
        if Owner.Components[i] is TBrett then begin
          TBrett(Owner.Components[i]).Canvas.CopyMode:=SrcCopy;
          TBrett(Owner.Components[i]).Canvas.CopyRect
            (TBrett(Owner.Components[i]).AltRect, TBrett(Owner.Components[i]).Hintergrund.Canvas,
            TBrett(Owner.Components[i]).Hintergrund.Canvas.ClipRect);
        end;
      end;
    end;
  end
  else begin
    if figur>6 then ufigur:=-(figur-6)
    else UFigur:=Figur;
  end;
  inherited Click;
end;

procedure TKnopf.Click;
Var i, j, feld : byte;
begin
  inherited Click;
  keineClickProz:=true;
  for i:=0 to Owner.ComponentCount-1 do begin
    if Owner.Components[i] is TBrett then begin
      case Tag of
       2 : begin
             for j:=0 to 63 do TBrett(Owner.Components[i]).rStellung[c(j)]:=-100; {damit auch neu gesetzte Fig. veschwinden}
             TBrett(Owner.Components[i]).Grundstellung:=false;
             for j:=0 to Owner.ComponentCount-1 do begin
               if Owner.Components[j] is TAufbauCheckBox then TAufbauCheckBox(Owner.Components[j]).checked:=false;
               if Owner.Components[j] is TKnopf then if TKnopf(Owner.Components[j]).Tag=1
               then TKnopf(Owner.Components[j]).enabled:=false;
             end;
             neueWahl:=true;
             keineClickProz:=false;
             exit;
           end;
       3 : begin
             for j:=0 to 63 do TBrett(Owner.Components[i]).rStellung[c(j)]:=-100; {damit auch neu gesetzte Fig. veschwinden}
             TBrett(Owner.Components[i]).Grundstellung:=true;
             for j:=0 to Owner.ComponentCount-1 do begin
               if Owner.Components[j] is TAufbauRadiobutton then
               if TAufbauRadiobutton(Owner.Components[j]).Tag=9 then TAufbauRadiobutton(Owner.Components[j]).checked:=true;
               if Owner.Components[j] is TAufbauCheckBox then TAufbauCheckBox(Owner.Components[j]).checked:=true;
               if Owner.Components[j] is TKnopf then if TKnopf(Owner.Components[j]).Tag=1
               then TKnopf(Owner.Components[j]).enabled:=true;
             end;
             neueWahl:=true;
             keineClickProz:=false;
             exit;
           end;
       1 : for j:=0 to Owner.ComponentCount-1 do begin
             if Owner.Components[j] is TAufbauCheckBox then begin
               case TAufbauCheckBox(Owner.Components[j]).Tag of
                 5 : if TAufbauCheckBox(Owner.Components[j]).checked then
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten+[wkr]
                     else TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                     TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten-[wkr];
                 6 : if TAufbauCheckBox(Owner.Components[j]).checked then
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten+[wlr]
                     else TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                     TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten-[wlr];
                 7 : if TAufbauCheckBox(Owner.Components[j]).checked then
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten+[skr]
                     else TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                     TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten-[skr];
                 8 : if TAufbauCheckBox(Owner.Components[j]).checked then
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                       TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten+[slr]
                     else TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten:=
                     TBrett(Owner.Components[i]).BrZug^.Rochademoeglichkeiten-[slr];
               end;
             end;
             if Owner.Components[j] is TAufbauRadioButton then
               if TAufbauRadioButton(Owner.Components[j]).Tag=9 then
                 if TAufbauRadioButton(Owner.Components[j]).Checked then
                   TBrett(Owner.Components[i]).BrZug^.amZug:=WEISS
                   else TBrett(Owner.Components[i]).BrZug^.amZug:=SCHWARZ;
             if Owner.Components[j] is TComboBox then begin
               TBrett(Owner.Components[i]).BrZug^.epFeld:=LEER;
               if (TComboBox(Owner.Components[j]).Text<>'') and
               (upcase(TComboBox(Owner.Components[j]).Text[1]) in ['A'..'H']) then begin
                 feld:=ord(upcase(TComboBox(Owner.Components[j]).Text[1]));
                 if TBrett(Owner.Components[i]).BrZug^.amZug=WEISS then begin
                   feld:=c(feld-25); {65 fr A auf 40 fr a6 usw. u. auf 10x12-Brett anpassen}
                   if (TBrett(Owner.Components[i]).BrStellung^[feld-10]=sB) and
                   (TBrett(Owner.Components[i]).BrStellung^[Feld+10]=LEER) and
                   (TBrett(Owner.Components[i]).BrStellung^[Feld]=LEER)
                      then TBrett(Owner.Components[i]).BrZug^.epFeld:=feld;
                 end {ep nur mglich, wenn dahinter auch kein Bauer auf Grundfeld steht-dann wre kein Doppelschritt zuvor ew.}
                 else begin
                   feld:=c(feld-49);  {65 fr A auf 16 fr a3 usw.}
                   if (TBrett(Owner.Components[i]).BrStellung^[feld+10]=wB) and
                   (TBrett(Owner.Components[i]).BrStellung^[Feld-10]=LEER) and
                   (TBrett(Owner.Components[i]).BrStellung^[Feld]=LEER)
                      then TBrett(Owner.Components[i]).BrZug^.epFeld:=feld;
                 end;
               end;
             end;
           end;
      end;
    end;
  end;
  keineClickProz:=false;
end;

procedure TAufbauPanel.MouseMove(Shift: TShiftState; X, Y: Integer);
Var i : byte;
begin
 if (neueWahl=false) then begin
  for i:=0 to Owner.ComponentCount-1 do begin  {Damit Figurenrest verschwindet, falls beim Aufbauen Brett verlassen wurde}
    if Owner.Components[i] is TBrett then begin
      TBrett(Owner.Components[i]).Canvas.CopyMode:=SrcCopy;
      TBrett(Owner.Components[i]).Canvas.CopyRect
        (TBrett(Owner.Components[i]).AltRect, TBrett(Owner.Components[i]).Hintergrund.Canvas,
        TBrett(Owner.Components[i]).Hintergrund.Canvas.ClipRect);
    end;
  end;
 end;
 inherited MouseMove(Shift, X, Y);
end;

procedure TAufbauRadioButton.Click;
Var i, j : byte;
begin
 if keineClickProz=false then begin
  for i:=0 to Owner.ComponentCount-1 do if Owner.Components[i] is TBrett then begin
    if Tag=9 then TBrett(Owner.Components[i]).BrZug^.amZug:=WEISS
    else TBrett(Owner.Components[i]).BrZug^.amZug:=SCHWARZ;
    for j:=0 to Owner.ComponentCount-1 do if Owner.Components[j] is TButton then
    if TButton(Owner.Components[j]).Tag=1 then
      TButton(Owner.Components[j]).enabled:=TBrett(Owner.Components[i]).pruefe
  end;
 end;
 inherited Click;
end;

procedure TAufbauCheckBox.click;
Var i : byte;
begin
 inherited click;
 if keineClickProz=false then begin
  for i:=0 to Owner.ComponentCount-1 do if Owner.Components[i] is TBrett then begin
    case Tag of
      5 : if (not(TBrett(Owner.Components[i]).BrStellung^[e1]=wk)) or
          (not(TBrett(Owner.Components[i]).BrStellung^[h1]=wT)) then checked:=false;
      6 : if (not(TBrett(Owner.Components[i]).BrStellung^[e1]=wk)) or
          (not(TBrett(Owner.Components[i]).BrStellung^[a1]=wT)) then checked:=false;
      7 : if (not(TBrett(Owner.Components[i]).BrStellung^[e8]=sk)) or
          (not(TBrett(Owner.Components[i]).BrStellung^[h8]=sT)) then checked:=false;
      8 : if (not(TBrett(Owner.Components[i]).BrStellung^[e8]=sk)) and
          (not(TBrett(Owner.Components[i]).BrStellung^[a8]=sT)) then checked:=false;
    end;
  end;
 end;
end;

{-----------------------------------------------------------------
   Methoden von TBrett
-----------------------------------------------------------------}
procedure TBrett.SetPosition(p : TSchachBrett; z : TZug);
begin
  BrStellung^ := p;
  BrZug^ := z;
  BrettRefresh(false);
end;

procedure TBrett.CopyFENToClipboard;
Var s : string;
    cs : PChar;
begin
  s := PosToFen(BrStellung^, BrZug^, 1, Nil);
  with ClipBoard do begin
    open;
    cs := stralloc(length(s) + 1);
    try
      StrCopy(cs, PChar(s));
      SetTextBuf(cs);
    finally
      StrDispose(cs);
      close;
    end;
  end;
end;

function TBrett.PasteFENFromClipboard;
Var cs : PChar;
    s : string;
    Dummy : word;
begin
  Result := false;
  if not ClipBoard.HasFormat(CF_TEXT) then exit;
  with Clipboard do begin
    open;
    cs := stralloc(100);
    try
      GetTextBuf(cs, 100);
      s := trim(StrPas(cs));
    finally
      strdispose(cs);
      close;
    end;
  end;
  if Pos('"', s) <> 0 then begin
    s := copy(s, Pos('"', s), length(s));
    if s <> '' then Delete(s, Length(s), 1);
  end;
  if FENToPos(s, BrStellung^, BrZug^, Dummy, Nil) then begin
    BrettRefresh(false);
    if Assigned(FOnNewPosition) then FOnNewPosition(Self, BrStellung^, BrZug^, 1);
    Result := true;
  end;
end;

procedure TBrett.CopyPictureToClipboard;
var
  Bmp: TBitmap;
  Stream: TStream;
  Data: THandle;
  Format: Word;
  Palette: HPalette;
  Buffer: Pointer;
begin
  Bmp := TBitmap.Create;
  try
    Bmp.Assign(Picture.Bitmap);
    Bmp.Canvas.Pen.Style := psSolid;
    Bmp.Canvas.Pen.Color := clBlack;
    Bmp.Canvas.Pen.Width := 1;
    Bmp.Canvas.brush.Style := bsClear;
    Bmp.Canvas.Rectangle(0, 0, width, Height);
    Stream := TMemoryStream.Create;
    try
      Bmp.SaveToStream(Stream);
      Palette := 0;
      with Clipboard do begin
        Open;
        try
          Clear;
          Bmp.SaveToClipboardFormat(Format, Data, Palette);
          SetClipboardData(Format, Data);
          if Palette <> 0 then SetClipboardData(CF_PALETTE, Palette);
          Data := GlobalAlloc(HeapAllocFlags, Stream.Size);
          try
            if Data <> 0 then begin
              Buffer := GlobalLock(Data);
              try
                Stream.Seek(0, 0);
                Stream.Read(Buffer^, Stream.Size);
                SetClipboardData(CF_BITMAP, Data);
              finally
                GlobalUnlock(Data);
              end;
            end;
          except
            GlobalFree(Data);
            raise;
          end;
        finally
          Close;
        end;
      end;
    finally
      Stream.Free;
    end;
  finally
    Bmp.Free;
  end;
end;


procedure TBrett.MoveDone;
begin
  if Assigned(FOnMoveDone) then FOnMoveDone(Self);
end;

function TBrett.Movetry(von, nach : Byte; FiRochade : Boolean) : Boolean;
const legal : Boolean = False;
var rettvon, rettnach, rettRoch : byte;
begin
  if keineZugpruefung then Movetry:=true else begin
    rettvon:=BrZug^.von; rettnach:=BrZug^.nach;
    rettRoch:=BrZug^.RochadeArt;
    BrZug^.von:=von; BrZug^.nach:=nach;
    if FiRochade then BrZug^.RochadeArt := KURZEFISCHERROCHADE  {darf nur nicht KEINEROCHADE sein}
    else BrZug^.RochadeArt := KEINEROCHADE;
    if Assigned(FOnMoveTry) then FOnMoveTry(Self, legal);
    BrZug^.von:=rettvon; BrZug^.nach:=rettnach;
    BrZug^.RochadeArt:=rettRoch;
    MoveTry:=Legal;
  end;
end;

function TBrett.MovePart(Teilfeld : Byte) : byte;
const zugvorschlag : byte = 0;
begin
  if Assigned(FOnMovePart) then FOnMovePart(Self, Teilfeld, zugvorschlag);
  MovePart:=zugvorschlag;
end;

function TBrett.GetBrZug : TZug;
begin
  Result := BrZug^;
end;

function TBrett.GetBrStellung : TSchachbrett;
begin
  Result := BrStellung^;
end;

procedure TBrett.ZugVor;

procedure Animiere;
Var deltaX, deltaY, abstandx, abstandy, zaehlerx, zaehlery, hx ,hy : integer;
    lOrt, nOrt : TRect;
    Fvon, Fnach : byte;

begin
  DeltaX := 0;
  DeltaY := 0;
  if dr then begin
    Fvon:=abs(cc(BrZug^.von)-63);
    Fnach:=abs(cc(BrZug^.nach)-63);
  end
  else begin
    Fvon:=cc(BrZug^.von);
    Fnach:=cc(BrZug^.nach);
  end;
  hy:= Feld[Fvon].top - Feld[Fnach].top;
  hx:= Feld[Fvon].Right - Feld[Fnach].Right;
  abstandy:=abs(hy);
  abstandx:=abs(hx);
  if hy=0 then begin
    DeltaY:=0;
    inc(abstandy);  {sonst ist bereits Schleifenabbruchbedingung erfllt}
    if hx<0 then DeltaX:=-4 else DeltaX:=4; {Horiz. Bew.}
  end;
  if hx=0 then begin
    DeltaX:=0;
    inc(abstandx);
    if hy<0 then DeltaY:=-4 else DeltaY:=4; {Vert. Bew.}
  end;
  if (hx<>0) and (hy<>0) then begin
    if hy<0 then DeltaY:=-4 else DeltaY:=4;  {Diag. Bew.}
    if hx<0 then DeltaX:=-4 else DeltaX:=4;
    if abs(hx)<abs(hy) then begin
      if hx<0 then DeltaX:=-2 else DeltaX:=2;  {Springer}
      inc(abstandx);
    end;
    if abs(hx)>abs(hy) then begin
      if hy<0 then DeltaY:=-2 else DeltaY:=2;  {Springer}
      inc(abstandy);
    end;
  end;
  lOrt:=Feld[Fvon];
  nOrt:=Feld[Fvon];
  zaehlerx:=0;
  zaehlery:=0;
  Hintergrund.Canvas.CopyRect(Hintergrund.Canvas.Cliprect, Canvas, lOrt);
  enabled:=false;
  while (not(zaehlerx>=abstandx)) and (not(zaehlery>=abstandy)) do begin
    zaehlerx:=zaehlerx+abs(deltaX);
    zaehlery:=zaehlery+abs(deltaY);
    if (not(zaehlerx>=abstandx)) and (not(zaehlery>=abstandy)) then begin
      nOrt.Top:=nOrt.Top-DeltaY;
      nOrt.Bottom:=nOrt.Bottom-DeltaY;
      nOrt.Left:=nOrt.Left-DeltaX;
      nOrt.Right:=nOrt.Right-DeltaX;
      ZeichneSprite(lOrt,nOrt , BrStellung^[BrZug^.von]);
      lOrt:=nOrt;
    end;
    sleep(animation);
    Refresh;
  end;
  enabled:=true;
  Canvas.CopyMode:=SrcCopy;
  Canvas.CopyRect(lOrt, Hintergrund.Canvas, Hintergrund.Canvas.ClipRect);
  FeldZeichnen(cc(BrZug^.nach));
  SetzeFeld(cc(BrZug^.nach),BrStellung^[BrZug^.von]);
end;

begin
  FeldZeichnen(cc(BrZug^.von));  {INFO epFeld und Rochadem. werden nicht gerettet - das macht Notationskomp.}
  if (Animation<>0) and (ani) then animiere   {}
  else begin
    FeldZeichnen(cc(BrZug^.nach));
    SetzeFeld(cc(BrZug^.nach),BrStellung^[BrZug^.von]);
  end;
  BrStellung^[BrZug^.nach]:=BrStellung^[BrZug^.von];
  BrStellung^[BrZug^.von]:=0;
  if BrZug^.epSchlag<>LEER then begin
    FeldZeichnen(cc(BrZug^.epSchlag));
    BrStellung^[BrZug^.epSchlag]:=0;
  end;
  if BrZug^.RochadeArt<>KEINEROCHADE then begin
    if BrZug^.RochadeArt=KURZEROCHADE then begin
      if BrZug^.amZug=SCHWARZ then begin
        BrStellung^[h1]:=Leer;
        FeldZeichnen(cc(h1));
        BrStellung^[f1]:=wT;
        SetzeFeld(cc(f1),wT);
      end
      else begin
        BrStellung^[h8]:=Leer;
        FeldZeichnen(cc(h8));
        BrStellung^[f8]:=sT;
        SetzeFeld(cc(f8),sT);
      end;
    end
    else if BrZug^.RochadeArt=LANGEROCHADE then begin
      if BrZug^.amZug=SCHWARZ then begin
        BrStellung^[a1]:=Leer;
        FeldZeichnen(cc(a1));
        BrStellung^[d1]:=wT;
        SetzeFeld(cc(d1),wT);
      end
      else begin
        BrStellung^[a8]:=Leer;
        FeldZeichnen(cc(a8));
        BrStellung^[d8]:=sT;
        SetzeFeld(cc(d8),sT);
      end;
    end
    else if BrZug^.RochadeArt=KURZEFISCHERROCHADE then begin
      if not assigned(FRC) then exit;
      if BrZug^.amZug=SCHWARZ then begin
        BrStellung^[FRC^.FischerRightWhiteRook]:=LEER;
        FeldZeichnen(cc(FRC^.FischerRightWhiteRook));
      end
      else begin
        BrStellung^[FRC^.FischerRightBlackRook]:=LEER;
        FeldZeichnen(cc(FRC^.FischerRightBlackRook));
      end;
      BrStellung^[BrZug^.nach-1]:=-BrZug^.amZug*WT; { Auf F1/F8 weissen/schwarzen Turm setzen }
      SetzeFeld(cc(BrZug^.nach-1),-BrZug^.amZug*WT);
      BrStellung^[BrZug^.nach]:=-BrZug^.amZug*WK;   {knnte gelscht worden sein, wenn es dasselbe Feld wie Ausgang war}
      SetzeFeld(cc(BrZug^.nach),-BrZug^.amZug*WK);
    END
    else if BrZug^.RochadeArt=LANGEFISCHERROCHADE then BEGIN
      if not assigned(FRC) then exit;
      if BrZug^.amZug=SCHWARZ then begin
        BrStellung^[FRC^.FischerLeftWhiteRook]:=LEER;
        FeldZeichnen(cc(FRC^.FischerLeftWhiteRook));
      end
      else begin
        BrStellung^[FRC^.FischerLeftBlackRook]:=LEER;
        FeldZeichnen(cc(FRC^.FischerLeftBlackRook));
      end;
      BrStellung^[BrZug^.nach+1]:=-BrZug^.amZug*WT; { Auf F1/F8 weissen/schwarzen Turm setzen }
      SetzeFeld(cc(BrZug^.nach+1),-BrZug^.amZug*WT);
      BrStellung^[BrZug^.nach]:=-BrZug^.amZug*WK;   {knnte gelscht worden sein, wenn es dasselbe Feld wie Ausgang war}
      SetzeFeld(cc(BrZug^.nach),-BrZug^.amZug*WK);
    end;
  end;
  if BrZug^.UFigur<>LEER then begin
    BrStellung^[BrZug^.nach]:=BrZug^.UFigur;
    FeldZeichnen(cc(BrZug^.nach));
    SetzeFeld(cc(BrZug^.nach), BrZug^.UFigur);
  end;
  if Ton then MessageBeep(0);
  rStellung:=BrStellung^;
end;

procedure TBrett.AddZug(Zug : TZug);
begin
  BrZug^:=Zug;
  ZugVor;
end;

procedure TBrett.Zieh(v, n, u : integer; FiRochade : Boolean);
Var k : shortint;
begin
  BrZug^.von:=v;
  BrZug^.nach:=n;
  if BrStellung^[n]<>0 then BrZug^.GeschlFigur:=BrStellung^[n]
  else BrZug^.GeschlFigur:=Leer;
  BrZug^.attr1:=Leer;
  BrZug^.attr2:=Leer;
  BrZug^.epSchlag:=Leer;
  BrZug^.epFeld:=Leer;
  BrZug^.UFigur:=Leer;
  BrZug^.RochadeArt:=Leer;
  UFigur:=Leer;  {Schnittstelle zum Umwandlungsfenster}
  case BrStellung^[v] of
    wK : begin
           if (assigned(FRC)) and (FiRochade)
             then k := FRC^.FischerWhiteKing
           else k := e1;
           if (v = k) then begin  {wK - Rochade prfen}
             case n of
               g1 : if FiRochade then BrZug^.RochadeArt:=KURZEFISCHERROCHADE
                    else BrZug^.RochadeArt:=KURZEROCHADE;
               c1 : if FiRochade then BrZug^.RochadeArt:=LANGEFISCHERROCHADE
                    else BrZug^.RochadeArt:=LANGEROCHADE;
             end;
           end;
           BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WlR, WkR]; {W keine Rochade mehr}
         end;
    sK : begin
           if (assigned(FRC)) and (FiRochade)
             then k := FRC^.FischerBlackKing
           else k := e8;
           if (v = k) then begin  {wK - Rochade prfen}
             case n of
               g8 : if FiRochade then BrZug^.RochadeArt:=KURZEFISCHERROCHADE
                    else BrZug^.RochadeArt:=KURZEROCHADE;
               c8 : if FiRochade then BrZug^.RochadeArt:=LANGEFISCHERROCHADE
                    else BrZug^.RochadeArt:=LANGEROCHADE;
             end;
           end;
           BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[SlR, SkR]; {keine S Rochade mehr}
         end;
    wT : begin
           if assigned(FRC) then begin
             if v=FRC^.FischerRightWhiteRook then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WkR];
             if v=FRC^.FischerLeftWhiteRook then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WlR];
           end
           else begin
             if v=h1 then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WkR];
             if v=a1 then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WlR];
           end;
         end;
    sT : begin
           if assigned(FRC) then begin
             if v=FRC^.FischerRightBlackRook then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WkR];
             if v=FRC^.FischerLeftBlackRook then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[WlR];
           end
           else begin
             if v=h8 then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[SkR];
             if v=a8 then BrZug^.Rochademoeglichkeiten:=BrZug^.Rochademoeglichkeiten-[SlR];
           end;
         end;
    sB : begin {sB}
           if (cc(v)-cc(n)=16) then BrZug^.epFeld:=c(cc(n)+8); {bei Doppelschritt knnte ein ep-Sclag mglich werden}
           if ((cc(v)-cc(n)=7) or (cc(v)-cc(n)=9)) and ((BrStellung^[n]=LEER)
           and (v>h3) and (v<a5)) then  {dann mu ep vorliegen}
             BrZug^.epSchlag:=c(cc(n)+8);
           if U = -1 then begin
             if cc(n)<cc(a2) then BrZug^.UFigur:= Umwandlung(Schwarz); {Umwandlung}
           end
           else BrZug^.UFigur:=U;
         end;
    wB : begin {wB}
           if (cc(n)-cc(v)=16) then BrZug^.epFeld:=c(cc(n)-8); {bei Doppelschritt knnte ein ep-Sclag mglich werden}
           if ((cc(n)-cc(v)=7) or (cc(n)-cc(v)=9)) and ((BrStellung^[n]=LEER)
           and (v>h4) and (v<a6)) then  {dann mu ep vorliegen}
             BrZug^.epSchlag:=c(cc(n)-8);
           if U = -1 then begin
             if cc(n)>cc(h7) then BrZug^.UFigur:=Umwandlung(Weiss); {Umwandlung}
           end
           else BrZug^.UFigur:=U;
         end;
  end;
  BrZug^.amZug:=-BrZug^.amZug;
  zugvor;
end;


procedure TBrett.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var legal, RettTon, FiRochade  : Boolean;
    i  : byte;
    AusgleichX, AusgleichY : word; {Mitte der gezogenen Figur - sonst huppt sie dahin, wo Mauszeiger ist}
    HintergrundRestaurieren : Boolean;
    hilf : byte;

begin
 inherited MouseUp(Button, Shift, X, Y);
 if (Button=mbLeft) and
 (((Ziehenmoeglich) and (BewegteFigur<>0) and (aufbauFigur=0)) or (ZugVorschlag<>0)) then begin
  if bewegteFigur=0 then begin
    AusgleichX:=x;
    AusgleichY:=y;
  end
  else begin
    AusgleichX:=AltRect.Left+trunc((AltRect.Right-AltRect.Left)/2);
    AusgleichY:=AltRect.Top+trunc((AltRect.Bottom-AltRect.Top)/2);
  end;
  i:=0;
  {i bis 64, um zu erkennen, wenn Mauzeiger auerhalb des Brettes war}
  while (i<64) and (not ((Feld[i].Top<=AusgleichY) and (Feld[i].Bottom>=AusgleichY)
    and (Feld[i].Left<=AusgleichX) and (Feld[i].Right>=AusgleichX))) do inc(i);
  if dr then i:=abs(i-63) ; { Anpassung wegen ev. Drehen notw.}

  HintergrundRestaurieren:=true;
  if (ZugVorschlag<>0) then begin
    FeldZeichnen(cc(Zugvorschlag));
    if BrStellung^[Zugvorschlag]<>0 then SetzeFeld(cc(Zugvorschlag), BrStellung^[Zugvorschlag]);
    if i=woher then begin
      if not (Shift = [ssCtrl]) then begin  {Fischer-Rochade - da kann das gleich sein}
        if BrStellung^[c(woher)]*BrZug^.amZug>0 then i:=cc(zugvorschlag)
        else woher:=cc(zugvorschlag);
      end;
      if bewegteFigur=0 then HintergrundRestaurieren:=false;
      bewegteFigur:=BrStellung^[c(woher)]; {anhand von bew.F. wird e.p. usw. untersucht}
    end
    else begin
      if (i < 64) and
      ((BrStellung^[c(i)]*BrZug^.amZug>0)
      and (not(BrStellung^[c(woher)]*BrZug^.amZug>0))) then begin  {sonst wurde eine weie Figur auf die andere gezogen}
        hilf:=woher;
        woher:=i;
        i:=hilf;
        if bewegteFigur=0 then HintergrundRestaurieren:=false;
        bewegteFigur:=BrStellung^[c(woher)];
      end;
      if bewegteFigur=0 then begin
        ZugVorschlag := 0;
        exit; {wenn bewF.=0 dann wurde Zielfeld angeklickt und Maus davon weggezoge->kein Zug, ansonsten
               wurde  Ausgangsfeldfigur bewegt->Zugprfung erforderlich}
      end;
    end;
  end;
  if HintergrundRestaurieren then begin
    Canvas.CopyMode:=SrcCopy;  {vorher wurde Figur bewegt bei ZV=0}
    Canvas.CopyRect(AltRect, Hintergrund.Canvas, Hintergrund.Canvas.ClipRect);
  end;
  if (ZugVorschlag<>0) then begin
    FeldZeichnen(cc(Zugvorschlag)); {Rechteck mu nochmal entfernt werden, da es vom gesicherten Hintergrund teilweise neu
    gezeichnet wird}
    if BrStellung^[Zugvorschlag]<>0 then SetzeFeld(cc(Zugvorschlag), BrStellung^[Zugvorschlag]);
  end;
  FiRochade := false;
  if assigned(FRC) then begin
    if (Shift = [ssCtrl]) and
    (
      ((BrZug^.amZug = WEISS) and (c(woher) = FRC^.FischerWhiteKing)) or
      ((BrZug^.amZug = SCHWARZ) and (c(woher) = FRC^.FischerBlackKing))
    ) and
    (BrStellung^[c(woher)] = BrZug^.amZug*wK)
      then FiRochade := true;
  end;

  ZugVorschlag := 0;
  Legal:=True;
  if (i>=64) or
  ((i=woher) and (not FiRochade)) or
  ((BrStellung^[c(i)]*BrZug^.amZug>0) and (not FiRochade))
  or (MoveTry(c(woher),c(i), FiRochade)=false) {Ereignisproz.} then legal:=false;
  if legal=False then begin
    SetzeFeld(Woher, BewegteFigur);
    BewegteFigur:=0;
    exit;
  end;
  RettTon:=Ton;
  Ton:=false;
  ani:=false;
  Zieh(c(Woher), c(i), -1, FiRochade);  { bei -1 (als UFigur) wird bei Bedarf eine Umwandlung erfragt}
  ani:=true;  {damit bei Zugeingabe nicht animiert wird}
  Ton:=RettTon;
  BewegteFigur:=0;
  if KeineZugpruefung=false then movedone;
 end;
end;

procedure TBrett.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:Integer);
var i, j, k : byte;
    p : Boolean;
begin
 inherited MouseDown(Button, Shift, X, Y);
 if ((Ziehenmoeglich) and (Button=mbLeft)) or (aufbauFigur<>0)  then begin {mbLeft weil rechter Mausbutton fr Kontextmenu
 benutzt wird}
  i:=0;
  while (i<63) and (not ((Feld[i].Top<=Y) and (Feld[i].Bottom>=Y)
    and (Feld[i].Left<=X) and (Feld[i].Right>=X))) do inc(i);
  if aufbauFigur<>0 then begin
    if Shift=[ssCtrl, ssRight] then begin
      if aufbaufigur>0 then begin
        if aufbaufigur>1 then dec(aufbaufigur) else aufbaufigur:=-6;
      end
      else if aufbaufigur<-1 then inc(aufbaufigur) else aufbaufigur:=6;
      ZeichneSprite(AltRect, AltRect, aufbauFigur);
      exit;
    end;
    Canvas.CopyMode:=SrcCopy;
    Canvas.CopyRect(AltRect, Hintergrund.Canvas, Hintergrund.Canvas.ClipRect);
    if Button=mbRight then aufbauFigur:=-aufbauFigur;  {bei rechter Maustaste andere Farbe als ausgewhlte setzen}
    if (BrStellung^[c(i)]<>aufbauFigur) and
    (not (Shift=[ssCtrl, ssLeft])) {bei Ctrl dazu - nur Feld lschen} then begin
      FeldZeichnen(i);
      SetzeFeld(i, aufbauFigur);
      BrStellung^[c(i)]:=aufbauFigur;
    end
    else begin
      FeldZeichnen(i);
      BrStellung^[c(i)]:=LEER;
    end;
    if Button=mbRight then aufbauFigur:=-aufbauFigur; {zurck}
    Hintergrund.Canvas.CopyRect(Hintergrund.Canvas.Cliprect, Canvas, AltRect);
    if tag = 0 then p:=pruefe { bei aufbauen(true) illegale Stellungen zulassen}
    else p := true;
    For j:=0 to Owner.ComponentCount-1 do begin
      if Owner.Components[j] is TKnopf then if TKnopf(Owner.Components[j]).Tag=1
      then TKnopf(Owner.Components[j]).enabled:=p;
    end;
    keineClickProz:=true;
    For j:=0 to Owner.ComponentCount-1 do if Owner.Components[j] is TAufbauCheckBox then begin
      case TAufbauCheckBox(Owner.Components[j]).Tag of
        5 : if (BrStellung^[e1]=wK) and (BrStellung^[h1]=wT) then
            TAufbauCheckBox(Owner.Components[j]).checked:=true else TAufbauCheckBox(Owner.Components[j]).checked:=false;
        6 : if (BrStellung^[e1]=wK) and (BrStellung^[a1]=wT) then
            TAufbauCheckBox(Owner.Components[j]).checked:=true else TAufbauCheckBox(Owner.Components[j]).checked:=false;
        7 : if (BrStellung^[e8]=sK) and (BrStellung^[h8]=sT) then
            TAufbauCheckBox(Owner.Components[j]).checked:=true else TAufbauCheckBox(Owner.Components[j]).checked:=false;
        8 : if (BrStellung^[e8]=sK) and (BrStellung^[a8]=sT) then
            TAufbauCheckBox(Owner.Components[j]).checked:=true else TAufbauCheckBox(Owner.Components[j]).checked:=false;
      end;
    end;
    keineClickProz:=false;
  end
  else begin
    j:=i;
    if dr then i:=abs(i-63) ; {wo nachher j statt i benutzt wird ist Anpassung wegen ev. Drehen notw. - j ist "gedreht"}
    zugvorschlag:=0;
    if (ZugVorschlagen) and (keineZugpruefung=false) then
      zugvorschlag:=MovePart(c(i));  {diese Routine ruft Ereignisproz. auf, falls es nicht zugewiesen ist, gibt sie FALSE
      zurck}
    if zugvorschlag<>0 then begin
      canvas.brush.style:=bsclear;
      canvas.pen.color:=clBlack;
      canvas.pen.style:=psSolid;
      canvas.pen.Width:=2;
      if dr then k:=abs(cc(zugvorschlag)-63) else k:=cc(zugvorschlag);
      canvas.rectangle(feld[k].left+1,feld[k].top+1,feld[k].right,feld[k].bottom);
    end;
    if ((BrStellung^[c(i)]<>Leer)or(Zugvorschlag<>0)) then begin
      Woher:=i;
      if (BrStellung^[c(i)]*BrZug^.amZug>0) or (keineZugpruefung) then begin {wird nur >0 wenn Figur von Seite am Zug gewhlt
      ist}
        AltX:=X; AltY:=Y;
        BewegteFigur:=BrStellung^[c(i)];
        FeldZeichnen(i);
        with AltRect do begin
          Top:=Feld[j].Top-2;
          Bottom:=Feld[j].Bottom-2;
          Left:=Feld[j].Left;
          Right:=Feld[j].Right;
        end;
        Hintergrund.Canvas.CopyRect(Hintergrund.Canvas.Cliprect, Canvas, AltRect);
        ZeichneSprite(AltRect, AltRect, BewegteFigur);
      end;
    end;
  end;
 end;
end;

procedure TBrett.MouseMove(Shift: TShiftState; X, Y: Integer);
Var NeuRect : TRect;
    DeltaX, DeltaY : Integer;

begin
  inherited MouseMove(Shift, X, Y);
  if aufbaufigur<>0 then  bewegteFigur:=AufbauFigur;
  if neueWahl then begin  {wird nur in Aufbaufunktion TRUE}
    AltX:=X; AltY:=Y;
    with AltRect do begin
      Top:=Y-(Groesse shr 1);          {!!!}
      Bottom:=Y+(Groesse shr 1);
      Left:=X-(Groesse shr 1);
      Right:=X+(Groesse shr 1);
    end;
    Hintergrund.Canvas.CopyRect(Hintergrund.Canvas.Cliprect, Canvas, AltRect);
    ZeichneSprite(AltRect, AltRect, BewegteFigur);
    neueWahl:=false;
  end
  else if bewegteFigur<>0 then begin
    DeltaX:=AltX-X;
    DeltaY:=AltY-Y;
    with NeuRect do begin
      Top:=AltRect.Top-DeltaY;
      Bottom:=AltRect.Bottom-DeltaY;
      Left:=AltRect.Left-DeltaX;
      Right:=AltRect.Right-DeltaX;
    end;
    ZeichneSprite(AltRect, NeuRect, BewegteFigur);
    AltX:=X;
    AltY:=Y;
    AltRect:=NeuRect;
  end;
end;

procedure TBrett.InitRects(Seitenlaenge : Byte);
Var i, x, y : integer;
begin
  y:=Seitenlaenge shl 3;
  for i:=0 to 63 do begin       {Initialisierung der Felder}
    if (i mod 8 = 0) then begin {nchste Horizontale...}
      x:=0;
      dec(y,Seitenlaenge);
    end;
    with Feld[i] do begin
      Left:= x; Top:= y;
      Bottom:= y+Seitenlaenge; Right:= x+Seitenlaenge;
    end;
    inc(x,Seitenlaenge);
  end;
end;

function TBrett.GetRect(f : integer) : TRect;
Var x, y : integer;
begin
  x := FS.Width div 12;
  y := FS.Height div 2;
  with Result do begin
    Top := y;
    Left := (F - 1) * x;
    Right := Left + x;
    Bottom :=  FS.Height;
  end;
end;

procedure TBrett.SetzeFeld(Wo, Figur : shortint);
Var r : TRect;
begin
  if dr then wo:=abs(wo-63);
  if Figur<0 then Figur:=abs(Figur)+6;  {Umrechnen von -6..-1 auf 7..12}
  if (Figur<1) or (Figur>12) then exit;  {drfte eigentlich nicht vorkommen}

  r := GetRect(Figur);
  Canvas.CopyMode:=SrcErase;
  Canvas.CopyRect(feld[Wo],FS.canvas,  r);
  r.Bottom := r.Top;
  r.Top := 0;
  Canvas.CopyMode:=SrcInvert;
  Canvas.CopyRect(feld[Wo],FS.canvas, r);

  if Blind then feldZeichnen(wo);
end;

procedure TBrett.FeldZeichnen (i : byte);
begin
  if dr then i:=abs(i-63);
  Canvas.CopyMode:=cmSrcCopy;
  Canvas.pen.style:=psClear;
  if Feldfarbe[i]=1 then begin
    Canvas.brush.color:=FBlackSquareColor;
    if FBlackSquarePattern.empty<>true then begin
      Canvas.brush.bitmap:=FBlackSquarePattern;
      Canvas.CopyRect(feld[i], FBlackSquarePattern.Canvas, FBlackSquarePattern.Canvas.Cliprect);
    end
    else Canvas.rectangle(feld[i].left,feld[i].top,feld[i].right+1,feld[i].bottom+1);
  end
  else begin
    Canvas.brush.color:=FWhiteSquareColor;
    if FWhiteSquarePattern.empty<>true then begin
      Canvas.brush.bitmap:=FWhiteSquarePattern;
      Canvas.CopyRect(feld[i], FWhiteSquarePattern.Canvas, FWhiteSquarePattern.Canvas.Cliprect);
    end
    else Canvas.rectangle(feld[i].left,feld[i].top,feld[i].right+1,feld[i].bottom+1);
  end;
end;

procedure TBrett.ZeichneSprite(letzterOrt,neuerOrt : TRect; Figur : shortint);
Var r : TRect;
begin
  if Figur<0 then Figur:=abs(Figur)+6;
  if (Figur<1) or (Figur>12) then exit;  {drfte eigentlich nicht vorkommen}
  Canvas.CopyMode:=SrcCopy;
  Canvas.CopyRect(letzterOrt, Hintergrund.Canvas, Hintergrund.Canvas.ClipRect);
  Hintergrund.Canvas.copyrect(Hintergrund.Canvas.Cliprect, Canvas, NeuerOrt);
  r := GetRect(Figur);
  Canvas.CopyMode:=SrcErase;
  Canvas.CopyRect(neuerOrt, FS.Canvas, r);
  r.Bottom := r.Top;
  r.Top := 0;
  Canvas.CopyMode:=SrcInvert;
  Canvas.CopyRect(neuerOrt, FS.Canvas, r);
end;

function TBrett.Umwandlung(Farbe : Shortint) : shortint;
var UFenster : TForm;
    Figuren : array[0..3] of TSchalter;
    i : Byte;
    P : TPoint;
    r : TRect;
    b : TBitmap;
    h : integer;
begin
  UFenster:=TForm.Create(self);
  b := TBitmap.Create;
 try
  h := FS.Height shr 1 + 5;
  P.Y:=(3*FGroesse)+trunc(FGroesse/2);  {damit UFenster in Brettmitte dargestellt wird}
  P.X:=2*FGroesse;
  P:=ClientToScreen(P);
  with UFenster do begin
    if P.X+Width>Screen.Width then P.X:=P.X-(P.X+Width-Screen.Width);
    if P.Y+Height>Screen.Height then P.Y:=P.Y-(P.Y+Height-Screen.Height);
    Top:=P.Y;
    Left:=P.X;
    Height:=h;
    Width:=h shl 2;
    BorderStyle:=BsNone;
  end;
  For i:=0 to 3 do begin
    Figuren[i]:=TSchalter.Create(self);
    with Figuren[i] do begin
      Top:=0;
      Height:=h;
      Left:=i*h;
      Width:=h;
      ModalResult:=mrOk;
      if Farbe=WEISS then Figur:=i+2 else Figur:=i+8;
      r := GetRect(Figur);
      r.Bottom := r.Top;
      r.Top := 0;
      b.width := FS.Height shr 1;
      b.Height := FS.Height shr 1;
      b.Canvas.CopyRect(b.Canvas.ClipRect, FS.Canvas, r);
      Glyph := b;
    end;
    UFenster.insertcontrol(Figuren[i]);
  end;
  UFenster.ActiveControl := Figuren[3];
  UFenster.showModal;
  umwandlung:=UFigur;
 finally
   UFenster.Free;
   b.Free;
 end;
end;

function TBrett.Pruefe : Boolean;
Var ii,wKo,wDa,wTu,wLa,wSp,wBa,sKo,sDa,sTu,sLa,sSp,sBa : byte;

function InSchach(wer, wo : Shortint) : Boolean;
const  LZ : array[1..4] of integer = (-9,-11,9,11);  { Laeufer Richtungen }
       TZ : array[1..4] of integer = (-1,10,1,-10);  { Turm               }
       SZ : array[1..8] of integer = (19,21,12,-8,-19,-21,-12,8);   { Springer           }
var    j,k, zaehler, Richtung : byte;

begin
  inSchach:=false;
  For k:=1 to 4 do begin
    j:=wo;
    if wer=wK then Richtung:=3 else Richtung:=1;
    zaehler:=0;
    repeat
      inc(Zaehler);
      inc(j, LZ[k]);
      if  (BrStellung^[j]=-(wer div 6)*wD) or (BrStellung^[j]=-(wer div 6)*wL) then InSchach:=True;
      if (zaehler=1) then begin
        if (BrStellung^[j]=-(wer div 6)*wK) then InSchach:=True;
        if (k=Richtung) or (k=Richtung+1) then if (BrStellung^[j]=-(wer div 6)*wB) then InSchach:=True;
      end;
    until BrStellung^[j]<>LEER;
  end;
  For k:=1 to 4 do begin
    j:=wo;
    zaehler:=0;
    repeat
      inc(Zaehler);
      inc(j, TZ[k]);
      if  (BrStellung^[j]=-(wer div 6)*wD) or (BrStellung^[j]=-(wer div 6)*wT) then InSchach:=True;
      if zaehler=1 then if (BrStellung^[j]=-(wer div 6)*wK) then InSchach:=True;
    until BrStellung^[j]<>LEER;
  end;
  For k:=1 to 8 do begin
    j:=wo;
    inc(j, SZ[k]);
    if  (BrStellung^[j]=-(wer div 6)*wS) then InSchach:=True;
  end;
end;

begin
  pruefe:=true;
  wKo:=0;sKo:=0;wDa:=0;sDa:=0;wTu:=0;sTu:=0;sLa:=0;wLa:=0;wSp:=0;sSp:=0;wBa:=0;sBa:=0;
  for ii:=0 to 63 do begin
    case Brstellung^[c(ii)] of
      wk :  begin
              inc(wKo);
              if BrZug^.amZug=SCHWARZ then if InSchach(wK,c(ii)) then pruefe:=false;
            end;
      wd :  inc(wDa);
      wt :  inc(wTu);
      wl :  inc(wLa);
      ws :  inc(wSp);
      wb :  begin
             inc(wBa);
             if (c(ii)>h7) or (c(ii)<a2) then pruefe:=false;
           end;
      sk :  begin
              inc(sKo);
              if BrZug^.amZug=WEISS then if InSchach(sK,c(ii))
                then pruefe:=false;
            end;
      sd :  inc(sDa);
      st :  inc(sTu);
      sl :  inc(sLa);
      ss :  inc(sSp);
      sb :  begin
             inc(sBa);
             if (c(ii)<a2) or (c(ii)>h7) then pruefe:=false;
           end;
    end;
  end;
  if (wKo<>1) or (sKo<>1) then pruefe:=false;
  if (wDa+wBa>9) or (wTu+wBa>10) or (wLa+wBa>10) or (wSp+wBa>10) then pruefe:=false;
  if (sDa+sBa>9) or (sTu+sBa>10) or (sLa+sBa>10) or (sSp+sBa>10) then pruefe:=false;
  if (wBa>8) or (sBa>8) then pruefe:=false;
  if (wKo+wDa+wTu+wLa+wSp+wBa>16) then pruefe:=false;
  if (sKo+sDa+sTu+sLa+sSp+sBa>16) then pruefe:=false;
end;

procedure TBrett.drehen;
begin
  dr:= not dr;
  BrettRefresh(true);
end;

function TBrett.aufbauen(IgnoreIllegal : Boolean)  : Boolean;
const Rochaden : array[0..3] of string[15] = (' Wei 0-0', ' Wei 0-0-0',' Schwarz 0-0',' Schwarz 0-0-0');
      RochadenEngl: array[0..3] of string[15] = (' White 0-0', ' White 0-0-0',' Black 0-0',' Black 0-0-0');
var A : TForm;
    B : TBrett;
    Figuren : array[1..12] of TSchalter;
    i : word;
    Pa : TAufbauPanel;
    P : TPanel;
    K1, K2, K3, K4 : TKnopf;
    Cb : array[0..3] of TCheckbox;
    R1, R2 : TAufbauRadioButton;
    G1, G2, G3 : TGroupBox;
    S : TSpinEdit;
    Co : TComboBox;
    L1, L2 : TPanel;
    ep : TStringlist;
    r : TRect;
    Bitmap : TBitmap;
    l : TLabel;
begin
  Result := false;
  A:=TForm.Create(self);
  Bitmap := TBitmap.Create;
 try
  with A do begin
    Font.Name:='MS Sans Serif';
    Font.Size:=8;
    Position:=PoScreenCenter;
    Height:=420;
    Width:=545;
    if English then Caption:='Setup position' else Caption:='Stellung eingeben';
    BorderStyle:=BsDialog;
  end;
  Pa:=TAufbauPanel.Create(self);
  Pa.Align:=alClient;
  Pa.BorderStyle:=bsNone;
  Pa.BorderWidth:=0;
  Pa.Bevelouter:=bvNone;
  Pa.Caption:='';
  A.insertControl(Pa);
  P:=TAufbauPanel.Create(self);
  with P do begin
    top:=13;
    left:=30;
    Height:=267;
    Width:=267;
    Bevelwidth:=2;
    Borderwidth:=2;
    BevelInner:=bvLowered;
  end;
  A.insertControl(P);
  b:=TBrett.Create(self);
  if Groesse = 32 then begin
    B.BlacksquarePattern.assign(BlacksquarePattern);
    B.WhitesquarePattern.assign(WhitesquarePattern);
  end;  
  b.Groesse:=32;
  if AufbauFiguren then b.Figuren := F32
  else b.FS.Assign(FS);
  b.top:=5;
  b.left:=5;
  A.insertcontrol(B);
  B.Parent:=P;
  B.cursor:=crNone;
  For i:=5 downto 0 do begin
    Figuren[i+1]:=TSchalter.Create(self);
    with Figuren[i+1] do begin
      Top:=i*40+14+i*5;
      Height:=40;
      Left:=306;
      Width:=40;
      ModalResult:=mrNone;
      Figur:=i+1;
      r := b.GetRect(Figur);
      r.Bottom := r.Top;
      r.Top := 0;
      Bitmap.Width := 32;
      Bitmap.Height := 32;
      Bitmap.Canvas.CopyRect(Bitmap.Canvas.ClipRect, b.FS.Canvas, r);
      Glyph := Bitmap;
    end;
    A.insertcontrol(Figuren[i+1]);
  end;
  For i:=11 downto 6 do begin
    Figuren[i+1]:=TSchalter.Create(self);
    with Figuren[i+1] do begin
      Top:=(i-6)*40+14+(i-6)*5;
      Height:=40;
      Left:=348;
      Width:=40;
      ModalResult:=mrNone;
      Figur:=5-i; {schw. Figuren -1..-6}
      r := b.GetRect(i + 1);
      r.Bottom := r.Top;
      r.Top := 0;
      Bitmap.Width := 32;
      Bitmap.Height := 32;
      Bitmap.Canvas.CopyRect(Bitmap.Canvas.ClipRect, b.FS.Canvas, r);
      Glyph := Bitmap;
    end;
    A.insertcontrol(Figuren[i+1]);
  end;
  for i := 0 to 7 do begin
    l := TLabel.Create(self);
    l.Caption := IntToStr(i + 1);
    l.Top := 252 - (i * 32);
    l.Left := 18;
    Pa.insertcontrol(l);
  end;
  for i := 0 to 7 do begin
    l := TLabel.Create(self);
    l.Caption := Char(i + 65);
    l.left := 48 + (i * 32);
    l.Top := 281;
    Pa.insertcontrol(l);
  end;
  K1:=TKnopf.Create(self);
  K1.top:=360; K1.Left:=15; K1.Width:=115; K1.caption:='&Ok';
  K1.Modalresult:=mrOk;
  K1.Tag:=1;
  A.insertcontrol(K1);
  K2:=TKnopf.Create(self);
  K2.top:=360; K2.Left:=147;K2.Width:=115;
  if English then K2.Caption:='Clear &Board' else K2.caption:='&Brett leeren';
  K2.Tag:=2;
  A.insertcontrol(K2);
  K3:=TKnopf.Create(self);
  K3.top:=360; K3.Left:=279; K3.Width:=115;
  if English then K3.Caption:='&Reset' else K3.caption:='&Grundstellung';
  K3.Tag:=3;
  A.insertcontrol(K3);
  K4:=TKnopf.Create(self);
  K4.top:=360; K4.Left:=411; K4.Width:=115;
  if English then K4.Caption:='&Cancel' else K4.caption:='&Abbrechen';
  K4.Modalresult:=mrCancel;
  A.insertcontrol(K4);
  G1:=TgroupBox.Create(self);
  G1.Top:=15; G1.Left:=395;G1.Width:=130;G1.Caption:='Rochade';
  G1.Height:=145;
  A.insertcontrol(G1);
  G2:=TgroupBox.Create(self);
  G2.Top:=178; G2.Left:=395;G2.Width:=130; G2.Height:=90;
  if English then G2.Caption:='Who to move?' else G2.Caption:='Am Zug:';
  A.insertcontrol(G2);
  G3:=TgroupBox.Create(self);
  G3.Top:=299; G3.Left:=13;G3.Width:=512;G3.Caption:='';
  G3.Height:=52;
  A.insertcontrol(G3);
  for i:=0 to 3 do begin
    Cb[i]:=TAufbauCheckbox.create(Self);
    A.insertcontrol(Cb[i]);
    with Cb[i] do begin
      width:=110;
      tag:=i+5;
      parent:=G1;
      top:=25*i+25;
      left:=10;
      if English then Caption:=RochadenEngl[i] else caption:=Rochaden[i];
    end;
  end;
  R1:=TAufbauRadioButton.Create(Self);
  A.InsertControl(R1);
  R1.Tag:=9;
  R1.Parent:=G2;
  if English then R1.Caption:=' &White' else R1.Caption:=' &Wei';
  R1.Tag:=9;
  R1.Top:=25;
  R1.Left:=10;
  R2:=TAufbauRadioButton.Create(Self);
  A.InsertControl(R2);
  R2.Tag:=10;
  R2.Parent:=G2;
  if English then R2.Caption:=' B&lack' else R2.Caption:=' &Schwarz';
  R2.Tag:=10;
  R2.Top:=50;
  R2.Left:=10;
  S:=TSpinedit.Create(self);
  A.InsertControl(S);
  S.Top:=317; S.Left:=120; S.Width:=50;
  S.MinValue:=1;S.Text:='1';S.MaxValue:=1000;
  Co:=TComboBox.Create(self);
  A.InsertControl(Co);
  Co.Top:=317; Co.Left:=400; Co.Width:=50;
  ep:=TStringlist.Create;
  for i:=65 to 72 do ep.add(chr(i));
  Co.Items:=ep;
  Co.Maxlength:=1;
  L:=TLabel.Create(self);
  if English then L.Caption:='Move number:' else L.Caption:='Zugnummer :';
  L.Top:=20; L.Left:=25;
  G3.InsertControl(L);
  L:=TLabel.Create(self);
  G3.InsertControl(L);
  if English then L.Caption:='  E.p. on line:' else L.Caption:='E.p. auf Linie :';
  L.Top:=20; L.Left:=282;
  B.BrStellung^:=BrStellung^;
  B.BrZug^:=BrZug^;
  B.BrettRefresh(false);
  keineClickProz:=true;
  If BrZug^.amZug=WEISS then R1.Checked:=true else R2.Checked:=true;
  if wkr in BrZug^.Rochademoeglichkeiten then Cb[0].Checked:=true;
  if wlr in BrZug^.Rochademoeglichkeiten then Cb[1].Checked:=true;
  if skr in BrZug^.Rochademoeglichkeiten then Cb[2].Checked:=true;
  if slr in BrZug^.Rochademoeglichkeiten then Cb[3].Checked:=true;
  keineClickProz:=false;
  aufbauFigur:=wk;
  neueWahl:=true;
  if IgnoreIllegal then B.Tag := 1;  {MouseDown fhrt daraufhin keine Prfung auf legale Stellung durch}
  if A.showmodal=mrOk then begin
    Result := true;
    BrStellung^:=B.BrStellung^;
    BrZug^:=B.BrZug^;
    if Assigned(FOnNewPosition) then FOnNewPosition(Self, BrStellung^, BrZug^, S.Value);
    BrettRefresh(false);
  end;
 finally
  aufbauFigur:=0;
  neueWahl:=false;
  ep.Free;
  Bitmap.Free;
  A.free;
 end;
end;

procedure TBrett.BoardRefresh;
begin
  BrettRefresh(true);
end;

procedure TBrett.BrettRefresh(alles : Boolean);
var i : byte;
begin
  if FLockBoardUpdate then exit;
  for i:=0 to 63 do begin
    if (rStellung[c(i)]<>BrStellung^[c(i)]) or (alles) then begin
      FeldZeichnen(i);
      SetzeFeld(i,Brstellung^[c(i)]);
    end;
  end;
  rStellung:=BrStellung^;
end;

function TBrett.ManipuliereStellung ( wie : byte ) : Boolean;
const r=0; l=1; o=2; u=3;
      spiegel : array[0..63] of byte =(7,6,5,4,3,2,1,0,15,14,13,12,11,10,9,8,23,22,21,20,19,18,17,16,31,30,29,28,27,26,25,24,
                              39,38,37,36,35,34,33,32,47,46,45,44,43,42,41,40,55,54,53,52,51,50,49,48,63,62,61,60,59,58,57,56);
Var i : byte;
    rettSt, rettSt1 : TSchachbrett;

function frei (wo : byte) : boolean;
var i,summand,grenze : byte;
begin
  frei:=true;
  case wo of
    r : begin i:=7; summand:=8; grenze:=63 end;
    l : begin i:=0; summand:=8; grenze:=56 end;
    o : begin i:=56;summand:=1; grenze:=63 end;
    u : begin i:=0; summand:=1; grenze:=7  end;
  end;
  repeat
    if BrStellung^[c(i)]<>LEER then Frei:=false;
    inc(i, summand);
  until i>=grenze;
end;

begin
  ManipuliereStellung:=true;
  RettSt:=BrStellung^;
  for i:=0 to 63 do RettSt[c(i)]:=LEER;
  case wie of
    nach_rechts  : if Frei(r) then for i:=63 downto 0 do RettSt[c(i+1)]:=BrStellung^[c(i)]
                   else begin ManipuliereStellung:=false; exit; end;
    nach_links   : if Frei(l) then for i:=0 to 63 do RettSt[c(i-1)]:=BrStellung^[c(i)]
                   else begin ManipuliereStellung:=false; exit; end;
    nach_oben    : if Frei(o) then for i:=63 downto 0 do RettSt[c(i+8)]:=BrStellung^[c(i)]
                   else begin ManipuliereStellung:=false; exit; end;
    nach_unten   : if Frei(u) then for i:=0 to 63 do RettSt[c(i-8)]:=BrStellung^[c(i)]
                   else begin ManipuliereStellung:=false; exit; end;
    viertel_drehen:for i:=0 to 63 do RettSt[ c( (7-(i div 8)) + ((i mod 8) * 8) ) ]:=BrStellung^[c(i)];
    spiegeln_an_y:  for i:=0 to 63 do RettSt[ c(spiegel[i])]:=BrStellung^[c(i)];
  end;
  RettSt1:=BrStellung^;
  BrStellung^:=RettSt;
  if pruefe then begin
    BrZug^.epFeld:=LEER;
    BrZug^.Rochademoeglichkeiten:=[];
    if Assigned(FOnNewPosition) then FOnNewPosition(Self, BrStellung^, BrZug^, -1);
    {Ungltige Zugnummer bergeben, damit sie in dem Fall von TNotation nicht gendert wird}
    BrettRefresh(false);
  end
  else begin
    BrStellung^:=RettSt1;
    ManipuliereStellung:=false;
  end;
end;

function TBrett.GetFigurenset : TBitmap;
begin
  Result := FS;
end;

procedure TBrett.SetFigurenset(b : TBitmap);
begin
  FS.Assign(b);
end;

function  TBrett.GetWhitePieces : integer;
Var i : integer;
begin
  Result := 0;
  for i := 0 to 63 do if BrStellung[c(i)] > 0 then inc(Result);
end;

function  TBrett.GetBlackPieces : integer;
Var i : integer;
begin
  Result := 0;
  for i := 0 to 63 do if BrStellung[c(i)] < 0 then inc(Result);
end;

destructor TBrett.destroy;
begin
  try
    FBlackSquarePattern.free;
    FWhiteSquarePattern.free;
    Fs.Free;
    FsAufbau.Free;
    dispose(BrZug);
    dispose(BrStellung);
    Hintergrund.free;
  except
  end;
  inherited destroy;
end;

{procedure TBrett.loaded;
begin
  inherited loaded;
  BrettRefresh(true);
end;}

constructor TBrett.Create(AOwner : TComponent);
var m : integer;

begin
  inherited create (AOwner);
  FBlackSquarePattern := TBitmap.Create;
  FWhiteSquarePattern := TBitmap.Create;
  Fs:=TBitmap.create;
  FsAufbau:=TBitmap.create;

  keineZugpruefung:=false;
  FZiehenmoeglich:=true;
  FGrundstellung:=true;
  FWhiteSquareColor:=clWhite;
  FBlackSquareColor:=clSilver;
  FTon:=false;
  FEnglish:=false;
  FAufbauFiguren := false;
  New(BrZug);
  New(BrStellung);
  ani:=true;

  caption:='';
  FGroesse:=32;
  height:=256;
  width:=256;

  BewegteFigur:=0;
  Hintergrund:=TBitmap.Create;
  Hintergrund.height:=32;
  Hintergrund.width:=32;

  Canvas.Pen.Style:=psClear;
  InitRects(32);

  BrStellung^:=Ausgangsstellung;
  for m:=0 to 63 do rStellung[c(m)]:=-100;  {ungltige Werte, damit Brett das erste Mal gezeichnet wird}

  FUserFiguren := '';
  FFiguren := User;
  if csDesigning in ComponentState then Figuren := F32;
end;

procedure TBrett.SetFiguren(Wert : TFigurenset);
begin
  if (Wert <> User) and (Wert <> FFiguren) then begin
    LadeHauptFigurensatz(Wert);
    Brettrefresh(true);
    UserFiguren := '';
  end;
  FFiguren := Wert;
end;

procedure TBrett.SetUserFiguren(Wert : string);
begin
  if (Wert <> '') and (Wert <> FUserFiguren) then begin
    if not Fileexists(wert) then begin
      MessageDlg('File not found.', mtError, [mbOk], 0);
      exit;
    end;
    LadeFigurensatz(Wert);
    Brettrefresh(true);
    Figuren := User;
  end;
  FUserFiguren := Wert;
end;

procedure TBrett.SetGroesse(wert : shortint);
begin
  if (abs(Wert)<>FGroesse) and (abs(Wert)>9) and (abs(wert)<100) then begin
   { FS.Width := abs(wert) * 12;
    FS.Height := abs(wert) * 2;}
    Width:=abs(Wert) shl 3;
    Height:=abs(Wert) shl 3;
    Picture.Graphic.Height:=abs(Wert) shl 3;
    Picture.Graphic.Width:=abs(Wert) shl 3;
    Hintergrund.Width:=abs(Wert);
    Hintergrund.Height:=abs(Wert);
   { if wert > 0 then begin
      if Figuren <> User then LadeHauptFigurensatz(Figuren)
      else if UserFiguren <> '' then LadeFigurensatz(UserFiguren);
    end;}
    initRects(abs(Wert));
    BrettRefresh(true);
    FGroesse:=abs(Wert);
  end;
end;

procedure TBrett.SetGrundstellung(Z : Boolean);
var i : byte;
begin
  for i:=0 to 63 do begin
    if Z then BrStellung^[c(i)]:=Ausgangsstellung[c(i)]
    else BrStellung^[c(i)]:=Leer;
  end;
  with BrZug^ do begin  {wird Brett geleert, mssen diese Var. sowieso neu initial. werden}
    von:=0;nach:=0;UFigur:=0;
    epSchlag:=0;epFeld:=0;
    geschlFigur:=0;RochadeArt:=0;
    Rochademoeglichkeiten:=[nr,wkr,wlr,skr,slr];
    amZug:=Weiss;
    attr1:=0;
    attr2:=0;
  end;
  if Assigned(FOnNewPosition) then FOnNewPosition(Self, BrStellung^, BrZug^, 1);
  BrettRefresh(false);
  FGrundstellung:=Z;
end;

procedure TBrett.SetZiehenmoeglich(Z : boolean);
begin
  if Z<>FZiehenmoeglich then begin
    FZiehenmoeglich:=Z;
  end;
end;

procedure TBrett.SetWhiteSquareColor (farbe : TColor);
begin
  if FWhiteSquareColor<>farbe then begin
    FWhiteSquareColor:=farbe;
    BrettRefresh(true);
  end;
end;

procedure TBrett.SetBlackSquareColor (farbe : TColor);
begin
  if FBlackSquareColor<>farbe then begin
    FBlackSquareColor:=farbe;
    BrettRefresh(true);
  end;
end;

procedure TBrett.SetWhiteSquarePattern (Muster : TBitmap);
begin
 if Muster<>FWhiteSquarePattern then begin
  if Muster<>Nil then begin
    FWhiteSquarePattern.assign(Muster as TBitmap);
  end
  else begin
    try
      FWhiteSquarePattern.Free;
      FWhiteSquarePattern:=TBitmap.create;
    except
      Messagebeep(0);
    end;
  end;
  BrettRefresh(true);
 end;
end;

procedure TBrett.SetBlackSquarePattern (Muster : TBitmap);
begin
 if Muster<>FBlackSquarePattern then begin
  if Muster<>Nil then begin
    FBlackSquarePattern.assign(Muster as TBitmap);
  end
  else begin
    try
      FBlackSquarePattern.free;
      FBlackSquarePattern:=TBitmap.create;
    except
      Messagebeep(0);
    end;
  end;
  BrettRefresh(true);
 end;
end;

procedure TBrett.SetTon(Wert : Boolean);
begin
  if Wert<>Fton then FTon:=Wert;
end;

procedure TBrett.SetEnglish(Wert : Boolean);
begin
  if Wert<>FEnglish then FEnglish:=Wert;
end;

procedure TBrett.SetAnimation(Wert : byte);
begin
  if Wert<>FAnimation then Fanimation:=Wert;
end;

procedure TBrett.SetZugVorschlagen(Wert : Boolean);
begin
  if Wert<>FZugVorschlagen then FZugVorschlagen:=Wert;
end;

procedure TBrett.SetkeineZugpruefung(Wert : Boolean);
begin
  if Wert<>FkeineZugpruefung then FkeineZugpruefung:=Wert;
  if Wert then begin
    BrZug^.epFeld:=LEER;
    BrZug^.Rochademoeglichkeiten:=[];
  end;
end;



end.
