unit BrettWin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Brett, Notation, StdCtrls, MiniMax, PGN,
  SchachProcs, Buttons, Menus, ComCtrls, SyncObjs;

Const WM_ONSTOP = WM_USER + 6;

type
  TAnalyseThread = class(TThread)
  private
    aParent : TForm;
  protected
    procedure Execute; override;
    destructor destroy; override;
  public
    constructor Create(f : TForm);
  end;

  TMDIBrett = class(TForm)
    pButtonLeiste: TPanel;
    pBrett: TPanel;
    pNotation: TPanel;
    Splitter1: TSplitter;
    Notation1: TNotation;
    pBoard: TPanel;
    Brett1: TBrett;
    pNavigation: TPanel;
    pStatus: TPanel;
    pButtons: TPanel;
    sbReplace: TSpeedButton;
    puBrett: TPopupMenu;
    mAufbauen: TMenuItem;
    sbPrev: TSpeedButton;
    sbBack: TSpeedButton;
    sbAhead: TSpeedButton;
    sbNext: TSpeedButton;
    sbAnalyse: TSpeedButton;
    tbTiefe: TTrackBar;
    sbPlay: TSpeedButton;
    Memo1: TMemo;
    lTiefe: TLabel;
    sbSave: TSpeedButton;
    mDiaCopy: TMenuItem;
    puNotation: TPopupMenu;
    mPGNCopy1: TMenuItem;
    mPGNInsert: TMenuItem;
    mFENCopy: TMenuItem;
    mInsertFEN: TMenuItem;
    mDrehen: TMenuItem;
    mKoord: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    mFont: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N6: TMenuItem;
    N5: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Nichts1: TMenuItem;
    MiniMax1: TMiniMax;
    mMessages: TMenuItem;
    bPrev: TSpeedButton;
    bNext: TSpeedButton;
    bComment: TSpeedButton;
    bNew: TSpeedButton;
    mGameData: TSpeedButton;
    bUndo: TSpeedButton;
    bCut: TSpeedButton;
    bDelete: TSpeedButton;
    mAufwerten: TSpeedButton;
    lFRC: TLabel;
    Blind1: TMenuItem;
    MMCheck: TMiniMax;
    mPrint: TMenuItem;
    puMiniMax: TPopupMenu;
    mStop: TMenuItem;
    Splitter2: TSplitter;
    mFontComm: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure Brett1MoveDone(Sender: TObject);
    procedure Brett1MovePart(Sender: TObject; Teilfeld: Byte;
      var Zugvorschlag: Byte);
    procedure Brett1MoveTry(Sender: TObject; var legal: Boolean);
    procedure Brett1NewPosition(Sender: TObject; Stellung: TSchachbrett;
      Zug: TZug; z: Integer);
    procedure Notation1MoveChange(Sender: TObject; Zug: TZug;
      Stellung: TSchachbrett; NextMove: Boolean);
    procedure Notation13Repetition(Sender: TObject);
    procedure Notation150MovesRule(Sender: TObject);
    procedure sbReplaceClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mAufbauenClick(Sender: TObject);
    procedure Notation1Error(Sender: TObject; Fehlermeldung: String);
    procedure Notation1GameChanged(Sender: TObject);
    procedure sbPrevClick(Sender: TObject);
    procedure sbBackClick(Sender: TObject);
    procedure sbAheadClick(Sender: TObject);
    procedure sbNextClick(Sender: TObject);
    procedure MiniMax1Schach(Sender: TObject);
    procedure MiniMax1Stop(Sender: TObject; var Zug: PZug; Status: Byte);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure sbAnalyseClick(Sender: TObject);
    procedure sbPlayClick(Sender: TObject);
    procedure MiniMax1Trace(Sender: TObject; S: String);
    procedure tbTiefeChange(Sender: TObject);
    procedure sbSaveClick(Sender: TObject);
    procedure mDiaCopyClick(Sender: TObject);
    procedure mPGNCopy1Click(Sender: TObject);
    procedure mPGNInsertClick(Sender: TObject);
    procedure mInsertFENClick(Sender: TObject);
    procedure mFENCopyClick(Sender: TObject);
    procedure mKoordClick(Sender: TObject);
    procedure mFontClick(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure Nichts1Click(Sender: TObject);
    procedure mMessagesClick(Sender: TObject);
    procedure mDrehenClick(Sender: TObject);
    procedure bCommentClick(Sender: TObject);
    procedure bNewClick(Sender: TObject);
    procedure mGameDataClick(Sender: TObject);
    procedure bUndoClick(Sender: TObject);
    procedure bCutClick(Sender: TObject);
    procedure bDeleteClick(Sender: TObject);
    procedure mAufwertenClick(Sender: TObject);
    procedure bPrevClick(Sender: TObject);
    procedure bNextClick(Sender: TObject);
    procedure Blind1Click(Sender: TObject);
    procedure Notation1FischerInfo(Sender: TObject;
      FischerInfo: TFischerInfo);
    procedure mPrintClick(Sender: TObject);
    procedure mStopClick(Sender: TObject);
    procedure mFontCommClick(Sender: TObject);
  private
    koord : array[1..16] of TLabel;
    koord1 : array[1..16] of TLabel;
    iDiff : integer;
    NoDrawMessage, InLoop, FinishLoop, ForceMove : Boolean;
    rZug : TZug;
    rStatus : integer;
    slOpenDatabases : TStringlist;
    AnalyseThread : TAnalyseThread;
    UntilFlag : TEvent;
    procedure SetKoord(v : Boolean);
    procedure SetRect(g : integer);
    function  CheckOpenDatabases : Boolean;
    procedure SaveQuestion;
    procedure IniModul;
    procedure StopModul;
    procedure StopAnalyse;
    procedure DoStop(Var Msg : TMsg); message WM_ONSTOP;
    procedure DoPGNSave(Save : Boolean);
    procedure FischerQuestion;
  public
    PGN : TPGN;
    GameID : longint;
    FRC : PFischerInfo;
  end;

var
  MDIBrett: TMDIBrett;

implementation

uses Main, PGNSave, PGNWin, Comment, MoveCut, Riched;

{$R *.DFM}

procedure MsgWaitForSingleObject(Handle: THandle);
begin
  repeat
    if MsgWaitForMultipleObjects( 1, Handle, False,  INFINITE, QS_ALLINPUT)
    = WAIT_OBJECT_0 + 1
      then Application.ProcessMessages
      else BREAK;
  until True = False;
end;

Constructor TAnalyseThread.Create(f : TForm);
begin
  aParent := f;
  FreeOnTerminate := true;
  inherited Create(false);
end;

destructor TAnalyseThread.destroy;
Var f : TForm;
begin
  f := aParent;
  inherited destroy;
  (f as TMDIBrett).InLoop := false;
  (f as TMDIBrett).UntilFlag.SetEvent;
end;

procedure TAnalyseThread.Execute;
Var Tiefe : Integer;
begin
  with aParent as TMDIBrett do begin
    repeat
      FinishLoop := true;
      if sbPlay.Down then begin  {Spielmodus - weitere Zugeingaben abschalten}
        Tiefe := tbTiefe.Position;
        Brett1.ZiehenMoeglich := false;
        Notation1.Enabled := false;
        pNavigation.Enabled := false;
        mAufbauen.Enabled := false;
        mPGNInsert.Enabled := false;
        mInsertFEN.Enabled := false;
      end
      else Tiefe := Maximal;
      try
        MiniMax1.Start(Brett1.GetBrStellung, Brett1.GetBrZug, Tiefe);
      finally
        Brett1.ZiehenMoeglich := true;
        Notation1.Enabled := true;
        pNavigation.Enabled := true;
        mPGNInsert.Enabled := true;
        mAufbauen.Enabled := true;
        mInsertFEN.Enabled := true;
      end;
    until FinishLoop;
  end;
end;

procedure TMDIBrett.StopAnalyse;
begin
  if InLoop then begin
    if AnalyseThread.Suspended then AnalyseThread.Resume;
    MiniMax1.BreakLoop;
    MsgWaitForSingleObject(UntilFlag.Handle);
  end;
end;

procedure TMDIBrett.stopModul;
begin
  StopAnalyse;
  sbAnalyse.Down := false;
  Memo1.Visible := false;
  sbPlay.Down := false;
  tbTiefe.Visible := false;
  lTiefe.Visible := false;
  Memo1.Text := '';
end;

procedure TMDIBrett.IniModul;
begin
  if sbAnalyse.Down then begin
    if not InLoop then begin
      InLoop := True;
      UntilFlag.ResetEvent;
      AnalyseThread := TAnalyseThread.Create(self);
    end
    else begin
      FinishLoop := false;  {fhrt zur Wiederholung der Suchschleife}
      MiniMax1.BreakLoop;  {im Gegensatz zu TMiniMax.Stop := TRUE lst das kein OnStop-Ereignis aus}
    end;
  end;
end;

procedure TMDIBrett.DoStop(Var Msg : TMsg);
Const Gezogen : Boolean = TRUE;
begin
  try
    if (not sbPlay.Down) and (not ForceMove) then exit; {im Analysemodus kann Zug durch Leertaste gefordert werden}
    {wenn Mattstellung auf Brett ist, darf kein Zug ausgefhrt werden (status = matt);
     "mit_Matt" bedeutet, da bergebener Zug Matt setzt - darauf eigentlich Meldung}
    if ((rStatus = legaler_zug) or (rStatus = mit_Schach))
    or (rStatus = mit_Matt) or (rStatus = mit_Patt) then begin
      Gezogen := Notation1.AddZug(rZug);
      if Gezogen then begin
        Brett1.Ton := true;
        Brett1.AddZug(rZug); {nur Zug ausfhren, wenn kein Abbruch in einem ev. Variantenfenster gewhlt wurde}
       {Alternative: Brett1.Zieh(rZug^.von, rZug^.nach, rZug^.UFigur,
       (Zug.RochadeArt = KURZEFISCHERROCHADE) or (Zug.RochadeArt = LANGEFISCHERROCHADE)); (ohne FRC-Option kann hier immer FALSE bergeben werden)}
        Brett1.Ton := false;
        if rStatus = mit_Schach  {Es ist zustzlich das Ereignis OnSchach belegt. Das wird immer zu Beginn von Minimax ausgelst, wenn in bergebener Stellung Schach ist}
          then if sbPlay.Down then MessageBeep(MB_ICONEXCLAMATION);
      end;
    end;
    if (Gezogen) and ((rStatus = Matt) or (rStatus = mit_Matt))
      then Notation1.Matt; {mu Notation explizit mitgeteilt werden, damit das Mattkreuz geschrieben wird}
    Memo1.Text := '';
  finally
    ForceMove := false;
  end;
end;

procedure TMDIBrett.MiniMax1Stop(Sender: TObject; var Zug: PZug;
  Status: Byte);
begin
  rZug := Zug^;  {wird aus Thread heraus aufgerufen - deshalb nicht sofort auf Brett zeichnen}
  rStatus := Status;
  SendMessage(Handle, WM_ONSTOP, 0, 0);
end;

procedure TMDIBrett.sbPlayClick(Sender: TObject);
begin
  tbTiefe.Visible := sbPlay.Down;
  lTiefe.Visible := sbPlay.Down;
  if sbPlay.Down then begin
    StopAnalyse;
    Memo1.Text := '';
  end
  else IniModul;
end;

procedure TMDIBrett.FischerQuestion;
Var Zug : TZug;      {Aufbaufunktion von TBrett ist nicht an FRC angepat - deshalb dieser "Kopfstand"}
begin
  if not lFRC.Visible then exit;
  Zug := Brett1.GetBrZug;
  if MessageDlg('Handelt es sich bei der neuen Stellung um eine ' +
  'Fischer-Random-Chess-Ausgangsstellung?' + #13 +
  '(Wenn nicht, mssen alle Rochaderechte zurckgesetzt werden)',
  mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    SetFischerInfo(FRC, Brett1.GetBrStellung);
    Notation1FischerInfo(self, FRC^);
    Zug.Rochademoeglichkeiten := [wkr, wlr, skr, slr];
  end
  else begin
    Zug.Rochademoeglichkeiten := [];
  end;
  Brett1.SetPosition(Brett1.GetBrStellung, Zug);
  Notation1.NeueStellung(Brett1.GetBrStellung, Zug, Notation1.Partiedaten.Zugnummer);
end;

procedure TMDIBrett.DoPGNSave(Save : Boolean);
Var rPGN : TPGN;
    I : Integer;
begin
  with TfPGNSave.Create(self) do try
    with Notation1.Partiedaten.EventData do begin
      eWeiss.Text := Weiss;
      eSchwarz.Text := Schwarz;
      eQuelle.Text := quelle;
      eSite.Text := Ort;
      sewElo.Value := WElo;
      sesElo.Value := SElo;
      eKommentator.Text := Annotator;
      seJahr.Value := Jahr;
      seMonat.Value := Monat;
      seTag.Value := Tag;
      seRunde.Value := Runde;
      eEco.Text := Eco;
      if Ergebnis = '1-0' then rbGewinn.Checked:=true
      else if Ergebnis = '1/2-1/2' then rbRemis.Checked:=true
      else if Ergebnis = '0-1' then rbVerlust.Checked:=true
      else rbKeinErgebnis.Checked:=true;
      if Save then begin
        cbFileName.Items.Assign(slOpenDatabases);
        cbFileName.Visible := true;
        lFileName.Visible := true;
        cbFileName.Itemindex := cbFileName.Items.IndexOf(MainForm.SaveDataBase);
        bOk.Caption := 'Speichern';
      end;
      if ShowModal = mrOk then begin
        Weiss := eWeiss.Text;
        Schwarz := eSchwarz.Text;
        quelle := eQuelle.Text;
        Ort := eSite.Text;
        WElo := sewElo.Value;
        SElo := sesElo.Value;
        Annotator := eKommentator.Text;
        Eco := eEco.Text;
        Jahr := seJahr.Value;
        Monat := seMonat.Value;
        Tag := seTag.Value;
        Runde := seRunde.Value;
        if rbGewinn.Checked then Ergebnis := '1-0'
        else if rbRemis.Checked then Ergebnis := '1/2-1/2'
        else if rbVerlust.Checked then Ergebnis := '0-1'
        else Ergebnis := '*';
        Notation1.NotationRefresh; {wichtig - macht Notation nicht automatisch}
        if Save then begin
          rPGN := Nil;
          for I := MainForm.MDIChildCount - 1 downto 0 do
            if MainForm.MDIChildren[I] is TMDIPGN then
              if (MainForm.MDIChildren[I] as TMDIPGN).Caption =
              ListboxNameToDatabaseName(cbFileName.Text) then begin{vor Dialog schlieen wird auf Eintrag dort geprft}
                rPGN := (MainForm.MDIChildren[I] as TMDIPGN).PGN1;
                Break;
              end;
          if not assigned(rPGN) then begin
            MessageDlg(sSpeicherFehler, mtError, [mbOk], 0);
            exit;
          end;
          GameID := pgnAddGame;  {Anhngen, nicht Ersetzen}
          PGN := rPGN;           {Datenbank mglicherweise gewechselt}
          if not PGN.SaveGame(pgnAddGame, GameID, Notation1.GetGame)
            then MessageDlg(sSpeicherfehler, mtError, [mbOk], 0)
          else begin
            Notation1.geaendert := false;
            sbReplace.Enabled := false;
            bPrev.Enabled := True;
            bNext.Enabled := True;
            MainForm.SaveDataBase := cbFileName.Text;
          end;
        end
        else begin
          Notation1.geaendert := true;
          sbReplace.Enabled := true;
        end;
        self.Caption := Weiss + ' - ' + Schwarz;
      end;
    end;
  finally
    Free;
  end;
end;

procedure TMDIBrett.sbAnalyseClick(Sender: TObject);
begin
  Memo1.Visible := sbAnalyse.Down;
  sbPlay.Enabled := sbAnalyse.Down;
  if sbAnalyse.Down then IniModul
  else StopModul;
end;

function TMDIBrett.CheckOpenDatabases : Boolean;
Var I : Integer;
begin
  Result := false;
  slOpenDatabases.Clear;
  for I := MainForm.MDIChildCount - 1 downto 0 do
    if MainForm.MDIChildren[I] is TMDIPGN then
      slOpenDatabases.Add(DatabaseNameToListboxName(
        (MainForm.MDIChildren[I] as TMDIPGN).Caption));
  if slOpenDatabases.Count = 0 then begin
    {Da das ffnen groer PGN-Dateien lnger dauern kann, wird das hier nicht automatisch gemacht
     (die Funktion AppendGameToPGN ohne ffnen mit TPGN wie im Drag&Drop auf DatabaseWin geht hier nicht,
      da sie keine ID fr ein ev. wiederholtes Speichern zurckgibt)}
    MessageDlg('Bitte ffnen Sie zuerst eine Datenbank, in der diese Partie gespeichert werden soll.',
    mtInformation, [mbOk], 0);
    exit;
  end;
  Result := true;
end;

procedure TMDIBrett.SaveQuestion;
begin
  if not Notation1.Geaendert then exit;
  case MessageDlg(Caption + #13 + #13 + sSaveQuestion, mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
    mrCancel : Abort;
    mrYes    : if not CheckOpenDatabases then Abort
               else sbReplaceClick(self);
  end;
end;

procedure TMDIBrett.SetKoord(v : Boolean);
Var i : integer;
begin
  for i := 1 to 16 do begin
    koord[i].Visible := v;
    koord1[i].Visible := v;
    if i < 9 then begin
      koord[i].Visible := v;
      koord[i].top := iDiff shr 1
       - (koord[i].height shr 1) +
      (((i-1) * Brett1.Groesse) + Brett1.Groesse shr 1);
      koord[i].left := iDiff shr 2 - (koord[i].width shr 1);
    end
    else begin
      koord[i].top := Brett1.height + iDiff shr 1
      + iDiff shr 2 - (koord[i].height shr 1);
      koord[i].left := iDiff shr 1
       - (koord[i].width shr 1) +
      (((i-9) * Brett1.Groesse) + Brett1.Groesse shr 1);
    end;
    if i < 9 then begin
      koord1[i].top := iDiff shr 1
       - (koord1[i].height shr 1) +
      (((i-1) * Brett1.Groesse) + Brett1.Groesse shr 1);
      koord1[i].left := Brett1.width + iDiff shr 1 +
      iDiff shr 2 - (koord1[i].width shr 1);
    end
    else begin
      koord1[i].top := iDiff shr 2 - (koord1[i].height shr 1);
      koord1[i].left := iDiff shr 1
       - (koord1[i].width shr 1) +
      (((i-9) * Brett1.Groesse) + Brett1.Groesse shr 1);
    end;
  end;
end;

procedure TMDIBrett.SetRect(g : integer);
begin
  Brett1.Groesse := g;
  case g of
    16 : Brett1.Figuren := F16;
    21 : Brett1.Figuren := WinboardF21;
    25 : Brett1.Figuren := WinboardF25;
    29 : Brett1.Figuren := WinboardF29;
    33 : Brett1.Figuren := WinboardF33;
    37 : Brett1.Figuren := WinboardF37;
    40 : Brett1.Figuren := WinboardF40;
    45 : Brett1.Figuren := WinboardF45;
    49 : Brett1.Figuren := WinboardF49;
    54 : Brett1.Figuren := WinboardF54;
    58 : Brett1.Figuren := WinboardF58;
    64 : Brett1.Figuren := WinboardF64;
    72 : Brett1.Figuren := WinboardF72;
    80 : Brett1.Figuren := WinboardF80;
    else Brett1.Figuren := WinboardF40;
  end;
  pBoard.Height := (g shl 3) + iDiff;
  pBoard.Width := (g shl 3) + iDiff;
  pNavigation.Top := pBoard.Height + 2;
  pNavigation.Left := (pBoard.Width shr 1) - (pNavigation.Width shr 1);
  SetKoord(MainForm.KoordVisible);
end;

procedure TMDIBrett.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIBrett.FormCreate(Sender: TObject);
Var i : integer;

function smallfonts : boolean;
Var DC : HDC;
begin
  DC := GetDC(0);
  Result := (GetDeviceCaps(DC, LOGPIXELSX) = 96);
  ReleaseDC(0, DC);
end;

begin
  Left := 0;
  Top := 0;
  Brett1.SetFigurenset(Mainform.hBrett.GetFigurenset);  {geht schneller als das erneute Auspacken des Figurensatzes - property Figuren mu dazu auf USER}
  Brett1.BoardRefresh;
  for i := 1 to 16 do begin
    koord[i] := TLabel.Create(self);
    koord[i].Parent := pBoard;
    koord[i].Transparent := true;
    if i < 9 then koord[i].caption := Inttostr(abs(i - 9))
    else koord[i].caption := chr(i + 56);
    koord1[i] := TLabel.Create(self);
    koord1[i].Parent := pBoard;
    koord1[i].Transparent := true;
    if i < 9 then koord1[i].caption := Inttostr(abs(i - 9))
    else koord1[i].caption := chr(i + 56);
  end;
  idiff := pBoard.Bevelwidth shl 2 + pBoard.Borderwidth shl 1;
  {TBrett pat sich nicht an 'Groe Schriftarten' an (wegen unschner Streckung der Grafiken) -
   deshalb "Umgebung" anpassen}
  if not SmallFonts then begin
    Brett1.Left := pBoard.Bevelwidth shl 1 + pBoard.Borderwidth;
    Brett1.Top := pBoard.Bevelwidth  shl 1 + pBoard.Borderwidth;
    pBoard.Width := Brett1.Width + idiff;
    pBoard.Height := Brett1.Height + idiff;
  end;
  SetKoord(MainForm.KoordVisible);
  MiniMax1.NoCheckMessages := True;  {sonst wird innerhalb der Suchschleife auf Nachrichten abgefragt - ist bei Threads nicht ntig}
  slOpenDatabases := TStringlist.Create;
  Notation1.Font0Var := MainForm.FontDialog1.Font;
  Notation1.FontComment := MainForm.FontDialogComm.Font;
  {'Assign' nicht ntig, da das die Eigenschaftsmethode macht (auerdem die Zuweisung auf Fonts der 1. u. 2. Var. -
  es werden keine versch. Schriftarten zugelassen)
  Wichtig: In FontDialog mu fdNoSimulations TRUE sein, da Schriftstile, die nicht direkt untersttzt werden, zu Fehlern bei der Markierung fhren knnen}
  mKoord.Checked := MainForm.KoordVisible;
  New(FRC);
  if MainForm.mEnglish.Checked then Notation1.English := true;
  if not ChessFontInstalled then mPrint.Enabled := false;
  UntilFlag  := TEvent.Create(Nil, True, False, '');
end;

procedure TMDIBrett.FormDestroy(Sender: TObject);
Var i : integer;
begin
  for i := 1 to 16 do begin
    koord[i].free;
    koord1[i].free;
  end;
  slOpenDatabases.Free;
  Dispose(FRC);
  UntilFlag.Free;
end;

procedure TMDIBrett.Splitter1Moved(Sender: TObject);
Var i : integer;
begin
    i := abs(Splitter1.Left - iDiff) shr 3;
    if i >= 80 then SetRect(80)
    else if i >= 72 then SetRect(72)
    else if i >= 64 then SetRect(64)
    else if i >= 58 then SetRect(58)
    else if i >= 54 then SetRect(54)
    else if i >= 49 then SetRect(49)
    else if i >= 45 then SetRect(45)
    else if i >= 40 then SetRect(40)
    else if i >= 37 then SetRect(37)
    else if i >= 33 then SetRect(33)
    else if i >= 29 then SetRect(29)
    else if i >= 25 then SetRect(25)
    else if i >= 21 then SetRect(21)
    else SetRect(16);
end;

procedure TMDIBrett.Brett1MoveDone(Sender: TObject);
Var gezogen : Boolean;
begin
  gezogen := Notation1.AddZug(Brett1.GetBrZug);
  if gezogen then IniModul;         {bei Abbruch wird Thread von Movechange aufgerufen}
end;

procedure TMDIBrett.Brett1MovePart(Sender: TObject; Teilfeld: Byte;
  var Zugvorschlag: Byte);
begin
  Zugvorschlag := MMCheck.Vorschlag(Brett1.GetBrStellung, Brett1.GetBrZug, Teilfeld);
end;

procedure TMDIBrett.Brett1MoveTry(Sender: TObject; var legal: Boolean);
begin
  legal :=  MMCheck.IstZugLegal(Brett1.GetBrStellung, Brett1.GetBrZug);
end;

procedure TMDIBrett.Brett1NewPosition(Sender: TObject;
  Stellung: TSchachbrett; Zug: TZug; z: Integer);
begin
  Notation1.NeueStellung(Stellung, Zug, z); {z = erste Zugnummer}
  if not sbPlay.Down then IniModul;
end;

procedure TMDIBrett.Notation1MoveChange(Sender: TObject; Zug: TZug;
  Stellung: TSchachbrett; NextMove: Boolean);
begin
  if NextMove then   {Nur wegen eingestellter Zuganimation}
    Brett1.Zieh(Zug.von, Zug.nach, Zug.Ufigur,
    (Zug.RochadeArt = KURZEFISCHERROCHADE) or (Zug.RochadeArt = LANGEFISCHERROCHADE))
  else Brett1.SetPosition(Stellung, Zug);
  if not sbPlay.Down then IniModul;
end;

procedure TMDIBrett.Notation13Repetition(Sender: TObject);
begin
  if not NoDrawMessage then ShowMessage('3-fache Stellungswiederholung.');
end;

procedure TMDIBrett.Notation150MovesRule(Sender: TObject);
begin
  if not NoDrawMessage then ShowMessage('50-Zge-Regel.');
end;

procedure TMDIBrett.sbReplaceClick(Sender: TObject);
begin
  if MainForm.Working then exit;
  if not Notation1.Geaendert then exit;
  if assigned(PGN) then begin
    {bei ID = pgnAddGame = -1 wrde Partie automatisch an akt. Datenbank (PGN) angehngt u. gltige ID zurckgegeben}
    if PGN.ReplaceGame(GameID, Notation1.GetGame) then begin
      sbReplace.Enabled := false;
      Notation1.Geaendert := false;
    end
    else MessageDlg(sSpeicherFehler, mtError, [mbOk], 0);
  end
  else sbSaveClick(self);
end;

procedure TMDIBrett.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  keypreview := false;
  case key of
    37, 39, 38, 40, 33, 34, 35, 36 :   {Cursor/Bild - Tasten steuern Notation}
    begin
      SendMessage(Notation1.Handle, WM_KEYDOWN, key, 0);
      key := 0;
    end;
    32 : if InLoop then begin
           if not sbPlay.Down then FinishLoop := false;
           ForceMove := True;
           MiniMax1.Stop:=True;  {Leertaste stoppt oder startet Suchschleife}
         end
         else IniModul;
    27 : Close;     
  end;
  keypreview := true;
end;

procedure TMDIBrett.mAufbauenClick(Sender: TObject);
begin
  if Brett1.Aufbauen(false) then FischerQuestion;  {Aufbauen lst OnNewPosition aus, wo Notation akt. wird}
end;

procedure TMDIBrett.Notation1Error(Sender: TObject; Fehlermeldung: String);
begin
  MessageDlg(Fehlermeldung, mtError, [mbOk], 0);
end;

procedure TMDIBrett.Notation1GameChanged(Sender: TObject);
begin
  sbReplace.Enabled := true;
end;

procedure TMDIBrett.sbPrevClick(Sender: TObject);
begin
  Notation1.GoPreviousVar;
end;

procedure TMDIBrett.sbBackClick(Sender: TObject);
begin
  Notation1.GoBack;
end;

procedure TMDIBrett.sbAheadClick(Sender: TObject);
begin
  Notation1.GoAhead;
end;

procedure TMDIBrett.sbNextClick(Sender: TObject);
begin
  Notation1.GoNextVar;
end;

procedure TMDIBrett.MiniMax1Schach(Sender: TObject);
begin
  Messagebeep(MB_ICONEXCLAMATION);
end;

procedure TMDIBrett.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := false;
  if MainForm.Working then exit;
  SaveQuestion;
  StopAnalyse;
  CanClose := true;
end;

procedure TMDIBrett.MiniMax1Trace(Sender: TObject; S: String);
begin
  Memo1.Text := S;
end;

procedure TMDIBrett.tbTiefeChange(Sender: TObject);
begin
  lTiefe.Caption := 'T' + IntToStr(tbTiefe.Position);
end;

procedure TMDIBrett.sbSaveClick(Sender: TObject);
begin
  if MainForm.Working then exit;
  if not CheckOpenDatabases then exit;
  DoPGNSave(True);
end;

procedure TMDIBrett.mDiaCopyClick(Sender: TObject);
begin
  Brett1.CopyPictureToClipboard;
end;

procedure TMDIBrett.mPGNCopy1Click(Sender: TObject);
begin
  Notation1.CopyGameToClipboard;
end;

procedure TMDIBrett.mPGNInsertClick(Sender: TObject);
begin
  SaveQuestion;
  Notation1.PasteGameFromClipBoard; {IniModul in OnMoveChange}
  with Notation1.Partiedaten.EventData do
    Caption := Weiss + ' - ' + Schwarz;
end;

procedure TMDIBrett.mInsertFENClick(Sender: TObject);
begin
  SaveQuestion;
  Brett1.PasteFENFromClipboard; {IniModul in OnNewPosition}
  FischerQuestion;
end;

procedure TMDIBrett.mFENCopyClick(Sender: TObject);
begin
  Brett1.CopyFENToClipboard;
end;

procedure TMDIBrett.mKoordClick(Sender: TObject);
begin
  mKoord.Checked := not mKoord.Checked;
  MainForm.KoordVisible := mKoord.Checked;
  SetKoord(MainForm.KoordVisible);
end;

procedure TMDIBrett.mFontClick(Sender: TObject);
begin
  MainForm.FontDialog1.Font.Assign(Notation1.Font0Var);
  if MainForm.FontDialog1.Execute
    then Notation1.Font0Var := MainForm.FontDialog1.Font;
end;

procedure TMDIBrett.N6Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('!');
end;

procedure TMDIBrett.N5Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('?');
end;

procedure TMDIBrett.N7Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('!!');
end;

procedure TMDIBrett.N8Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('??');
end;

procedure TMDIBrett.N9Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('!?');
end;

procedure TMDIBrett.N10Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('?!');
end;

procedure TMDIBrett.Nichts1Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('');
end;

procedure TMDIBrett.mMessagesClick(Sender: TObject);
begin
  NoDrawMessage := not mMessages.Checked;
end;

procedure TMDIBrett.mDrehenClick(Sender: TObject);
Var i : Integer;
begin
  For i := 1 to 8 do begin
    koord[i].Caption := IntToStr(abs(StrToInt(koord[i].Caption) - 9));
    koord1[i].Caption := IntToStr(abs(StrToInt(koord1[i].Caption) - 9));
  end;
  For i := 9 to 16 do begin
    koord[i].Caption := Chr(abs(Ord(koord[i].Caption[1]) - 73) + 64);
    koord1[i].Caption := Chr(abs(Ord(koord1[i].Caption[1]) - 73) + 64);
  end;
  Brett1.Drehen;
  SetKoord(MainForm.KoordVisible);
end;

procedure TMDIBrett.bCommentClick(Sender: TObject);
begin
  with TKomm.Create(self) do try
    Memo1.Text := Notation1.GetKommentar;
    if ShowModal = mrOK
      then Notation1.SetKommentar(Memo1.Text);
  finally
    Free;
  end;
end;

procedure TMDIBrett.bNewClick(Sender: TObject);
begin
  SaveQuestion;
  Notation1.IniPartie;
  with Notation1.Partiedaten.EventData do
    Caption := Weiss + ' - ' + Schwarz;
  GameID := pgnAddGame; //.
  PGN := Nil;           //.
end;

procedure TMDIBrett.mGameDataClick(Sender: TObject);
begin
  DoPGNSave(false);
end;

procedure TMDIBrett.bUndoClick(Sender: TObject);
begin
  Notation1.UnDo;
end;

procedure TMDIBrett.bCutClick(Sender: TObject);
begin
  with TSchneide.Create(self) do try
    if ShowModal = mrOk then begin
      if rbVor.Checked then Notation1.schneide(true)
      else Notation1.schneide(false);
    end;
  finally
    Free;
  end;
end;

procedure TMDIBrett.bDeleteClick(Sender: TObject);
begin
  Notation1.loeschen;
end;

procedure TMDIBrett.mAufwertenClick(Sender: TObject);
begin
  Notation1.aufwerten;
end;

procedure TMDIBrett.bPrevClick(Sender: TObject);
Var i, ID : longint;
    s : String;
begin
  if not assigned(PGN) then exit;
  SaveQuestion;
  if PGN.Itemindex = -1 then begin
    if PGN.ItemsVisibleCount = 0 then exit
    else i := PGN.ItemsVisibleCount - 1;
  end
  else begin
    if PGN.Itemindex = 0 then begin
      MessageBeep(0);
      i := PGN.ItemsVisibleCount - 1;
    end
    else i := PGN.Itemindex - 1;
  end;
  PGN.Selected[PGN.Itemindex] := False;
  PGN.Selected[i] := true;
  PGN.Itemindex := i;
  s := PGN.GetGameAsString(PGN.ListeIndexToDatabaseIndex(i), ID);
  if s <> '' then begin
    Notation1.SetGame(s);
    with Notation1.Partiedaten.EventData do
      Caption := Weiss + ' - ' + Schwarz;
    GameID := ID;
  end;
end;

procedure TMDIBrett.bNextClick(Sender: TObject);
Var i, ID : longint;
    s : String;
begin
  if not assigned(PGN) then exit;
  SaveQuestion;
  if PGN.Itemindex = -1 then begin
    if PGN.ItemsVisibleCount = 0 then exit
    else i := 0;
  end
  else begin
    if PGN.Itemindex = PGN.ItemsVisibleCount - 1 then begin
      MessageBeep(0);
      i := 0;
    end
    else i := PGN.Itemindex + 1;
  end;
  PGN.Selected[PGN.Itemindex] := False;
  PGN.Selected[i] := true;
  PGN.Itemindex := i;
  s := PGN.GetGameAsString(PGN.ListeIndexToDatabaseIndex(i), ID);
  if s <> '' then begin
    Notation1.SetGame(s);
    with Notation1.Partiedaten.EventData do
      Caption := Weiss + ' - ' + Schwarz;
    GameID := ID;
  end;
end;

procedure TMDIBrett.Blind1Click(Sender: TObject);
begin
  Blind1.Checked := not Blind1.Checked;
  Brett1.Blind := Blind1.Checked;
  Brett1.BoardRefresh;
end;

procedure TMDIBrett.Notation1FischerInfo(Sender: TObject;
  FischerInfo: TFischerInfo);
begin
  if Fischerinfo.Enabled then begin  {wird aufgerufen, wenn Notation eine Fischer-R.-C. Partie geladen hat}
    FRC^ := Fischerinfo;
    Brett1.FRC := FRC;
    Notation1.FRC := FRC;
    MiniMax1.FRC := FRC;
    MMCheck.FRC := FRC;
    lFRC.Visible := true;
  end
  else begin
    Brett1.FRC := Nil;
    Notation1.FRC := Nil;
    MiniMax1.FRC := Nil;
    MMCheck.FRC := Nil;
    lFRC.Visible := false;
  end;
end;

procedure TMDIBrett.mPrintClick(Sender: TObject);
begin
  RicheditForm := TRicheditForm.Create(self);
  try
    with RicheditForm.Richedit1 do begin
      DefAttributes.Size := 12;
      ParaGraph.FirstIndent := 50;
      ParaGraph.RightIndent := 50;
    end;
    if Caption <> 'N.N. - N.N.' then  {noch keine Spieler eingetragen - N.N. von Notation init.}
      RicheditForm.Richedit1.Lines.Add(Caption);
    InsertDia(RicheditForm.Richedit1, Brett1.GetBrStellung);
    RicheditForm.Richedit1.Print(noReturn + noReturn);
  finally
    RicheditForm.Free;
  end;
end;

procedure TMDIBrett.mStopClick(Sender: TObject);
begin
  if mStop.Caption = 'Stop' then begin
    if not InLoop then exit;
    mStop.Caption := 'Weiter';
    pBrett.Enabled := false;
    Notation1.Enabled := false;
    pButtons.Enabled := false;
    AnalyseThread.Suspend;
    Memo1.WordWrap := false;
    Memo1.Lines.Insert(0, 'RECHTE MAUSTASTE ZUM WEITERRECHNEN');
  end
  else begin
    mStop.Caption := 'Stop';
    pBrett.Enabled := True;
    Notation1.Enabled := True;
    pButtons.Enabled := True;
    if not InLoop then exit;
    if Memo1.Lines.Count <> 0 then Memo1.Lines.Delete(0);
    Memo1.WordWrap := true;
    if AnalyseThread.Suspended then AnalyseThread.Resume;
  end
end;

procedure TMDIBrett.mFontCommClick(Sender: TObject);
begin
  MainForm.FontDialogComm.Font.Assign(Notation1.FontComment);
  if MainForm.FontDialogComm.Execute
    then Notation1.FontComment := MainForm.FontDialogComm.Font;
end;

end.
