unit DatabaseWin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SchachProcs;

type
  TMDIDatabase = class(TForm)
    lbDatabase: TListBox;
    procedure lbDatabaseDblClick(Sender: TObject);
    procedure lbDatabaseDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbDatabaseDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbDatabaseKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MDIDatabase: TMDIDatabase;

implementation

uses Main, PGN;

{$R *.DFM}

procedure TMDIDatabase.lbDatabaseDblClick(Sender: TObject);
begin
  MainForm.CreateMDIPGNChild(ListboxNameToDatabaseName(
    lbDatabase.Items[lbDatabase.ItemIndex]));
end;

procedure TMDIDatabase.lbDatabaseDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
Var p : TPoint;
begin
  p.x := X;
  p.y := Y;
  lbDatabase.Itemindex := lbDatabase.ItemAtPos(p, true);
  Accept := (Source is TPGN) and (lbDatabase.Itemindex <> -1);
end;

procedure TMDIDatabase.lbDatabaseDragDrop(Sender, Source: TObject; X,
  Y: Integer);
Var p : TPoint;
    i, Item, ID : integer;
    s, FileName, sGames : string;
begin
  if (Sender is TListbox) and (Source is TPGN) then begin
    p.x := X;
    p.y := Y;
    Item := lbDatabase.ItemAtPos(p, true);
    if Item = -1 then exit;
    FileName := ListboxNameToDatabaseName(lbDatabase.Items[Item]);
    if FileName = (Source as TPGN).PGNFile then exit;
    if (Source as TPGN).SelCount = 0 then exit;
    for I := MainForm.MDIChildCount - 1 downto 0 do
    if MainForm.MDIChildren[I].Caption = FileName then begin
      MessageDlg('Die Datenbank "' + FileName + '" ist bereits geffnet.',
      mtError, [mbOk], 0);
      exit;
    end;
    if MessageDlg('Markierte Partien werden an die Datei "' +
    FileName + '" angehngt.' + #13 + 'Fortfahren?', mtConfirmation, [mbYes, mbNo], 0) <> mrYes
      then exit; 
    Screen.Cursor := crHourGlass;
    enabled := false;
    ((Source as TPGN).Parent as TForm).Enabled := false;
    try
      MainForm.Abbrechen := false;
      i := 0;
      sGames := '';
      while i < (Source as TPGN).Items.Count do begin
        if (Source as TPGN).Selected[i] then begin
          s := (Source as TPGN).GetGameAsString(
          (Source as TPGN).ListeIndexToDatabaseIndex(i), ID);
          if s <> '' then begin
            sGames := sGames + #13#10#13#10 + s;
            Application.ProcessMessages;
            if MainForm.Abbrechen then Break;
          end;
        end;
        inc(i);
      end;
      if not AppendGameToPGN(FileName, sGames) {eine Funktion zum Partien an Datenbanken anzuhngen, die nicht zuvor mit TPGN geffnet wurden}
        then MessageDlg(sSpeicherfehler, mtError, [mbOk], 0);
    finally
      ((Source as TPGN).Parent as TForm).Enabled := true;
      enabled := true;
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TMDIDatabase.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MainForm.mHistory.Enabled := true;
  Action := caFree;
end;

procedure TMDIDatabase.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if MainForm.Working then CanClose := false;
end;

procedure TMDIDatabase.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 27 then Close;  
end;

procedure TMDIDatabase.lbDatabaseKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 13 then
    if lbDatabase.Itemindex <> -1 then lbDatabaseDblClick(self);
end;

end.
