unit PGNWin;

interface

uses Windows, Classes, Graphics, Forms, Controls, ComCtrls, StdCtrls, PGN,
     ExtCtrls, Buttons, SysUtils, Dialogs,
     SchachProcs, Spin, ShellApi, Notation, FileIntf, Brett;  { Diese Unit mu bei Verwendung einer der Schachkomponenten IMMER eingebunden werden}

type
  TMDIPGN = class(TForm)
    Panel1: TPanel;
    pFilter: TPanel;
    PGN1: TPGN;
    HeaderControl: THeaderControl;
    bFilter: TButton;
    Label17: TLabel;
    eSpieler: TEdit;
    rbWeiss: TRadioButton;
    rbSchwarz: TRadioButton;
    rbBeide: TRadioButton;
    Label19: TLabel;
    eEreignis: TEdit;
    cbZeitraum: TCheckBox;
    seAYear: TSpinEdit;
    seEYear: TSpinEdit;
    cbGewinn: TCheckBox;
    cbRemis: TCheckBox;
    cbVerlust: TCheckBox;
    bEmpty: TButton;
    Label1: TLabel;
    bPosition: TButton;
    cbPosition: TCheckBox;
    sbFilter: TSpeedButton;
    sbOpen: TSpeedButton;
    sbDeleteGame: TSpeedButton;
    sbDeleteDatabase: TSpeedButton;
    sbDragInsert: TSpeedButton;
    bPrint: TSpeedButton;
    hNotation: TNotation;
    SearchBrett: TBrett;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PGN1PGNTrace(Sender: TObject; Percent: Integer;
      var CancelMode: TCancelMode);
    procedure HeaderControlSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure PGN1FilterRequest(Sender: TObject; GameHeader: TEventData;
      var ShowThisGame: Boolean);
    procedure bFilterClick(Sender: TObject);
    procedure PGN1PGNDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; GameHeader: TEventData; GameIndex: Integer);
    procedure PGN1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sbFilterClick(Sender: TObject);
    procedure bEmptyClick(Sender: TObject);
    procedure sbOpenClick(Sender: TObject);
    procedure PGN1BeforeCreatePGNFile(Sender: TObject; FileName: String;
      var CreateNewPGNFile: Boolean);
    procedure bPositionClick(Sender: TObject);
    procedure sbDeleteGameClick(Sender: TObject);
    procedure sbDeleteDatabaseClick(Sender: TObject);
    procedure PGN1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PGN1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PGN1PGNDblClick(Sender: TObject; PGNGame: String;
      GameID: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bPrintClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HeaderControlSectionClick(HeaderControl: THeaderControl;
      Section: THeaderSection);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses Main, DatabaseWin, BrettWin, Riched;

{$R *.DFM}

procedure TMDIPGN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIPGN.PGN1PGNTrace(Sender: TObject; Percent: Integer;
  var CancelMode: TCancelMode);
begin  {wenn CancelMode auf cmCancel gesetzt wird, wird Vorgang abgebrochen (auer wenn's nicht mglich ist - dann ist CancelMode cmDenieded)}
  MainForm.DoTrace(Sender, Percent, CancelMode);
end;

procedure TMDIPGN.HeaderControlSectionResize(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
  PGN1.Refresh;
end;

procedure TMDIPGN.PGN1FilterRequest(Sender: TObject;
  GameHeader: TEventData; var ShowThisGame: Boolean);
Var ok, w, b, g, r, v : Boolean;
    s : string;
    tmpBrett, suchBrett : TSchachbrett;
    tmpZug : TZug;
    i, j : word;
begin
  if not sbFilter.down then exit;
  with GameHeader do begin
    ok := true;
    if eSpieler.Text <> '' then begin
      s := uppercase(eSpieler.Text);
      if Pos(s, uppercase(Weiss)) <> 0 then w := true else w := false;
      if Pos(s, uppercase(Schwarz)) <> 0 then b := true else b := false;
      if rbWeiss.Checked then ok := w
      else if rbSchwarz.Checked then ok := b
      else ok := w or b;
    end;
    if (ok) and (eEreignis.Text <> '') then
      ok := Pos(uppercase(eEreignis.Text), uppercase(Quelle)) <> 0;
    if (ok) and (cbZeitraum.Checked) then
      ok := (seAYear.Value <= Jahr) and (seEYear.Value >= Jahr);
    if ok then begin
      if (cbGewinn.Checked) or (cbRemis.Checked) or (cbVerlust.Checked) then begin
        if cbGewinn.Checked then g := Ergebnis = Gewinn else g := false;  {immer aus weier Sicht}
        if cbRemis.Checked then r := Ergebnis = Remis else r := false;
        if cbVerlust.Checked then v := Ergebnis = Verlust else v := false;
        ok := g or r or v;
      end;
    end;
    if (ok) and (cbPosition.Checked) then begin
      FENToPos(FENString, tmpBrett, tmpZug, i, Nil);
      suchBrett := SearchBrett.GetBrStellung;
      For i := 0 to 63 do begin
        j := c(i);  {Die Funktion c wandelt 0..63 in die Indexe der entsprechenden TSchachbrett-Felder um}
        if suchBrett[j] <> LEER
          then if suchBrett[j] <> tmpBrett[j] then begin
            ok := false;
            Break;
          end;
      end;
    end;
  end;
  if not ok then ShowThisGame := false;
end;

procedure TMDIPGN.bFilterClick(Sender: TObject);
begin
  Panel1.Enabled := false;
  try
    MainForm.Abbrechen := false;
    PGN1.Filtern;
  finally
    Panel1.Enabled := true;
  end;    
end;

procedure TMDIPGN.PGN1PGNDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; GameHeader: TEventData; GameIndex: Integer);
Var s : string;
begin   {Dieses Ereignis mu bei TPGN IMMER belegt werden}
  with (Control as TPGN).Canvas do begin
    FillRect(Rect);
    with GameHeader do begin
      Rect.Right := HeaderControl.Sections[0].Width;
      Font.Style := Font.Style - [fsBold];
      TextRect(Rect, Rect.Left + 5, Rect.Top, Format('%6d', [GameIndex + 1]));
      Rect.Left := Rect.Left + HeaderControl.Sections[0].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[1].Width;
      Font.Style := Font.Style + [fsBold];
      TextRect(Rect, Rect.Left, Rect.Top, Weiss + ' - ' + Schwarz);
      Rect.Left := Rect.Left + HeaderControl.Sections[1].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[2].Width;
      s := '';
      if (Quelle <> '') and (Quelle <> '?') then s := s + Quelle;
      if (Ort <> '') and (Ort <> '?') then begin
        if s <> '' then s := s + ', ';
        s := s + Ort;
      end;
      Font.Style := Font.Style - [fsBold];
      TextRect(Rect, Rect.Left, Rect.Top, s);
      Rect.Left := Rect.Left + HeaderControl.Sections[2].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[3].Width;
      if Jahr <> 0 then s := IntTostr(Jahr) else s := '';
      TextRect(Rect, Rect.Left, Rect.Top, s);
      Rect.Left := Rect.Left + HeaderControl.Sections[3].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[4].Width;
      Font.Style := Font.Style + [fsBold];
      TextRect(Rect, Rect.Left, Rect.Top, Ergebnis);
    end;
  end;
end;

procedure TMDIPGN.PGN1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 46 then sbDeleteGameClick(self);
end;

procedure TMDIPGN.sbFilterClick(Sender: TObject);
begin
  pFilter.Visible := sbFilter.Down;
end;

procedure TMDIPGN.bEmptyClick(Sender: TObject);
begin
  eSpieler.Text := '';
  rbBeide.Checked := true;
  eEreignis.Text := '';
  cbZeitraum.Checked := false;
  cbGewinn.Checked := false;
  cbRemis.Checked := false;
  cbVerlust.Checked := false;
  cbPosition.Checked := false;
end;

procedure TMDIPGN.sbOpenClick(Sender: TObject);
begin
  if MainForm.OpenDialog.Execute then begin
    {Bei allen Vorgngen, bei denen OnPGNTrace ausgelst wird, mu Abbrechen vorher auf false gestzt werden!}
    MainForm.Abbrechen := False;
    PGN1.PGNFile := MainForm.OpenDialog.FileName;
    MainForm.AddDatabase(PGN1.PGNFile);
    Caption := PGN1.PGNFile;
  end;
end;

procedure TMDIPGN.PGN1BeforeCreatePGNFile(Sender: TObject;
  FileName: String; var CreateNewPGNFile: Boolean);
begin
  if MessageDlg('Soll die PGN-Datei "' + FileName + '" neu angelegt werden?',
  mtConfirmation, [mbYes, mbNo], 0) <> mrYes
    then CreateNewPGNFile := false;
end;

procedure TMDIPGN.bPositionClick(Sender: TObject);
begin
  if SearchBrett.Aufbauen(true)  {bei true wird auch eine illegale Stellung akzeptiert}
    then cbPosition.Checked := true;
end;

procedure TMDIPGN.sbDeleteGameClick(Sender: TObject);
Var i : longint;
begin
  if PGN1.SelCount <> 0 then begin
    if MessageDlg('Wirklich lschen?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      Enabled := false; {beim Lschen das gesamte Formular abschalten (im Gegensatz zu Filtern)}
      Screen.Cursor := crHourGlass;
      try
        MainForm.Abbrechen := false;
        i := 0;
        while i < PGN1.Items.Count do begin
          if PGN1.Selected[i] then begin
            if not PGN1.DeleteGame(i) then inc(i);
            MainForm.DoProcessMessages;
            if MainForm.Abbrechen then Break;
          end
          else inc(i);
        end;
      finally
        Enabled := true;
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TMDIPGN.sbDeleteDatabaseClick(Sender: TObject);
begin
  if MessageDlg('Soll die gesamte Datenbank wirklich gelscht werden?',
  mtWarning, [mbYes, mbNo], 0) = mrYes then begin
    MainForm.DeletePGNFile := Caption;
    Close;
    PostMessage(MainForm.Handle, WM_DELETEPGNFILE, 0, 0);
  end;
end;

procedure TMDIPGN.PGN1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := Source is TPGN;
end;

procedure TMDIPGN.PGN1DragDrop(Sender, Source: TObject; X, Y: Integer);
Var ID, i, j : longint;
    s : string;
    p : TPoint;
begin
  if (Sender is TPGN) and (Source is TPGN) and (Sender <> Source) then begin
    if (Source as TPGN).SelCount = 0 then exit;
    Screen.Cursor := crHourGlass;
    enabled := false;
    ((Source as TPGN).Parent as TForm).Enabled := false;
    try
      MainForm.Abbrechen := false;
      i := 0;
      while i < (Source as TPGN).Items.Count do begin
        if (Source as TPGN).Selected[i] then begin
          s := (Source as TPGN).GetGameAsString(
          (Source as TPGN).ListeIndexToDatabaseIndex(i), ID);
          if s <> '' then begin
            if sbDragInsert.Down then begin
              p.x := X;
              p.y := Y;
              j := (Sender as TPGN).ItemAtPos(p, true);  {-1 bei keinem Eintrag an betr. Stelle - ist -1 = pgnAddGame}
            end
            else j := pgnAddGame;
            (Sender as TPGN).SaveGame(j, ID, s);
            {Fgt Partie an Stelle j ein - bei j = pgnAddGame an letzter Stelle
             (Var-Param. ID hier nicht merken - nur wenn die Partie mit ReplaceGame noch verndert werden soll, wird die gebraucht}
            (Source as TPGN).Selected[i] := false;
            {Listeindex ist bei gefilterter Liste nicht gleich der tatschlichen Nummer der Partie}
            MainForm.DoProcessMessages;
            if MainForm.Abbrechen then Break;
          end;  
        end;
        inc(i);
      end;
      if (j <> pgnAddGame) and (sbFilter.Down)
        then (Sender as TPGN).Filtern;
    finally
      ((Source as TPGN).Parent as TForm).Enabled := true;
      enabled := true;
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TMDIPGN.PGN1PGNDblClick(Sender: TObject; PGNGame: String;
  GameID: Integer);
begin  {dieses Ereignis wird auch auf <ENTER> ausgelst}
  MainForm.CreateMDIBrettChild(PGN1, PGNGame, GameID);
end;

procedure TMDIPGN.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Var I : Integer;
    Opened : Boolean;
begin
  if MainForm.Working then begin
    CanClose := false;
    exit;
  end;
  if MainForm.Closing then exit;
  Opened := false;
  for I := MainForm.MDIChildCount - 1 downto 0 do
    if MainForm.MDIChildren[I] is TMDIBrett then
      if (MainForm.MDIChildren[I] as TMDIBrett).PGN = PGN1 then begin
         Opened := true;
         Break;
      end;
  if Opened then begin
    if MessageDlg('Aus dieser Datenbank sind noch Partien geffnet.' + #13 +
    'Wird sie geschlossen, mssen Sie diese Partien an diese oder eine andere Datenbank anhngen.' + #13 +
    'Soll sie trotzdem geschlossen werden?', mtWarning, [mbYes, mbNo], 0) <> mrYes
      then CanClose := false
    else begin
      for I := MainForm.MDIChildCount - 1 downto 0 do
        if MainForm.MDIChildren[I] is TMDIBrett then begin
          if (MainForm.MDIChildren[I] as TMDIBrett).PGN = PGN1 then begin
           (MainForm.MDIChildren[I] as TMDIBrett).PGN := Nil;
           (MainForm.MDIChildren[I] as TMDIBrett).GameID := pgnAddGame;
           (MainForm.MDIChildren[I] as TMDIBrett).bPrev.Enabled := False;
           (MainForm.MDIChildren[I] as TMDIBrett).bNext.Enabled := False;
         end;  
        end;
    end;
  end;
end;

procedure TMDIPGN.bPrintClick(Sender: TObject);
Var ID, i, j, rj, HVar  : longint;
    sPart, sNotat : String;
    Done : Boolean;
    Stllg : TSchachbrett;

procedure eInsert(fs : TFontStyles; c : TColor);
begin
  with RicheditForm.Richedit1 do begin
    if (text <> '') and (text[length(text)] = #10) then begin
      if (sPart <> '') and (sPart[1] = ' ') then Delete(sPart, 1, 1);
      if (sPart <> '') and (sPart[1] = ' ') then Delete(sPart, 1, 1);
    end;
    SelText := sPart;
    sPart := '';
    SelAttributes.Style := fs;
    SelAttributes.Color := c;
  end;
end;

procedure OrtEintragen;
begin
  with hNotation.Partiedaten.EventData, RicheditForm.Richedit1 do begin
    if (ort<>'') and (ort<>'?') then begin
      SelText := ort;
      if jahr<>0 then SelText := ', '
      else SelText := noReturn;
    end;
    if jahr<>0 then SelText := inttostr(jahr) + noReturn;
  end;
end;

begin    {Nur Notbehelf - sollte eigentlich eine 'richtige' Print-Komponente machen}
  RicheditForm := TRicheditForm.Create(self);
  Screen.Cursor := crHourGlass;
  try
    if PGN1.SelCount = 0 then exit;
    with RicheditForm.Richedit1 do begin
      DefAttributes.Size := 12;
      ParaGraph.FirstIndent := 50;
      ParaGraph.RightIndent := 50;
    end;
    For i := 0 to PGN1.Items.count - 1 do if PGN1.Selected[i] then begin
      sNotat := PGN1.GetGameAsString(PGN1.ListeIndexToDatabaseIndex(i), ID);
      if sNotat <> '' then begin
        hNotation.SetGame(sNotat);
        sNotat := hNotation.GetNotation;
        j := 0;
        HVar := 0;
        sPart := '';
        eInsert([fsBold], clBlack);
        with hNotation.Partiedaten.EventData, RicheditForm.Richedit1 do begin
          SelText := Weiss + ' - ' + Schwarz + noReturn;
          if (Quelle<>'') and (Quelle<>'?') then begin
            SelText := Quelle;
            if ((ort<>'') and (ort<>'?')) or (jahr <> 0) then begin
              SelText := ', ';
              OrtEintragen;
            end
            else SelText := noReturn;
          end
          else OrtEintragen;
          SelText := noReturn;
        end;
        Done := false;
        while j < length(sNotat) do begin
          inc(j);
          case sNotat[j] of
            '[' : begin
                    eInsert([], clBlack);
                    inc(HVar);
                  end;
            ']' : begin
                    sPart := sPart + sNotat[j];
                    Done := true;
                    eInsert([fsBold], clBlack);
                    dec(HVar);
                  end;
            '(' : begin
                    eInsert([], clMaroon);
                    inc(HVar);
                  end;
            ')' : begin
                    sPart := sPart + sNotat[j];
                    Done := true;
                    dec(HVar);
                    if HVar < 2 then eInsert([], clBlack);
                  end;
            '{' : begin
                    eInsert([], clMaroon);
                    rj := j;
                    inc(j);
                    while (sNotat[j] <> '}') and (j <= length(sNotat)) do begin
                      if (sNotat[j] <> '}') and (sNotat[j] <> noDiagrammzeichen)
                        then sPart := sPart + sNotat[j];
                      if sNotat[j] = noDiagrammzeichen then begin
                        while (rj > 1) and ((sNotat[rj] = '{') or (sNotat[rj] = ' '))  {auf Zug setzen}
                          do dec(rj);
                        Stllg := hNotation.GetPositionAt(rj); {Achtung - diese Funktion stellt auch Notation auf diese Stellung ein, wie auf Mausklick}
                        InsertDia(RicheditForm.Richedit1, Stllg);
                      end;
                      inc(j);
                    end;
                    case HVar of
                      0 : eInsert([fsBold], clBlack);
                      1 : eInsert([], clBlack);
                      else eInsert([], clMaroon);
                    end;
                    Done := true;
                  end;
          end;
          if not Done then sPart := sPart + sNotat[j];
          Done := false;
        end;
      end;
      eInsert([], clBlack);
      RicheditForm.Richedit1.SelText := noReturn + noReturn;
    end;
    RicheditForm.Richedit1.Print(noReturn + noReturn);
  finally
    Screen.Cursor := crDefault;
    RicheditForm.Free;
  end;
end;

procedure TMDIPGN.FormCreate(Sender: TObject);
begin
  if MainForm.mEnglish.Checked then hNotation.English := true;
  if not ChessFontInstalled then bPrint.Enabled := false;
end;

procedure TMDIPGN.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 27 then Close;  
end;

procedure TMDIPGN.HeaderControlSectionClick(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
  MainForm.Abbrechen := false;
  if Section = HeaderControl.Sections[0] then PGN1.Sortieren(soNothing)
  else if Section = HeaderControl.Sections[1] then PGN1.Sortieren(soWeiss)
  else if Section = HeaderControl.Sections[2] then PGN1.Sortieren(soQuelle)
  else if Section = HeaderControl.Sections[3] then PGN1.Sortieren(soJahr)
  else PGN1.Sortieren(soErgebnis);
end;

end.
