unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls,
  SchachProcs,   { Diese Unit mu bei Verwendung einer der Schachkomponenten IMMER eingebunden werden}
  Brett, PGN, IniFiles, MiniMax;

const WM_DELETEPGNFILE = WM_USER + 5;
      sIniFileName = 'CompoChess.ini';
      sSpeicherfehler = 'Beim Speichern ist ein Fehler aufgetreten.';
      sLadeFehler = 'Beim Laden der Partie ist ein Fehler aufgetreten.';
      sSaveQuestion = 'Partie wurde gendert.' + #13 + 'Speichern?';
      sHistory = 'History';
      sOptions = 'Options';

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    mPartien: TMenuItem;
    mGameOpen: TMenuItem;
    mOpenPGN: TMenuItem;
    mClose: TMenuItem;
    Window1: TMenuItem;
    N1: TMenuItem;
    mExit: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    WindowMinimizeItem: TMenuItem;
    Panel1: TPanel;
    pHint: TPanel;
    pTrace: TPanel;
    prBar: TProgressBar;
    bStop: TBitBtn;
    hBrett: TBrett;
    N2: TMenuItem;
    mFRC: TMenuItem;
    mHistory: TMenuItem;
    FontDialog1: TFontDialog;
    mEnglish: TMenuItem;
    FontDialogComm: TFontDialog;
    procedure FormCreate(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure mCloseClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure mExitClick(Sender: TObject);
    procedure mFRCClick(Sender: TObject);
    procedure mGameOpenClick(Sender: TObject);
    procedure mHistoryClick(Sender: TObject);
    procedure mOpenPGNClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mEnglishClick(Sender: TObject);
  private
    { Private declarations }
    slDatabase : TStringList;
    procedure ShowHint(Sender: TObject);
    procedure DoDeletePGNFile(Var Msg : TMsg); message WM_DELETEPGNFILE;
    procedure DoClose(Var Msg : TMsg); message WM_CLOSE;
  public
    { Public declarations }
    Abbrechen, DatabaseWinOpen, Working, Closing,
    KoordVisible : Boolean;
    DeletePGNFile, SaveDataBase : string;
    procedure CreateMDIPGNChild(const Name: string);
    procedure DoTrace(Sender: TObject; Percent: Integer; var CancelMode: TCancelMode);
    procedure AddDatabase(s : string);
    procedure DeleteDatabase(s : string);
    procedure CreateMDIBrettChild(const PGN : TPGN; Game : string; GameID : longint);
    procedure DoProcessMessages;
  end;

var
  MainForm: TMainForm;
  ChessFontInstalled : Boolean;

function  DatabaseNameToListboxName(s : string) : string;
function  ListboxNameToDatabaseName(s : string) : string;
procedure InsertDia(Richedit : TRichedit; Stllg : TSchachbrett);

implementation

{$R *.DFM}

uses PGNWin, BrettWin, DatabaseWin, About, Riched;

function FontProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
 if StrPas(LogFont.lfFaceName) = '1Echecs' then begin
   ChessFontInstalled := true;
   Result := 0;
 end
 else Result := 1;
end;

procedure InsertDia(Richedit : TRichedit; Stllg : TSchachbrett);
Var attrColor : TColor;
    attrStyle : TFontStyles;
    attrName : String;
    attrSize : Integer;
    k, l : integer;

const
      SchachfontName = '1Echecs';
      sfRo  = '';  {Rand}
      sfRl  = #180;
      sfRr  = #222;
      sfRu  = #131;
      sfElo = #241; {Ecken}
      sfEro = #242;
      sfElu = #243;
      sfEru = #244;
      sfwFl = #32;  {Leerfelder}
      sfsFl = #58;
      sfwFwK = 'r';    sfwFsK = 'R';   {Figuren}
      sfsFwK = '01r';  sfsFsK = '01R';
      sfwFwD = 'de';   sfwFsD = 'D';
      sfsFwD = '23de'; sfsFsD = '23D';
      sfwFwT = 't';    sfwFsT = 'T';
      sfsFwT = '45t';  sfsFsT = '45T';
      sfwFwL = 'f';    sfwFsL = 'F';
      sfsFwL = '67f';  sfsFsL = '67F';
      sfwFwS = 'c';    sfwFsS = 'C';
      sfsFwS = '89c';  sfsFsS = '89C';
      sfwFwB = 'p';    sfwFsB = 'P';
      sfsFwB = '()p';  sfsFsB = '()P';

procedure Choose(sw, ss : string);
begin
  if FeldFarbe[k] = 0 then RicheditForm.Richedit1.SelText := sw
  else RicheditForm.Richedit1.SelText := ss;
end;

begin
  with RicheditForm.Richedit1 do begin
      attrColor := SelAttributes.Color;
      attrStyle := SelAttributes.Style;
      attrName := SelAttributes.Name;
      attrSize := SelAttributes.Size;
      if (text <> '') and (text[length(text)] <> #10)
        then SelText := noReturn{ +  noReturn};
      SelAttributes.Name := SchachfontName;
      SelAttributes.Size := 20;
      SelAttributes.Style := [];
      SelAttributes.Color := clBlack;
      SelText := sfElo + sfRo + sfRo + sfRo + sfRo + sfRo + sfRo + sfRo + sfRo + sfEro + noReturn;
      l := 56;
      repeat
        SelText := sfRl;
        for k := l to l + 7 do begin
          case Stllg[c(k)] of
            LEER: Choose(sfwFl, sfsFl);
            wk  : Choose(sfwFwK, sfsFwK);
            wd  : Choose(sfwFwD, sfsFwD);
            wt  : Choose(sfwFwT, sfsFwT);
            wl  : Choose(sfwFwL, sfsFwL);
            ws  : Choose(sfwFwS, sfsFwS);
            wb  : Choose(sfwFwB, sfsFwB);
            sk  : Choose(sfwFsK, sfsFsK);
            sd  : Choose(sfwFsD, sfsFsD);
            st  : Choose(sfwFsT, sfsFsT);
            sl  : Choose(sfwFsL, sfsFsL);
            ss  : Choose(sfwFsS, sfsFsS);
            sb  : Choose(sfwFsB, sfsFsB);
          end;
        end;
        SelText := sfRr + noReturn;
        dec(l, 8);
      until l < 0;
      SelText := sfEru + sfRu + sfRu + sfRu + sfRu + sfRu + sfRu + sfRu + sfRu + sfEru;
      SelAttributes.Color := attrColor;
      SelAttributes.Style := attrStyle;
      SelAttributes.Name := attrName;
      SelAttributes.Size := attrSize;
      SelText := noReturn{ +  noReturn};
  end;
end;

procedure TMainForm.DoClose(Var Msg : TMsg);
begin
  Closing := True; {Rckfrage des PGN-Fensters unterdrcken}
  Close;
  Closing := False;
end;

procedure TMainForm.DoDeletePGNFile(Var Msg : TMsg);
begin
  DeleteFile(DeletePGNFile);
  DeleteDatabase(DeletePGNFile);
  DeletePGNFile := '';
end;

procedure TMainForm.DoProcessMessages;
begin
  Working := true;
  Application.ProcessMessages;
  Working := false;
end;

procedure TMainForm.DoTrace(Sender: TObject; Percent: Integer; var CancelMode: TCancelMode);
begin
  PrBar.Position := Percent;
  if CancelMode <> cmCancelDenied then begin
    DoProcessMessages;
    if Abbrechen then CancelMode := cmCancel;
  end
  else if Percent = 0 then Refresh;
end;

function DatabaseNameToListboxName(s : string) : string;
begin
  Result := ExtractFileName(s) + '   "' + s + '"';
end;

function ListboxNameToDatabaseName(s : string) : string;
Var i : integer;
begin
  Result := '';
  i := Pos('"', s);
  if i = 0 then exit;
  Result := copy(s, i + 1, length(s));
  if Result <> '' then delete(Result, length(Result), 1);
end;

procedure TMainForm.DeleteDatabase(s : string);
Var i : integer;
begin
  i := slDatabase.IndexOf(DatabaseNameToListboxName(s));
  if i <> -1 then begin
    slDatabase.Delete(i);
    if not mHistory.Enabled then
      MDIDatabase.lbDatabase.Items.Assign(slDataBase);
  end;
end;

procedure TMainForm.AddDatabase(s : string);
begin
  if (s = '') or
  (slDatabase.IndexOf(DatabaseNameToListboxName(s)) <> -1)
    then exit;
  slDatabase.Insert(0, DatabaseNameToListboxName(s));
  if slDatabase.Count > 8 then slDatabase.Delete(slDatabase.Count - 1);
  if not mHistory.Enabled then
    MDIDatabase.lbDatabase.Items.Assign(slDataBase);
end;

procedure TMainForm.CreateMDIPGNChild(const Name: string);
var I : Integer;
    Child: TMDIPGN;
begin
  for I := MDIChildCount - 1 downto 0 do
    if uppercase(MDIChildren[I].Caption) = uppercase(Name) then begin
      MDIChildren[I].BringToFront;
      exit;
    end;
  Child := TMDIPGN.Create(Application);
  Abbrechen := false;
  Child.PGN1.PGNFile := Name;
  Child.Caption := Child.PGN1.PGNFile;
  AddDatabase(Child.PGN1.PGNFile);
  Child.Panel1.Enabled := true;
end;

procedure TMainForm.CreateMDIBrettChild(const PGN : TPGN; Game : string; GameID : longint);
var I : Integer;
    Child: TMDIBrett;
begin
  Screen.Cursor := crHourGlass;
  try
    if Game <> '' then for I := MDIChildCount - 1 downto 0 do
      if MDIChildren[I] is TMDIBrett then
        if ((MDIChildren[I] as TMDIBrett).PGN = PGN) and
        ((MDIChildren[I] as TMDIBrett).GameID = GameID) then begin
          MDIChildren[I].BringToFront;
          exit;
        end;
    Child := TMDIBrett.Create(Application);
    Child.PGN := PGN;
    Child.GameID := GameID;
    if Game <> '' then begin
      Child.Notation1.SetGame(Game);
      Child.bPrev.Enabled := true;
      Child.bNext.Enabled := true;
    end
    else if MainForm.mFRC.Checked then begin
      Child.Brett1.SetPosition(GetFischerRandomPosition, Child.Brett1.GetBrZug);
      SetFischerInfo(Child.FRC, Child.Brett1.GetBrStellung);
      Child.Notation1.NeueStellung(Child.Brett1.GetBrStellung, Child.Brett1.GetBrZug, 1);
      Child.Notation1.Geaendert := false;
      Child.sbReplace.Enabled := false;
      Child.Notation1FischerInfo(self, Child.FRC^);
    end;
    Child.Caption := Child.Notation1.Partiedaten.EventData.Weiss +
    ' - ' + Child.Notation1.Partiedaten.EventData.Schwarz;
  finally
    Screen.Cursor := crDefault;
  end;    
end;

procedure TMainForm.FormCreate(Sender: TObject);
Var DC: HDC;
begin
  Application.OnHint := ShowHint;
  Screen.OnActiveFormChange := UpdateMenuItems;
  slDatabase := TStringlist.Create;
  Randomize;  {fr Aufbauen einer Fischer-R.-C.-Ausgangsstellung}
  DC := GetDC(0);
  try
    EnumFonts(DC, nil, @FontProc, Pointer(Self));
  finally
    ReleaseDC(0, DC);
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
  slDatabase.Free;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  pHint.Caption := Application.Hint;
end;

procedure TMainForm.mCloseClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    ActiveMDIChild.Close;
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do try
    ShowModal;
  finally
    free;
  end;    
end;

procedure TMainForm.bStopClick(Sender: TObject);
begin
  Abbrechen := true;
end;

procedure TMainForm.mExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.mFRCClick(Sender: TObject);
begin
  mFRC.Checked := not mFRC.Checked;
end;

procedure TMainForm.mGameOpenClick(Sender: TObject);
begin
  CreateMDIBrettChild(Nil, '', pgnAddGame);
end;

procedure TMainForm.mHistoryClick(Sender: TObject);
begin
  MDIDatabase := TMDIDatabase.Create(Application);
  MDIDatabase.lbDatabase.Items.Assign(slDatabase);
  mHistory.Enabled := false;
end;

procedure TMainForm.mOpenPGNClick(Sender: TObject);

function MayBeMailChessFile(s : string) : Boolean;
begin //wird als externer PGN-Viewer in "MailChess" empfohlen - sollte aber dessen Dateien nicht verndern
  Result := false;
  if uppercase(ExtractFileName(s)) = 'PARTIEN.PGN' then begin
    if (FileExists(ExtractFilePath(s) + 'Turnier.ini')) and
    (FileExists(ExtractFilePath(s) + 'Gegner.mcf')) then begin
      if MessageDlg('Die Datei "' + s + '" ist mglicherweise die Partiendatei des Programmes MAILCHESS.' + #13 +
      'Falls dem so ist, sollte sie nicht verndert und der Ladevorgang abgebrochen werden.' + #13 +
      #13 + 'Soll der Ladevorgang abgebrochen werden?', mtWarning, [mbYes, mbNo], 0)
      = mrYes then Result := True;
    end;
  end;
end;

begin
  if OpenDialog.Execute then begin
    if MayBeMailChessFile(OpenDialog.FileName) then exit;
    CreateMDIPGNChild(OpenDialog.FileName);
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
Var i : integer;
    s : string;
    fett : Boolean;
begin
  with TIniFile.Create(ExtractFilePath(Application.ExeName) + sIniFileName) do try
    For i := 0 to 7 do begin
      s := ReadString(sHistory, 'File' + IntToStr(i), '');
      if CheckPGN(ListboxNameToDatabaseName(s))
        then slDatabase.Add(s);
    end;
    SaveDataBase := ReadString(sHistory, 'SaveDataBase', '');
    if not ReadBool(sOptions, 'DatabaseWinEnabled' , true)
      then mHistoryClick(self);
    KoordVisible := ReadBool(sOptions, 'Koordinaten', True);
    FontDialog1.Font.Name := ReadString(sOptions, 'FontName', 'Courier New');
    FontDialog1.Font.Size := ReadInteger(sOptions, 'FontSize', 10);
    fett := ReadBool(sOptions, 'FontBold', True);
    if fett then FontDialog1.Font.Style:=[fsBold]
    else FontDialog1.Font.Style:=[];
    FontDialog1.Font.Color := ReadInteger(sOptions, 'FontColor', clBlack);
    FontDialogComm.Font.Name := ReadString(sOptions, 'CFontName', 'Arial');
    FontDialogComm.Font.Size := ReadInteger(sOptions, 'CFontSize', 10);
    fett := ReadBool(sOptions, 'CFontBold', false);
    if fett then FontDialogComm.Font.Style:=[fsBold]
    else FontDialogComm.Font.Style:=[];
    FontDialogComm.Font.Color := ReadInteger(sOptions, 'CFontColor', clMaroon);
    mFRC.Checked := ReadBool(sOptions, 'FRC', false);
    mEnglish.Checked := ReadBool(sOptions, 'English', false);
  finally
    free;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
Var s : string;
    i : integer;
    fett : Boolean;
begin
  with TIniFile.Create(ExtractFilePath(Application.ExeName) + sIniFileName) do try
    For i := 0 to 7 do begin
      if i < slDatabase.Count then s := slDatabase[i]
      else s := '';
      WriteString(sHistory, 'File' + IntToStr(i), s);
    end;
    WriteString(sHistory, 'SaveDataBase', SaveDataBase);
    WriteBool(sOptions, 'DatabaseWinEnabled' , mHistory.Enabled);
    WriteBool(sOptions, 'Koordinaten', KoordVisible);
    WriteString(sOptions, 'FontName', FontDialog1.Font.Name);
    WriteInteger(sOptions, 'FontSize', FontDialog1.Font.Size);
    if fsBold in FontDialog1.Font.Style then fett:=true else fett:=false;
    WriteBool(sOptions, 'FontBold', fett);
    WriteInteger(sOptions, 'FontColor', FontDialog1.Font.Color);
    WriteString(sOptions, 'CFontName', FontDialogComm.Font.Name);
    WriteInteger(sOptions, 'CFontSize', FontDialogComm.Font.Size);
    if fsBold in FontDialogComm.Font.Style then fett:=true else fett:=false;
    WriteBool(sOptions, 'CFontBold', fett);
    WriteInteger(sOptions, 'CFontColor', FontDialogComm.Font.Color);
    WriteBool(sOptions, 'FRC', mFRC.Checked);
    WriteBool(sOptions, 'English', mEnglish.Checked);
  finally
    free;
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Working then CanClose := false;
end;

procedure TMainForm.mEnglishClick(Sender: TObject);
begin
  mEnglish.Checked := not mEnglish.Checked;
end;

end.
