unit Notation;

{$B-}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Menus, Spin, ComCtrls, clipbrd,
  SchachProcs;

type

     TPartiedaten = record
       EventData : TEventData;
       Stellung : TSchachbrett;
       Zug : TZug;       {in Zug stehen Stellungsinfos wie Rochademglichkeiten usw.}
       Zugnummer : word;
       Kommentar : string; {falls vor ersten Zug Kommentar zur Stellung steht}
     end;

     PBaumList = ^TBaumList;
     PBaum = ^TBaum;
     TBaumlist = record B : PBaum;  BL, rBL : PBaumList; end;
     PPBaumList = ^Pointer;

     TBaum = record
       B, rB : PBaum;
       VarWurzel : PBaumList;
       Zug : TZug;
       Kommentar : String;
       ss, sl : longint;
       Zugnummer : integer; {Partiedaten.Zugnummer + aktuelle}
     end;

     PRettBrett = ^TRettBrett;
     TRettBrett = record
       stellung : TSchachbrett;
       Zug : TZug;
       Wurzel : PBaumList;
       Baum : PBaum;
     end;

     TNotatScrollbar = class(TScrollbar)
       procedure Change; override;
     end;

     TNotatPaintbox = class(TPaintbox)
       procedure paint; override;
       procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:Integer); override;
     end;

     TMoveChangeEvent = procedure (Sender: TObject; Zug : TZug; Stellung : TSchachbrett; NextMove : Boolean) of object;
     TErrorEvent  = procedure (Sender: TObject; Fehlermeldung : string) of object;
     TFischerInfoEvent = procedure (Sender: TObject; FischerInfo : TFischerInfo) of object;

     TNotation = class(TCustomPanel)
     constructor create(AOwner : TComponent);override;
     destructor destroy;override;
     private
       Fueberschrift : boolean;
       FEnglish : Byte;
       FOnMoveChange : TMoveChangeEvent;
       FOnFischerInfo : TFischerInfoEvent;
       FOnError : TErrorEvent;
       FGeaendert : Boolean;
       FOn50MovesRule : TNotifyEvent;
       FOn3Repetition : TNotifyEvent;
       FOnGameChanged : TNotifyEvent;
       FPartiedaten : TPartiedaten;

       FFontHeadLine, FFont0Var, FFontComment : TFont;
       FAutoBold : Boolean;
       FFont1Var : TFont;
       FFont2Var : TFont;
       FIndent0Var, FIndent1Var, FIndent2Var : word;
       FZeilenAbstand : word;
       FBevelwidthNotat, FBorderwidthNotat : word;
       FFRC : PFischerInfo;

       VarDialog : TForm;
       Einfuegen, Ueberschreiben, Abbruch : TButton;
       lZuege : TListBox;

       (*zugnummer, *)ebene : integer;
       klammerzu, klammerauf : Boolean; {fr klettere}
       notat, ret : string;

       NoStellung : PSchachbrett;
       NoZug : PZug;
       inBetracht : array[1..10] of integer; {in Betracht knnen hchstens 10 gleiche Figuren kommen}
       inBetrachtindex : byte;
       Wurzel : PBaumList;
       Wurzelliste : PBaumList; {fr Verzweigungen}
       Baum : PBaum;
       Baumindex : PBaum;
       Wurzelindex : PBaumList;
       ZBaumlist : PPBaumList;   {Zeiger auf Zeiger auf Wurzelliste - zum Var. lschen}
       inHauptvariante : Boolean;  {in dem Fall darf nicht aufgewertet, aber nach vorn geschnitten werden}
       uebergabe : integer;  {fr Variantenwahl}
       gemeldet : Boolean;
       udBi : PBaum;         {fr UnDo}
       udwurzel : PBaumlist;
       ud : integer; {0 = kein UnDo mglich, -1 = Schneiden hinten, -2 = Schneiden vorn, 1.. = Lschen (Var.Nr)}
       udPartiedaten : TPartiedaten; {bei Schneiden nach vorn ndern die sich}

       pb : TNotatPaintbox;
       SLeiste : TNotatScrollbar;
       wrap, commwrap : TStringlist;
       bf : TBitmap;
       ZugRect : TRect;
       rNotatBaumindex : PBaum;
       rFont : TFont;   (**)
       Texthoehe : integer;
       FirstLine, LastLine : integer;
       UeberschriftEnde : integer;
       FontNoVar : TFont;

       procedure ZugVor;
       procedure ZugZurueck(z : TZug);
       procedure VarEinfuegen;
       procedure BaumEinfuegen(z : TZug);
       function  sucheKoenig(wo : byte; schachpruefung : boolean) : boolean;
       function  sucheDame(wo : byte; schachpruefung : boolean) : boolean;
       function  sucheTurm(wo : byte; schachpruefung : boolean) : boolean;
       function  sucheLaeufer(wo : byte; schachpruefung : boolean) : boolean;
       function  sucheSpringer(wo : byte; schachpruefung : boolean) : boolean;
       function  sucheBauer(wo : byte; schachpruefung : boolean) : boolean;
       procedure loescheBaum(Pbl1 : PPBaumList);
       procedure klettere(bl1 : PBaumlist; neu : Boolean);
       function  retract(NotatSelstart : longint) : Boolean;
       function  notiereZug(z : TZug) : string;
       procedure Dialog_ini;
       procedure Varianten_anzeigen(keineZuege : Boolean);
       procedure loesche_UD;
       function  SchreibePartie(ToClipBoard : Boolean; Var PGNString : string) : integer;

       procedure SetUberschrift(w : Boolean);
       procedure SetGeaendert(w : Boolean);
       function  GetEnglish : Boolean;
       procedure SetEnglish(w : Boolean);
       procedure SetFontHeadLine(f : TFont);
       procedure SetFontComment(f : TFont);
       procedure SetFont0Var(f : TFont);
       procedure SetFont1Var(f : TFont);
       procedure SetFont2Var(f : TFont);
       procedure SetIndent0Var(i : word);
       procedure SetIndent1Var(i : word);
       procedure SetIndent2Var(i : word);
       procedure SetZeilenabstand(i : word);
       procedure SetBevelwidthNotat(i : word);
       procedure SetBorderwidthNotat(i : word);

       procedure LoescheNotatImFenster;
       procedure KD(Sender: TObject; var Key: Word; Shift: TShiftState);
       procedure MD(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

       procedure DoIniPartie;
       procedure SetPbCaret;
       procedure WMSize(var Msg: TMsg); message WM_SIZE;
       procedure DoMouseDown(x, y : integer);
       function  GetNumber(index : integer) : longint;
       function  GetTextWidth(ALine, a, l : integer) : integer;
       procedure SetFontsInLine(sl : TStringlist; a, l : integer; f, fc : TFont);
       function  DeleteCommKlammer(szeile : string) : string;
       function  NumberToString(nr : longint) : string;
       function  GetIndent(Font : TFont) : Integer;
       procedure PaintPb;
       procedure SetNotatBounds(pos : longint);
       function  GetLineNumber(b : PBaum; Var Linestart : longint) : integer; {Zeilennummer von der ersten sichtbaren an}
       function  IsNewScrollbarPos(b : PBaum) : integer;
       procedure AdjustPb(b : PBaum);

     protected
       procedure KeyDown(Var Key: Word; Shift: TShiftState); override;
       procedure loaded; override;
     public
       property Partiedaten : TPartiedaten read FPartiedaten write FPartiedaten;
       procedure NeueStellung(Stellung : TSchachbrett; Zug : TZug; z : integer);
       property  FRC : PFischerInfo read FFRC write FFRC;
       function  AddZug(Zug : TZug) : Boolean;
       procedure schneide(wie : Boolean);
       procedure aufwerten;
       procedure loeschen;
       procedure UnDo;
       procedure Matt;
       procedure Goback;
       procedure Goahead;
       function  Goahead_inHauptVariante(Var von, nach, UFigur : shortint) : Boolean; {ohne Variantendialog}
       procedure GoPreviousVar;
       procedure GoNextVar;
       procedure GoToStart;
       procedure GoToEnd;

       function  SetGame(PGNString : String) : integer;
       function  GetGame : string;

       function  GetKommentar : string;
       procedure SetKommentar(k : string);
       procedure iniPartie;
       procedure CopyGameToClipboard;
       function  PasteGameFromClipBoard : Boolean;
       procedure SetZugBewertung(s : string);
       procedure NotationRefresh;
       function  GetNextMoveNumberAsString : string;
       function  GetNotation : string;
       function  GetPositionAt(Stelle : integer) : TSchachbrett;  {Stelle ist Index im Notations-String (wie Mausklick darauf)}
       function  GetMove : TZug;

       property geaendert : Boolean read FGeaendert write SetGeaendert;
     published
       property Ueberschrift : Boolean read FUeberschrift write SetUberschrift;
       property English : Boolean read GetEnglish write SetEnglish;
       property FontHeadLine : TFont read FFontHeadLine write SetFontHeadLine;
       property FontComment : TFont read FFontComment write SetFontComment;
       property Font0Var : TFont read FFont0Var write SetFont0Var;
       property Font1Var : TFont read FFont1Var write SetFont1Var;
       property Font2Var : TFont read FFont2Var write SetFont2Var;
       property Indent0Var : word read FIndent0Var write SetIndent0Var;
       property Indent1Var : word read FIndent1Var write SetIndent1Var;
       property Indent2Var : word read FIndent2Var write SetIndent2Var;
       property AutoBold : Boolean read FAutoBold write FAutoBold;
       property Zeilenabstand : word read FZeilenabstand write SetZeilenabstand;

       property Color;
       property BevelOuter;
       property BevelInner;
       property BevelWidthNotat : word read FBevelwidthNotat write SetBevelwidthNotat;
       property BorderWidthNotat : word read FBorderwidthNotat write SetBorderwidthNotat;
       property Align;
       property Ctl3D;
       property Cursor;
       property DragCursor;
       property DragMode;
       property Enabled;
       property FullRepaint;
       property HelpContext;
       property Hint;
       property ShowHint;
       property PopupMenu;
       property Visible;

      { property OnClick;  nur auf Panel bezogen - nicht auf Paintbox
       property OnDblClick;
       property OnDragDrop;
       property OnDragOver;
       property OnEndDrag;
       property OnMouseDown;
       property OnMouseMove;
       property OnMouseUp;
       property OnStartDrag; }
       property OnResize;

       property OnMoveChange : TMoveChangeEvent read FOnMoveChange write FOnMoveChange;
       property OnError : TErrorEvent read FOnError write FOnError;
       property On50MovesRule : TNotifyEvent read FOn50MovesRule write FOn50MovesRule;
       property On3Repetition : TNotifyEvent read FOn3Repetition write FOn3Repetition;
       property OnGameChanged : TNotifyEvent read FOnGameChanged write FOnGameChanged;
       property OnFischerInfo : TFischerInfoEvent read FOnFischerInfo write FOnFischerInfo;
     end;


implementation

const
 {fr sucheDame, sucheTurm usw.}
  LZ : array[1..4] of integer = (-9,-11,9,11);  { Laeufer Richtungen }
  TZ : array[1..4] of integer = (-1,10,1,-10);  { Turm               }
  SZ : array[1..8] of integer = (19,21,12,-8,-19,-21,-12,8);   { Springer           }
  DZ : array[1..8] of integer = (-9,-11,9,11,-1,10,1,-10);
  KZ : array[1..8] of integer = (-9,-11,9,11,-1,10,1,-10);

  {or-Werte fr Attr1}
  nLetter = $10;  {in Notation mu ein Buchstabe frs Ausgangsfeld eingefgt werden - 2 Figuren konnten aufs Zielfeld}
  nDigit = $20;
  nSchach = $40;
  nMatt = $80;

  nFischerrochade = $8;

  {Attr2 - das kann jeweils nur einen Wert annehmen (!, ?, !! etc)}
  nAusruf = 1;
  n2Ausruf = 2;
  nFrage = 3;
  n2Frage = 4;
  nAusrufFrage = 5;
  nFrageAusruf = 6;

  figurnamen : array[1..12] of string[1] = ('','T','L','S','D','K','','R','B','N','Q','K');
  sonderzeichen  = ['(',')','[',']','{','}',#$A,#$D,';',' '];


procedure TNotation.WMSize(var Msg: TMsg);
Var i : integer;
begin
  i := Borderwidth + Bevelwidth;
  pb.left := i;
  pb.Top := i;
  pb.width := self.width - SLeiste.Width - (i shl 1);
  pb.height := self.height - (i shl 1);
  SLeiste.left := pb.left + pb.width;
  SLeiste.Top := pb.Top;
  SLeiste.height := pb.height;
  SLeiste.LargeChange := (SLeiste.height div Texthoehe) - 1;
  Klettere(wurzel, true);
end;

procedure TNotation.NotationRefresh;
begin
  klettere(wurzel, true);
end;

function TNotation.GetNotation : string;
begin
  Result := Notat;
end;

function  TNotation.GetPositionAt(Stelle : integer) : TSchachbrett;
begin
  Result := Partiedaten.Stellung;
  if Retract(Stelle) then begin
    Result := NoStellung^;
    if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
  end;  
end;

procedure TNotation.loaded;
begin
  inherited loaded;
  pb.Canvas.Font.Assign(Font0Var);
  Texthoehe := pb.canvas.TextHeight('Mg') + ZeilenAbstand;
end;

constructor TNotation.Create(AOwner : TComponent);
begin
  inherited create(AOwner);
  Caption := '';
  New(NoStellung);
  New(NoZug);
  ret:=#$D+#$A;

  SLeiste := TNotatScrollbar.Create(self);
  SLeiste.Kind := sbVertical;
  SLeiste.parent := self;
  pb := TNotatPaintbox.Create(self);
  pb.Canvas.pen.color := clsilver;
  pb.Canvas.brush.color := clsilver;
  pb.Canvas.brush.style := bsSolid;
  pb.parent := self;

  pb.width := self.width - SLeiste.Width;
  pb.height := self.height;
  SLeiste.left := pb.width;
  SLeiste.height := self.height;

  FAutoBold := true;
  FFontHeadLine := TFont.Create;
  FFontComment := TFont.Create;
  FFont0Var := TFont.Create;
  FFont1Var := TFont.Create;
  FFont2Var := TFont.Create;
  FontNoVar := TFont.Create;
  rFont := TFont.Create;
  wrap := TStringlist.Create;
  bf := TBitmap.Create;
  commwrap := TStringlist.Create;
  wrap.sorted := true;
  FIndent0Var := 2;
  FIndent1Var := 10;
  FIndent2Var := 18;
  FZeilenAbstand := 3;
  FBevelWidthNotat := 1;
  BevelOuter := bvLowered;
  DoIniPartie;
  with TBitmap.Create do try
    Canvas.Font.Assign(FFont0Var);
    Texthoehe := Canvas.TextHeight('Mg') + ZeilenAbstand;
  finally
    free;
  end;
end;

destructor TNotation.destroy;
begin
  try
    Dispose(NoStellung);
    Dispose(NoZug);
    if wurzel<>Nil then begin
      ZBaumlist:=addr(wurzel);
      loescheBaum(ZBaumlist);
    end;
    if UDWurzel<>Nil then begin
      ZBaumlist:=addr(UDWurzel);
      loescheBaum(ZBaumlist);
    end;
    SLeiste.free;
    pb.free;
    wrap.free;
    bf.free;
    commwrap.free;
    FFontHeadLine.free;
    FFontComment.free;
    FFont0Var.free;
    FFont1Var.free;
    FFont2Var.free;
    FontNoVar.Free;
    rFont.free;
    inherited destroy;
  except
  end;
end;

{--------------------------------------------------------------------------------------------
Fgt eine Verzweigung im Baum ein - Wurzelindex mu auf VarWurzel eines Baumeintrages zeigen
---------------------------------------------------------------------------------------------}
procedure TNotation.VarEinfuegen;
begin
  if Wurzelindex<>Nil then begin
    while Wurzelindex^.BL<>Nil do begin
      Wurzelindex:=Wurzelindex^.BL;  {Index auf nchste Verzweigung}
    end;
    New(Wurzelliste);  {neues Ende der Liste};
    Wurzelindex^.BL:=Wurzelliste;
    Wurzelliste^.BL:=Nil;
    Wurzelliste^.rBL:=Wurzelindex;
    Wurzelliste^.B:=Nil;
    Wurzelindex:=Wurzelliste;
  end
  else begin
    New(Baumindex^.VarWurzel);
    Baumindex^.VarWurzel^.B:=Nil;
    Baumindex^.VarWurzel^.BL:=Nil;
    Baumindex^.VarWurzel^.rBL:=Nil;
    Wurzelindex:=Baumindex^.VarWurzel;
  end;
end;

{------------------------------------------------------
Fgt eine neuen Baum - der Aufrufer mu noch Verketten
-------------------------------------------------------}
procedure TNotation.BaumEinfuegen(z : TZug);
Begin
  New(Baum);
  Baum^.Zug:=z;
  Baum^.B:=Nil;
  Baum^.rB:=Nil;
  Baum^.VarWurzel:=Nil;
  Baum^.Kommentar:='';
end;

{----------------------------------------------------------------------
Aktualisiert NoStellung
----------------------------------------------------------------------}
procedure TNotation.ZugVor;
begin
  NoStellung^[NoZug^.nach]:=NoStellung^[NoZug^.von];
  NoStellung^[NoZug^.von]:=0;
  if NoZug^.epSchlag<>LEER then NoStellung^[NoZug^.epSchlag]:=0;
  if NoZug^.RochadeArt<>KEINEROCHADE then begin
    if NoZug^.RochadeArt=KURZEROCHADE then begin
      if NoZug^.amZug=SCHWARZ then begin
        NoStellung^[h1]:=Leer;
        NoStellung^[f1]:=wT;
      end
      else begin
        NoStellung^[h8]:=Leer;
        NoStellung^[f8]:=sT;
      end;
    end
    else if NoZug^.RochadeArt=LANGEROCHADE then begin
      if NoZug^.amZug=SCHWARZ then begin
        NoStellung^[a1]:=Leer;
        NoStellung^[d1]:=wT;
      end
      else begin
        NoStellung^[a8]:=Leer;
        NoStellung^[d8]:=sT;
      end;
    end
    else if NoZug^.RochadeArt=KURZEFISCHERROCHADE then begin
      if not assigned(FRC) then exit;
      if NoZug^.amZug = SCHWARZ then NoStellung^[FRC^.FischerRightWhiteRook]:=LEER
      else NoStellung^[FRC^.FischerRightBlackRook]:=LEER;
      NoStellung^[NoZug^.nach-1]:=-NoZug^.amZug*W_T;
      NoStellung^[NoZug^.nach]:=-NoZug^.amZug*W_K;
    end
    else if NoZug^.RochadeArt=LANGEFISCHERROCHADE then begin
      if not assigned(FRC) then exit;
      if NoZug^.amZug = SCHWARZ then NoStellung^[FRC^.FischerLeftWhiteRook]:=LEER
      else NoStellung^[FRC^.FischerLeftBlackRook]:=LEER;
      NoStellung^[NoZug^.nach+1]:=-NoZug^.amZug*W_T;
      NoStellung^[NoZug^.nach]:=-NoZug^.amZug*W_K;
    end;
  end;
  if NoZug^.UFigur<>LEER then begin
    NoStellung^[NoZug^.nach]:=NoZug^.UFigur;
  end;
end;

procedure TNotation.ZugZurueck(z : TZug);
begin
  NoStellung^[z.von]:=NoStellung^[z.Nach];
  if z.Ufigur <> Leer then NoStellung^[z.von] := -z.amZug;
  if NoZug^.epSchlag<>LEER then begin
    NoStellung^[NoZug^.epSchlag]:=Z.amZug;
    NoStellung^[Z.Nach]:=LEER;
  end
  else NoStellung^[Z.Nach]:=Z.geschlFigur;
  if NoZug^.RochadeArt<>KEINEROCHADE then begin
    if NoZug^.RochadeArt=KURZEROCHADE then begin
      if NoZug^.amZug=SCHWARZ then begin
        NoStellung^[f1]:=Leer;
        NoStellung^[h1]:=wT;
      end
      else begin
        NoStellung^[f8]:=Leer;
        NoStellung^[h8]:=sT;
      end;
    end
    else if NoZug^.RochadeArt=LANGEROCHADE then begin
      if NoZug^.amZug=SCHWARZ then begin
        NoStellung^[d1]:=Leer;
        NoStellung^[a1]:=wT;
      end
      else begin
        NoStellung^[d8]:=Leer;
        NoStellung^[a8]:=sT;
      end;
    end
    else if NoZug^.RochadeArt=KURZEFISCHERROCHADE then begin
      if not assigned(FRC) then exit;
      NoStellung^[z.nach-1]:=LEER;
      if NoZug^.amZug = SCHWARZ then NoStellung^[FRC^.FischerRightWhiteRook]:=wT
      else NoStellung^[FRC^.FischerRightBlackRook]:=sT;
      NoStellung^[z.von]:=-NoZug^.amZug*wK;
    end
    else if NoZug^.RochadeArt=LANGEFISCHERROCHADE then begin
      if not assigned(FRC) then exit;
      NoStellung^[z.nach+1]:=LEER;
      if NoZug^.amZug = SCHWARZ then NoStellung^[FRC^.FischerLeftWhiteRook]:=wT
      else NoStellung^[FRC^.FischerLeftBlackRook]:=sT;
      NoStellung^[z.von]:=-NoZug^.amZug*wK;
    end;
  end;
end;

function TNotation.sucheDame(wo : byte; schachpruefung : boolean) : boolean;
Var i, j, aZ : integer;
begin
  sucheDame:=false;
  if Schachpruefung then aZ:=-NoZug^.amZug else aZ:=NoZug^.amZug;
  for i:=1 to 8 do begin
    j:=wo;
    repeat
      inc(j, DZ[i]);
      if NoStellung^[j]=aZ*wD then begin
        if schachpruefung=false then begin   {bei Schachpruefung darf inBetracht nicht verndert werden}
          inc(inBetrachtindex);
          inBetracht[inBetrachtindex]:=j;
        end;
        sucheDame:=true;
      end;
    until NoStellung^[j]<>LEER;
  end;
end;

function TNotation.sucheTurm(wo : byte; schachpruefung : boolean) : boolean;
Var i, j, aZ : integer;
begin
  sucheTurm:=false;
  if Schachpruefung then aZ:=-NoZug^.amZug else aZ:=NoZug^.amZug;
  for i:=1 to 4 do begin
    j:=wo;
    repeat
      inc(j, TZ[i]);
      if NoStellung^[j]=aZ*wT then begin
        if schachpruefung=false then begin   {bei Schachpruefung darf inBetracht nicht verndert werden}
          inc(inBetrachtindex);
          inBetracht[inBetrachtindex]:=j;
        end;
        sucheTurm:=true;
      end;
    until NoStellung^[j]<>LEER;
  end;
end;

function TNotation.sucheLaeufer(wo : byte; schachpruefung : boolean) : boolean;
Var i, j, aZ : integer;
begin
  sucheLaeufer:=false;
  if Schachpruefung then aZ:=-NoZug^.amZug else aZ:=NoZug^.amZug;
  for i:=1 to 4 do begin
    j:=wo;
    repeat
      inc(j, LZ[i]);
      if NoStellung^[j]=aZ*wL then begin
        if schachpruefung=false then begin   {bei Schachpruefung darf inBetracht nicht verndert werden}
          inc(inBetrachtindex);
          inBetracht[inBetrachtindex]:=j;
        end;
        sucheLaeufer:=true;
      end;
    until NoStellung^[j]<>LEER;
  end;
end;

function TNotation.sucheSpringer(wo : byte; schachpruefung : boolean) : boolean;
Var i, j, aZ : integer;
begin
  sucheSpringer:=false;
  if Schachpruefung then aZ:=-NoZug^.amZug else aZ:=NoZug^.amZug;
  for i:=1 to 8 do begin
    j:=wo;
    inc(j, SZ[i]);
    if NoStellung^[j]=aZ*wS then begin
      if schachpruefung=false then begin   {bei Schachpruefung darf inBetracht nicht verndert werden}
        inc(inBetrachtindex);
        inBetracht[inBetrachtindex]:=j;
      end;
      sucheSpringer:=true;
    end;
  end;
end;

function TNotation.sucheKoenig(wo : byte; schachpruefung : boolean) : boolean;
Var i, j, aZ : integer;
begin
  sucheKoenig:=false;
  if Schachpruefung then aZ:=-NoZug^.amZug else aZ:=NoZug^.amZug;
  for i:=1 to 8 do begin
    j:=wo;
    inc(j, KZ[i]);
    if NoStellung^[j]=aZ*wK then begin
      if schachpruefung=false then begin   {bei Schachpruefung darf inBetracht nicht verndert werden}
        inc(inBetrachtindex);
        inBetracht[inBetrachtindex]:=j;
      end;
      sucheKoenig:=true;
    end;
  end;
end;

function TNotation.sucheBauer(wo : byte; schachpruefung : boolean) : boolean;
Var aZ : integer;
begin
  sucheBauer:=false;
  if Schachpruefung then aZ:=-NoZug^.amZug else aZ:=NoZug^.amZug;
  if (NoStellung^[wo+(-aZ*9)]=aZ*wB)
  or (NoStellung^[wo+(-aZ*11)]=aZ*wB) then begin
    if schachpruefung=false then begin   {bei Schachpruefung darf inBetracht nicht verndert werden}
      inc(inBetrachtindex);
{      inBetracht[inBetrachtindex]:=j;  Bei Bauern ist das unntig}
    end;
    sucheBauer:=true;
  end;
end;

procedure TNotation.DoIniPartie;
begin
  Geaendert:=false;
  NoStellung^:=Ausgangsstellung;
  with Partiedaten do begin
    ResetEventData(FPartiedaten.EventData);
    kommentar:='';
    stellung:=Ausgangsstellung;
    zugnummer:=1;
  end;
  with Partiedaten.Zug do begin
    Rochademoeglichkeiten:=[wkr, wlr, skr, slr];
    amZug:=1;
    epFeld:=LEER;
    epSchlag:=LEER;
    UFigur:=LEER;
    geschlFigur:=LEER;
    RochadeArt:=KEINEROCHADE;
    attr1:=0;
    attr2:=0;
  end;
  if assigned(FOnMoveChange) then FOnMoveChange(self, Partiedaten.Zug, Partiedaten.Stellung, false);
end;

procedure TNotation.iniPartie;(**)
begin
  DoIniPartie;
  LoescheNotatImFenster;
end;

{
Lesen der Zge und erstellen des Variantenbaumes
}

function TNotation.SetGame(PGNString : String) : integer;
Var
       tempbrett : TRettbrett;
       Kommentar : string;
       rettbrett : PRettbrett;
       RettBrettstack : TList;

procedure SetAttr2(s : string);
begin
  if not assigned(Baumindex) then exit;
  if s = '1' then Baumindex^.Zug.attr2 := nAusruf
  else if s = '3' then Baumindex^.Zug.attr2 := n2Ausruf
  else if s = '2' then Baumindex^.Zug.attr2 := nFrage
  else if s = '4' then Baumindex^.Zug.attr2 := n2Frage
  else if s = '5' then Baumindex^.Zug.attr2 := nAusrufFrage
  else if s = '6' then Baumindex^.Zug.attr2 := nFrageAusruf;
end;


function analyse : boolean;
var i, j, k : longint;
    zug, feld : string;
    hilfswort : string;
    hilf, figur : shortint;
    linie, reihe : byte;
    fehler : integer;
    kl, keineZuege : boolean;

function Figurenart(b : char) : shortint;
begin
  case b of
    'K' : Figurenart:=wK*NoZug^.amZug;
    'Q' : Figurenart:=wD*NoZug^.amZug;
    'R' : Figurenart:=wT*NoZug^.amZug;
    'B' : Figurenart:=wL*NoZug^.amZug;
    'N' : Figurenart:=wS*NoZug^.amZug;
    'P' : Figurenart:=wB*NoZug^.amZug;
    else Figurenart:=wB*NoZug^.amZug;
  end;
end;

begin
  analyse:=false; {wird true bei Fehler}
  keineZuege:=true; {falls das so bleibt, wird am Schlu Wurzel freigegeben}
  RettBrettstack:=TList.Create;
  RettBrettstack.Capacity:=10;
  UD:=0;
  if UDWurzel<>Nil then begin
    ZBaumlist:=addr(UDWurzel);
    loescheBaum(ZBaumlist);
  end;
  if wurzel<>nil then begin
    ZBaumlist:=addr(wurzel);
    loescheBaum(ZBaumlist);
  end;
  New(Wurzel);
  Wurzel^.B:=Nil;
  Wurzel^.BL:=Nil;
  Wurzel^.rBL:=Nil;
  Wurzelindex:=Wurzel;
  Baumindex:=Nil;
  i:=0;
  kl:=true;
  kommentar:='';
  NoStellung^:=Partiedaten.Stellung; {}
  repeat
    inc(i);
    if i>=length(notat) then begin
      if kommentar<>'' then FPartiedaten.kommentar:=kommentar+' ';
      exit; {keine Zge eingegeben}
    end;
    if notat[i]='{' then kl:=false;
    if kl=false then kommentar:=kommentar+notat[i];
    if notat[i]='}' then kl:=true;
  until (notat[i]='.' ) and (kl);  {am Anfang knnte auch ein Kommentar stehen}
  {erste Zugnummer wird in LeseDaten ermittelt!!!}
  if length(kommentar)>1 then begin  {bei Zeilensprung in PGN wird im Komm. ein Leerzeichen eingefgt - mu raus}
    if kommentar[2]=' ' then delete(kommentar, 2, 1);
    if kommentar[length(kommentar)-1]=' ' then delete(kommentar, length(kommentar)-1, 1);
  end;
  if kommentar<>'' then FPartiedaten.kommentar:=kommentar+' ';
  NoZug^:=Partiedaten.Zug;
  dec(i);
  repeat
    inc(i);
    if (i>1) then if (notat[i]=' ') and (notat[i-1]='.') then delete(notat, i, 1); {Leerzeichen nach Zugnummer raus}
    if notat[i]='{' then begin
      kommentar:='{';
      repeat
        inc(i);
        kommentar:=kommentar+notat[i];
        if i>=length(notat) then  begin analyse:=true; exit end;
      until notat[i]='}';
      if kommentar[2]=' ' then delete(kommentar, 2, 1);
      if kommentar[length(kommentar)-1]=' ' then delete(kommentar, length(kommentar)-1, 1);
      Baumindex^.kommentar:=kommentar(*+' '*);
    end;
    IF notat[i]='$' then begin  {Ausrufezeichen etc}
      hilfswort:='';
      while (not (notat[i]=' ')) and (not (notat[i]=')')) and (i <= length(notat))
      do begin
        if notat[i] in ['0'..'9'] then hilfswort:=hilfswort+notat[i];
        delete(notat, i, 1); {nach $12 o.. mu Leerzeichen stehen; i braucht nicht inc zu werde, da String "nachrutscht"}
      end;
      SetAttr2(Hilfswort);
    end;
    if notat[i]='(' then begin  {Variantenbeginn}
      New(RettBrett);
      RettBrett^.Stellung:=tempbrett.Stellung;
      RettBrett^.Zug:=tempbrett.Zug;
      RettBrett^.Wurzel:=Wurzelindex;
      RettBrett^.Baum:=Baumindex;
      RettBrettstack.add(rettbrett);
      NoStellung^:=tempbrett.Stellung;  {Zug zurck vvv}
      NoZug^:=tempbrett.Zug;
      Wurzelindex:=Baumindex^.VarWurzel;
      VarEinfuegen;
    end;
    if notat[i]=')' then begin  {Variantenende}
      RettBrett:=RettBrettstack.Items[RettBrettstack.count-1];
      NoStellung^:=RettBrett^.Stellung; {gerettete Stellung vor Variantenbeginn wieder als aktuelle restaurieren}
      NoZug^:= RettBrett^.Zug;
      Wurzelindex:= RettBrett^.Wurzel; {steht jetzt auf letzter Variante}
      Baumindex:=RettBrett^.Baum;
      dispose(Rettbrett);
      RettBrettstack.remove(RettBrettstack.Items[RettBrettstack.count-1]);  {Letzte Stellung entfernen}
      tempbrett.stellung:=NoStellung^;
      tempBrett.Zug:=NoZug^;
      NoZug^.amZug:=-NoZug^.amZug;
      zugvor;  {letzten Zug von Hauptvariante wieder vorspielen}
    end;
    if notat[i] in ['A'..'Z','a'..'z','O', 'o'{Fischerroch.}] then begin  {Hier mu Zug losgehen}
      with NoZug^ do begin
        epFeld:=LEER;
        epSchlag:=LEER;
        UFigur:=LEER;
        geschlFigur:=LEER;
        RochadeArt:=KEINEROCHADE;
        attr1:=0;
        attr2:=0;
      end;
      zug:='';
      repeat
        if i>=length(notat) then  begin analyse:=true; exit end;
        if (notat[i]<>'=') and (notat[i]<>'#') and (notat[i]<>'+') then zug:=zug+notat[i]; {filtern}
        if notat[i]='+' then NoZug^.attr1:=NoZug^.attr1 or nSchach;   {linkes Bit bedeutet Schach}
        if notat[i]='#' then NoZug^.attr1:=NoZug^.attr1 or nMatt;   {drittes linkes Bit bedeutet Matt}
        inc(i);
      until (notat[i]=' ') or (notat[i]=')') or (notat[i]='*') or (i>length(notat));
      {auch wenn kein Erg. am Ende steht, mu Leerzeichen und "*" kommen}
      if notat[i]=')' then dec(i);
      {damit im nchsten Durchlauf nochmal die Klammer entdeckt wird und Variantenende registriert wird}
      if (Zug[1]='O') or (Zug[1]='o') then begin {Rochade; Fischerrochade (eine Null statt ein O !)}
        if Zug[1]='O' then begin
          if NoZug^.amZug=WEISS then begin
            NoZug^.von:=e1;
            if length(zug)>3 then begin
              NoZug^.RochadeArt:=LANGEROCHADE;
              NoZug^.nach:=c1  {groe}
            end
            else begin
              NoZug^.RochadeArt:=KURZEROCHADE;
              NoZug^.nach:=g1;
            end;            {kleine}
          end
          else begin
            NoZug^.von:=e8;
            if length(zug)>3 then begin
              NoZug^.RochadeArt:=LANGEROCHADE;
              NoZug^.nach:=c8  {groe}
            end
            else begin
              NoZug^.RochadeArt:=KURZEROCHADE;
              NoZug^.nach:=g8;
            end;     {kleine}
          end;
        end
        else begin      {Fischer-Rochade}
          if NoZug^.amZug=WEISS then begin
            NoZug^.von:=FRC^.FischerWhiteKing;
            if length(zug)>3 then begin
              NoZug^.RochadeArt:=LANGEFISCHERROCHADE;
              NoZug^.nach:=c1;  {von u. nach-Feld wird bei R. eigentlich nicht gebraucht, nimmt hier die Ausgangsfelder auf (Zielfelder bleiben ja gleich)}
            end
            else begin
              NoZug^.RochadeArt:=KURZEFISCHERROCHADE;
              NoZug^.nach:=g1;
            end;            {kleine}
          end
          else begin
            NoZug^.von:=FRC^.FischerBlackKing;
            if length(zug)>3 then begin
              NoZug^.RochadeArt:=LANGEFISCHERROCHADE;
              NoZug^.nach:=c8;  {groe}
            end
            else begin
              NoZug^.RochadeArt:=KURZEFISCHERROCHADE;
              NoZug^.nach:=g8;
            end;     {kleine}
          end;
        end;
      end
      else begin
        if not (length(zug)>=2) then
          begin analyse:=true; exit end; {Zug mu mind. 2 Zeichen lang sein}
        if length(zug)=2 then Figur:=NoZug^.amZug*wB
        else figur:=Figurenart(Zug[1]);
        if zug[length(zug)] in ['A'..'Z'] then NoZug^.UFigur:=Figurenart(zug[length(zug)]); {Umwandlung}
        feld:='';
        if zug[1] in ['A'..'Z'] then j:=1 else j:=0;  {bei Bauernzug steht kein Grobuchstabe davor}
        repeat
          inc(j);
          if zug[j]<>'x' then feld:=feld+Zug[j];
        until (j>=length(zug)) or ((zug[j] in ['1'..'9'])
        {es wird davon ausgegangen, da Zug mit Zahl abgeschlossen wird - "exd5" nicht "exd"}
              and (not (zug[j-1] in ['A'..'Z'])) {bei "e4" ist Schlu - aber nicht bei "N3d4"}
              and (not (zug[j+1] in ['a'..'z']))); {fr Flle wo z.B. Sd2e4 notiert werden mu}
        j:=ord(feld[length(feld)-1])-97; {vorletztes Zeichen ist Linie - "a" (ASCII=97) mu dabei 0 werden}
        val(feld[length(feld)], k, fehler);  {zuletzt mu Zahl stehen , die Reihe bezeichnet}
        if fehler<>0 then
          begin analyse:=true; exit end;
        dec(k);  {erste Reihe mu 0 werden}
        NoZug^.nach:=c((k*8)+j);
        NoZug^.geschlFigur:=NoStellung^[NoZug^.nach];
        if abs(Figur)=wB then begin
          if length(feld)=3 then begin {Schlagzug (ed5 o..)}
            NoZug^.von:= c((ord(feld[1])-97)+((k-NoZug^.amZug)*8));
            {Ausgangsfeld ist eine Reihe nach oben (abh. von NoZug^.amZug) und die Linie die im ersten Zeichen steht}
            if NoStellung^[NoZug^.nach]=LEER then begin
              NoZug^.epSchlag:=NoZug^.nach-(NoZug^.amZug*10);  {e.p,Schlag -  geschl. Bauern entfernen}
              NoZug^.geschlFigur:=-NoZug^.amZug;
            end;
          end
          else begin
            if NoStellung^[NoZug^.nach-(NoZug^.amZug*10)]<>LEER then NoZug^.von:=NoZug^.nach-(NoZug^.amZug*10)
            else begin
              NoZug^.von:=NoZug^.nach-(NoZug^.amZug*20); {Doppelschritt}
              NoZug^.epFeld:=NoZug^.nach-(NoZug^.amZug*10);
            end;
          end;
        end
        else begin
          inBetrachtindex:=0;
          {Index fr das Array, in dem alle Felder gespeichert werden, wo Figuren stehen, die aufs Zielfeld knnen}
          case abs(figur) of
            wD : sucheDame(NoZug^.nach, false);
            wT : sucheTurm(NoZug^.nach, false);
            wL : sucheLaeufer(NoZug^.nach, false);
            wS : sucheSpringer(NoZug^.nach, false);
            wK : sucheKoenig(NoZug^.nach, false);
          end;
          if inBetrachtindex<1 then
            begin analyse:=true; exit end;
          if inBetrachtindex>1 then begin  {mehr als eine Figur kann aufs Zielfeld}
            if length(Feld)>=3 then begin
            {entsprechende Figur durch Linien oder Reihenangabe bezeichnet ->zus. Zeichen an 1.Stelle (fg3 o.)}
              if length(Feld)=3 then begin
                for j:=1 to inBetrachtindex do begin
                  linie:=cc(inBetracht[j]) mod 8;
                  reihe:=cc(inBetracht[j]) div 8;
                  if feld[1] in ['1'..'8'] then begin
                    val(feld[1], hilf, fehler);
                    if Reihe=hilf-1 then begin
                      NoZug^.von:=inBetracht[j];  {hilf ergibt von 1-8, reihe aber von 0-7}
                      NoZug^.attr1:=NoZug^.attr1 or nDigit;
                      {zweites Bit von links bezeichnet, da in PGN-notation Ausgangsfeld der jeweiligen
                      Figur angegeben werden mu}
                    end;
                  end
                  else if ord(feld[1])-97=linie then begin
                    NoZug^.von:=inBetracht[j];
                    NoZug^.attr1:=NoZug^.attr1 or nLetter;
                  end;
                end;
              end
              else begin  {falls 3 Figuren aufs Zielfeld knnen Sd2e4 z.B.}
                val(feld[2], hilf, fehler);
                NoZug^.von:=c(((hilf-1)*8) + (ord(feld[1])-97));
                NoZug^.attr1:=NoZug^.attr1 or nDigit or nLetter;
              end;
            end
            else begin
              hilf := e1;
              for j:=0 to 63 do if NoStellung^[c(j)]=NoZug^.amZug*wK then hilf:=c(j); {Knigsfeld suchen}
              for j:=1 to inBetrachtindex do begin
                NoStellung^[inBetracht[j]]:=LEER; {erste mgliche Figur entfernen}
                if (not(sucheDame(hilf, true))) and (not(sucheTurm(hilf, true)))
                and (not(sucheLaeufer(hilf, true)))
                  then NoZug^.von:=inBetracht[j]; {kein Langschrittler kann Schach geben ->Figur war nicht gefesselt}
                NoStellung^[inBetracht[j]]:=figur;
              end;
            end;
          end
          else NoZug^.von:=inBetracht[1];
        end;
      end;
      tempbRett.Stellung:=NoStellung^;
      tempbRett.Zug:=NoZug^;
      case NoStellung^[NoZug^.von] of
        wT :  begin
                if NoZug^.von=h1 then NoZug^.Rochademoeglichkeiten:=NoZug^.Rochademoeglichkeiten-[wkr];
                if NoZug^.von=a1 then NoZug^.Rochademoeglichkeiten:=NoZug^.Rochademoeglichkeiten-[wlr];
              end;
        sT :  begin
                if NoZug^.von=h8 then NoZug^.Rochademoeglichkeiten:=NoZug^.Rochademoeglichkeiten-[skr];
                if NoZug^.von=a8 then NoZug^.Rochademoeglichkeiten:=NoZug^.Rochademoeglichkeiten-[slr];
              end;
        wK :  NoZug^.Rochademoeglichkeiten:=NoZug^.Rochademoeglichkeiten-[wkr, wlr];
        sK :  NoZug^.Rochademoeglichkeiten:=NoZug^.Rochademoeglichkeiten-[skr, slr];
      end;
      NoZug^.amZug:=-NoZug^.amZug;
      BaumEinfuegen(NoZug^);
      if Wurzelindex^.B=Nil then begin
        Wurzelindex^.B:=Baum;  {Anfang der Liste - wird mit Baum.B fortgesetzt}
        if assigned(Baumindex) then Baum^.rB:=Baumindex;
      end
      else begin
        Baum^.rB:=Baumindex;
        Baumindex^.B:=Baum;  {Verketten}
      end;
      Baumindex:=Baum;
      ZugVor;
      keineZuege:=false;
    end;
  until (i>=length(notat)) or (notat[i]='*') or (notat[i]='-');
  For i:=0 to RettBrettstack.Count-1 do dispose(RettBrettstack[i]);
  RettBrettstack.free;
  if keineZuege then begin dispose(wurzel);wurzel:=Nil;end;
end;

var slTemp : TStringlist;
    s : string;
    j : integer;
    p : TMoveChangeEvent;
    ZuegeStart : integer;
    FischerInfo : PFischerInfo;

begin
  Result:=0;
  p := FOnMoveChange;
  FOnMoveChange := Nil;  {Ereignis in DoIniPartie nicht aufrufen, da es anschlieend auch nach unvollst. Einlesen gemacht wird}
  IniPartie;
  FOnMoveChange := p;
  slTemp := TStringList.Create;
  New(FischerInfo);
  try
    j := 0;
    ZuegeStart := 0;
    slTemp.Text := PGNString;
    while j < slTemp.Count do begin
      s := trim(slTemp[j]);
      if (s <> '') and (s[1] <> '[') then break;
      if s = '' then break;
      SetEventData(FPartiedaten.EventData, s);
      inc(j);
    end;
    notat := '';
    while j < slTemp.Count do begin
      notat := notat + slTemp[j] + ' ';
      inc(j);
    end;
    FischerInfo.Enabled := false;
    if Partiedaten.EventData.FENString <> '' then
       FENToPos(Partiedaten.EventData.FENString,
       FPartiedaten.Stellung, FPartiedaten.Zug, FPartiedaten.Zugnummer, FischerInfo);
    if assigned(OnFischerinfo) then OnFischerInfo(self, FischerInfo^);  {an enabled kann Hauptprogramm erkennen, ob auf FRC umgestellt werden mu}
    notat := trim(notat);
    if notat = '' then exit;
    if analyse then { gibt bei Fehler(!) true}
    begin
      Result:=-1;
      if assigned(OnError) then OnError(self, mess[7+FEnglish]);   {Partie wurde zwar eingelesen, aber nicht vollstndig}
      gemeldet:=true;  {"klettere" wird noch ausgefhrt u. setzt das wieder auf false}
    end;
  finally
    slTemp.Free;
    Dispose(FischerInfo);
    Baumindex:=Nil;  {nach Stellung laden ist noch kein Zug indiziert}
    klettere(wurzel, true);
    if assigned(FOnMoveChange) then FOnMoveChange(self, Partiedaten.Zug, Partiedaten.Stellung, false)
  end;
end;

function TNotation.GetNextMoveNumberAsString : string;
begin
  if not assigned(Baumindex) then begin
    if Partiedaten.Zug.amZug = WEISS then Result := IntToStr(PartieDaten.ZugNummer) + '.'
    else Result := IntToStr(PartieDaten.ZugNummer) + '...';
  end
  else begin
    if Baumindex^.Zug.amZug = WEISS then Result := IntToStr(Baumindex^.ZugNummer + 1) + '...'
    else Result := IntToStr(Baumindex^.ZugNummer) + '.';
  end;
end;


function TNotation.notiereZug(z : TZug) : string;
Var s, sf : string;
    fnindex : integer; {index in Figurennamen (engl. u. Deutsche}

procedure SetAttrZwei;
begin
  case z.Attr2 of
    nAusruf : s := s + '!';
    n2Ausruf : s := s + '!!';
    nFrage : s := s + '?';
    n2Frage : s := s + '??';
    nAusrufFrage : s := s + '!?';
    nFrageAusruf : s := s + '?!';
  end;
end;

begin
  fnindex:=FEnglish*6;
  s:='';
  if z.Rochadeart<>LEER then begin
    case z.Rochadeart of
      KURZEROCHADE : s:='O-O';
      LANGEROCHADE : s:='O-O-O';
      KURZEFISCHERROCHADE : s:='o-o';
      LANGEFISCHERROCHADE : s:='o-o-o';
    end;  
    if z.attr1 and nSchach <> 0 then s:=s+'+';
    if z.attr1 and nMatt <> 0 then s:=s+'#';
    SetAttrZwei;
    Result:=s;
    exit;
  end;
  if (abs(NoStellung^[z.von])=wB) and (NoStellung^[z.nach]<>LEER)
  or (z.epschlag<>LEER) then begin
    s:=s+char((cc(z.von) mod 8)+97);
  end
  else if abs(NoStellung^[z.von])<>0 then s:=s+Figurnamen[abs(NoStellung^[z.von])+fnindex];
  if z.attr1 and nLetter <> 0 then s:=s+char((cc(z.von) mod 8)+97);
  if z.attr1 and nDigit <> 0 then s:=s+IntTostr((cc(z.von) div 8)+1);
  if (NoStellung^[z.nach]<>LEER) or (z.epschlag<>LEER) then s:=s+'x';
  s:=s+feldnamen[cc(z.nach)];
  if z.UFigur<>LEER then s:=s+'='+Figurnamen[abs(z.UFigur)+fnindex];
  if z.attr1 and nSchach <> 0 then s:=s+'+';
  if z.attr1 and nMatt <> 0 then s:=s+'#';

  SetAttrZwei;

  if abs(NoStellung^[z.von])=0 then
    if not gemeldet then begin
      if FEnglish = 1 then sf := 'Error reading moves.' else
      sf := 'Beim Einlesen der Zge ist ein Fehler aufgetreten.' + #13 +
      'Diese Partie sollte nicht gespeichert werden.';
      if assigned(OnError) then OnError(self, sf);
      gemeldet:=true;
    end;
  Result:=s;
end;

function TNotation.GetIndent(Font : TFont) : Integer;
begin
  if font = FFont1Var then Result := Indent1Var
  else if font = FFont2Var then Result := Indent2Var
  else Result := Indent0Var;
end;

function TNotation.GetNumber(index : integer) : longint;
begin
  Result := -1;
  if (index < wrap.count) and (wrap.count <> 0) then
    Result := StrToInt(trim(wrap[index]));
end;

function TNotation.NumberToString(nr : longint) : string;
begin
  Result := Format('%' + IntToStr(15) + 'd', [nr]);
end;

procedure TNotation.klettere(bl1 : PBaumlist; neu : Boolean);
var ersterZug : boolean;
    rStellung : TSchachbrett;
    rZug : TZug;
    i, Zugnummer : integer;
    inHauptvar : Boolean;
    b1 : PBaum;
    FontHauptVar : TFont;

procedure AddRet(f : TFont);
begin
  notat:=notat+' ';
  wrap.AddObject(NumberToString(length(notat) + 1), F);
end;

procedure formatiere;
Var hilf : String; {auch um FontBreite zu bestimmen}
    i, j, k, l : longint;
    Indent : integer;
    font : TFont;
    tw : integer;

procedure SetTw;
begin
  if i = 1 then begin
    if Partiedaten.Kommentar = '' then bf.canvas.Font.assign(Font)
    else bf.canvas.Font.assign(FontComment);
  end;
  if (notat[i] <> '}') and (notat[i] <> '{') then
  tw := tw + bf.canvas.textwidth(notat[i])
  else begin
    if (notat[i] = '}') then bf.canvas.Font.assign(Font)
    else bf.canvas.Font.assign(FontComment);
  end;
end;

begin
  try
    hilf:='';
    tw:=0;
    i:=0;
    l := 0;
    while i<length(notat) do begin
      inc(i);
      if i=GetNumber(l) then begin  {im ersten Element von wrap steht immer 1 (was Funkt. zurckgibt), so da die Font u. Indent immer zuerst init. werden}
        font := wrap.objects[l] as TFont;
        Indent := GetIndent(Font);
        SetTw;
        tw := bf.canvas.textwidth(notat[i]);
        inc(l);
      end
      else begin
        SetTw;
        if tw>=pb.width - Indent then begin
          hilf:='';
          j:=i;
          repeat
            hilf:=notat[i]+hilf; {ntig, falls ein langes Kommentarwort ohne Leerzeichen drinnen steht}
            dec(i);
          until (notat[i]=' ') or (i=0);
          k:=j-3;
          while (notat[j]<>' ') and (j<length(notat)) do begin
            inc(j);
            hilf:=hilf+notat[j];
          end;
          if bf.canvas.textwidth(hilf{+'    '})>=pb.width - Indent then {dann wars langes Wort - trennen}
            if k>2 then i:=k;
          if i=0 then exit; {dann war TNotat so eng , da RET am Anfang eingefgt werden sollte - nicht zulassen}

          wrap.AddObject(NumberToString(i + 1), Font);
          hilf:='';
          tw := 0;
        end;
      end;
    end;
  except
  end;
end;

procedure rek(b : PBaum);
Var rettbrett : TRettbrett;
    rettZugNummer : word;
    l : PBaumList;
begin
  if b=Nil then exit;  {drfte nicht auftreten}
  repeat
    inc(zugnummer);
    b^.ss := length(notat) + 1;  {selstart merken}
    b^.Zugnummer := (Zugnummer+1) shr 1;

    if odd(Zugnummer) then notat:=notat+inttostr((Zugnummer+1) shr 1)+'.'
    else if (klammerzu) or (klammerauf) or (ersterZug) {S in Ausgangsstllg. am Zug}
      then notat:=notat+inttostr((Zugnummer+1) shr 1)+'...';
    ersterZug:=false;
    klammerauf:=false;
    klammerzu:=false;
    NoZug^:=b^.Zug;
    notat:=notat+ notiereZug(NoZug^);
    B^.sl:=length(notat) - (b^.ss - 1);
    if length(b^.kommentar)>2 then begin
      if b^.kommentar[2]=' ' then delete(b^.kommentar, 2,1);
      {bei Zeilenumruch in Pgn-Datei kommt Leerzeichen vor Klammer - das mu raus}
      if b^.kommentar[length(b^.kommentar)-1]=' ' then delete(b^.kommentar, length(b^.kommentar)-1,1);
      if b^.kommentar<>'' then begin
        commwrap.AddObject(IntToStr(length(notat) + 2), Pointer(length(b^.Kommentar)));
        notat:=notat+' '+b^.kommentar;
      end;  
    end;
    if b^.VarWurzel<>Nil then begin

      inc(ebene);
      l:=b^.Varwurzel;
      repeat
        inHauptvar:=false;
        Rettbrett.Stellung:=NoStellung^;
        Rettbrett.Zug:=NoZug^;
        RettZugNummer := ZugNummer;
        dec(Zugnummer);
        klammerauf:=true;
        case ebene of
          1 : begin  {vorher Var. beendet ')'? - dann kein ret, weil es beim Beenden eingefgt wurde}
                if GetNumber(wrap.count - 1) + 1 <> length(notat) then
                  wrap.AddObject(NumberToString(length(notat) + 2), FFont1Var);
                notat:=notat+' [';
              end;
          2 : begin
                if GetNumber(wrap.count - 1) + 1 <> length(notat) then
                  wrap.AddObject(NumberToString(length(notat) + 2), FFont2Var);
                notat:=notat+' (';
              end;
          else notat:=notat+' (';
        end;

        if l^.B<>Nil then rek(l^.B);
        if GetNumber(wrap.count - 1) - 1 = length(notat)  {Zeilenumbruch vor Klammer?}
          then wrap.delete(wrap.count - 1);{raus}
        while notat[length(notat)]=' ' do delete(notat,length(notat),1);
        case ebene of
          1 : begin
                notat:=notat+']';
                wrap.AddObject(NumberToString(length(notat) + 2), FontHauptVar);
                inHauptvar:=true;
              end;
          2 : begin
                notat:=notat+')';
                wrap.AddObject(NumberToString(length(notat) + 2), FFont1Var);
              end;
          else notat:=notat+')';
        end;
        klammerzu:=true;
        NoStellung^:=Rettbrett.Stellung;
        NoZug^:=Rettbrett.Zug;
        ZugNummer:=RettZugnummer;
        l:=l^.BL;
      until l=Nil;
      dec(ebene);
    end;
    zugvor;
    if b=Baumindex then begin
      rStellung:=NoStellung^;
      rZug:=NoZug^;
      inHauptvariante:=inHauptvar;
    end;
    notat:=notat+' ';
    b:=b^.B;
  until b=Nil;
  gemeldet:=false;
end;

procedure OrtEintragen;
begin
  with Partiedaten.EventData do begin
    if (ort<>'') and (ort<>'?') then begin
       notat := notat + ort;
       if jahr<>0 then notat:=notat+', '
       else AddRet(FFontHeadLine);
    end;
    if jahr<>0 then begin
      notat:=notat+inttostr(jahr);
      AddRet(FFontHeadLine);
    end;
  end;
end;

function CheckVar : Boolean;
Var b : PBaum;
begin
  Result := false;
  if not assigned(bl1) then exit;
  try
    b := bl1^.B;
    while assigned(b) do begin
      if assigned(b^.VarWurzel) then begin
        Result := true;
        break;
      end;
      b := b^.b;
    end;
  except
  end;
end;

begin
  Wrap.Clear;
  CommWrap.Clear;
  inHauptvariante:=true;
  inHauptvar:=true;
  rStellung:=Partiedaten.Stellung;
  rZug:=Partiedaten.Zug;
  zugnummer:=(Partiedaten.zugnummer-1) shl 1;
  if Partiedaten.Zug.amZug=SCHWARZ then inc(zugnummer);
  NoStellung^:=Partiedaten.Stellung;
  if (not CheckVar) or (not FAutoBold) then FontHauptVar := FFont0Var
  else begin
    FontNoVar.assign(FFont0Var);
    FontNoVar.Style := FontNoVar.Style + [fsBold];
    FontHauptVar := FontNoVar;
  end;
  notat:='';
  UeberschriftEnde := 0;
  if ueberschrift then begin
    wrap.AddObject(NumberToString(1), FFontHeadLine);
    with Partiedaten.EventData do begin
      notat:=weiss;
      if (weiss <> '') and (schwarz <> '') then notat := notat +' - ';
      notat := notat + schwarz;
      AddRet(FFontHeadLine);
      if (Quelle<>'') and (Quelle<>'?') then begin
        notat:=notat + Quelle;
        if ((ort<>'') and (ort<>'?')) or (jahr <> 0) then begin
          notat:=notat + ', ';
          OrtEintragen;
        end
        else AddRet(FFontHeadLine);
      end
      else OrtEintragen;
      AddRet(FontHauptVar);
    end;
    UeberschriftEnde := length(notat);
  end
  else wrap.AddObject(NumberToString(1), FontHauptVar);
  if Partiedaten.kommentar<>'' then begin
    commwrap.AddObject(IntToStr(length(notat) + 1), Pointer(length(Partiedaten.Kommentar)));
    notat:=notat+Partiedaten.kommentar+' ';
  end;
  ebene:=0;  {daran werden Einrckungen gemessen}
  ersterZug:=true;
  if assigned(bl1) then begin
    b1:=bl1^.B;
    rek(b1);
  end;

  formatiere;

  if GetNumber(wrap.count - 1) - 1 <> length(notat)  {kein Zeilenumbruch?}
    then AddRet(FFont0Var);
  AddRet(FFontHeadLine);
  notat := notat+Partiedaten.EventData.Ergebnis;
  SLeiste.Max := wrap.Count;
  i := IsNewScrollbarPos(Baumindex);
  if (i <> -1) and (SLeiste.Position <> i) then SLeiste.Position := i
  else SLeiste.Change; {immer neu zeichnen - Change wird auch nach ndern von Position aufger.}

  NoStellung^:=rStellung;
  NoZug^:=rZug;
end;

procedure TNotation.AdjustPb(b : PBaum);
Var i : integer;
begin
  i := IsNewScrollbarPos(Baumindex);
  if (i <> -1) and (SLeiste.Position <> i) then SLeiste.Position := i
  else SetPbCaret;
end;

function TNotation.IsNewScrollbarPos(b : PBaum) : integer;
Var Linestart, i : longint;
Begin
  Result := -1;
  i := GetLineNumber(b, Linestart);
  if i <> -1 then begin
    if i >= LastLine then Result := i - ((LastLine - FirstLine) shr 1)
    else if i + 1 < FirstLine then begin
      Result := i - ((LastLine - FirstLine) shr 1);
      if Result < 0 then Result := 0;
    end;
  end
  else if FirstLine <> 1 then Result := 0
end;

function TNotation.GetLineNumber(b : PBaum; Var Linestart : longint) : integer;
begin
  Result := -1;
  if assigned(B) then begin
    wrap.Find(NumberToString(B^.ss), Result);
    if wrap.Count > Result then begin
      LineStart := StrToInt(trim(wrap.strings[Result]));
      if Linestart <> B^.ss then begin
        dec(Result);
        if wrap.Count > Result then Linestart := StrToInt(trim(wrap.strings[Result]))
        else Result := -1;
      end;
    end
    else Result := -1;
  end;
end;

function TNotation.GetTextWidth(ALine, a, l : integer) : integer;
Var k : integer;
    szeile : string;
    slf : TStringlist;
begin
  Result := 0;
  try
    slf := TStringlist.Create;
    try
      SetFontsInLine(slf, a, l, wrap.objects[ALine] as TFont, FontComment);
      k := 0;
      while k < slf.count - 1 do begin
        bf.Canvas.Font.Assign(slf.Objects[k] as TFont);
        szeile := copy(notat, StrToInt(slf[k]), StrToInt(slf[k + 1]) - StrToInt(slf[k]));
        szeile := DeleteCommKlammer(szeile);
        Result := Result + bf.canvas.TextWidth(szeile);
        inc(k);
      end;
    finally
      slf.free;
    end;
  except
  end;
end;

procedure TNotation.SetPbCaret;
Var i, LineStart : longint;
    pbIndent : integer;
begin
  if assigned(rNotatBaumindex) then begin
    if IsNewScrollbarPos(rNotatBaumindex) = -1 then begin
      pb.canvas.Font.assign(rFont);
      pb.canvas.TextOut(ZugRect.Left, ZugRect.Top,
      copy(notat, rNotatBaumindex^.ss, rNotatBaumindex^.sl));
    end;
  end;
  rNotatBaumindex := Baumindex;

  i := GetLineNumber(Baumindex, Linestart);
  if i <> -1 then begin
    pb.canvas.Font.assign(wrap.objects[i] as TFont);
    pbIndent := GetIndent(wrap.objects[i] as TFont);
    rFont.assign(pb.canvas.Font);

    ZugRect.Left := pbIndent +   {!!!bei [Italic] + not TrueType klappt das nicht}
      GetTextWidth(i, LineStart, Baumindex^.ss - Linestart);
    ZugRect.Right := ZugRect.Left +
      pb.canvas.TextWidth(copy(notat, Baumindex^.ss, Baumindex^.sl));
    ZugRect.Top := TextHoehe * (i + 1 - FirstLine);
    ZugRect.Bottom := ZugRect.Top + TextHoehe;

    if (ZugRect.Top >= 0) and  {sonst wird herausgescrollte Zeile z.T. angezeicgt}
    (Zugrect.Top < (Lastline - FirstLine + 1) * Texthoehe) then begin
      pb.canvas.Brush.Color := clBlack;
      pb.canvas.Font.Color := clWhite;
      pb.canvas.TextOut(ZugRect.Left, ZugRect.Top,
      copy(notat, Baumindex^.ss, Baumindex^.sl));
      pb.canvas.Brush.Color := clSilver;
      pb.canvas.Font.Color := clBlack;
    end;
  end;
end;

procedure TNotation.SetFontsInLine(sl : TStringlist; a, l : integer; f, fc : TFont);
Var i, ca, cl, commi : integer;

function SetComm : Boolean;
begin
  inc(commi);
  if commi < commwrap.count then begin
    ca := StrToInt(commwrap[commi]);
    cl := longint(commwrap.Objects[commi]);
    Result := true;
  end
  else begin
    ca := -1;
    cl := -1;
    Result := false;
  end;
end;

begin
  commi := -1;
  sl.Clear;
  sl.AddObject(IntTostr(a), f);
  while SetComm do begin
    if (ca <= a) and (ca + cl > a) then begin  { Zeile geht mit Komm. los }
      sl.Objects[0] := fc;
      if ca + cl >= a + l then break;  { ausschlielich Komm. }
      sl.AddObject(IntTostr(ca + cl), f);
    end;
    if (ca > a) and (ca < a + l) then begin  { Komm. geht in Zeile los}
      if (ca + cl < a + l) then begin { Komm. dazwischen }
        sl.AddObject(IntTostr(ca), fc);
        sl.AddObject(IntTostr(ca + cl), f);
      end
      else begin      { Komm. geht dann weiter }
        sl.AddObject(IntTostr(ca), fc);
        break;
      end;
    end;
    if ca > a + l then break;
  end;
  sl.AddObject(IntTostr(a + l), Nil);
end;

function TNotation.DeleteCommKlammer(szeile : string) : string;
Var m : integer;
begin
  Result := szeile;
  m := Pos('{', Result);
  if m <> 0 then delete(Result, m, 1);
  m := Pos('}', Result);
  if m <> 0 then delete(Result, m, 1);

end;

procedure TNotation.PaintPb;
Var szeile : string;
    i, j, k, l, hdiff, diff, Indent : integer;
    inotata, inotate : integer;
    slf : TStringList;

begin
try
  slf := TStringList.Create;
  try
    pb.canvas.brush.Color := color;
    pb.canvas.pen.Color := color;
    pb.canvas.rectangle(0, 0, pb.width, pb.height);
    j := 0;
    i := 0;
    while i < wrap.count do begin
      if (i >= FirstLine - 1) and (i <= LastLine - 1) then begin
        pb.canvas.Font := FontComment;
        hdiff := pb.canvas.TextHeight('Wg');
        pb.canvas.Font.assign(wrap.objects[i] as TFont);
        hdiff := (pb.canvas.TextHeight('Wg') - hdiff) shr 1;
        inotata := GetNumber(i);
        inotate := GetNumber(i + 1);
        if inotate = -1 then inotate := length(notat) + 1;
        if i < wrap.count - 1 then l := inotate - inotata
        else l := length(notat);
        Indent := GetIndent(wrap.objects[i] as TFont);

        SetFontsInLine(slf, inotata, l, wrap.objects[i] as TFont, FontComment);
        k := 0;
        while k < slf.count - 1 do begin                                   
          if slf.Objects[k] as TFont <> FontComment then diff := 0
          else diff := hdiff;
          pb.Canvas.Font.Assign(slf.Objects[k] as TFont);
          szeile := copy(notat, StrToInt(slf[k]), StrToInt(slf[k + 1]) - StrToInt(slf[k]));
          szeile := DeleteCommKlammer(szeile);
          pb.canvas.TextOut(Indent, TextHoehe * j + diff, szeile);
          Indent := Indent + pb.canvas.TextWidth(szeile);
          inc(k);
        end;
        inc(j);
      end;
      inc(i);
    end;
    rNotatBaumindex := Nil;
    SetPbCaret;
  finally
    slf.free;
  end;
except
end;
end;

procedure TNotation.SetNotatBounds(pos : longint);
begin
  FirstLine := pos + 1;
  LastLine := FirstLine + (pb.height div TextHoehe) - 1;
end;

procedure TNotation.DoMouseDown(x, y : integer);
Var z, i : longint;
    s : string;
    Indent, inotata, inotate, l, tw, islf, j, diff : integer;
    slf : TStringList;
begin
  slf := TStringList.Create;
  try
    if (Lastline - Firstline + 1) * Texthoehe < Y then exit;
    z := FirstLine + (y div TextHoehe) - 1;
    if z < wrap.count then begin
      i := StrToInt(trim(wrap.strings[z]));
      pb.canvas.Font.assign(wrap.Objects[z] as TFont);
      Indent := GetIndent(wrap.Objects[z] as TFont);

      inotata := GetNumber(z);
      inotate := GetNumber(z + 1);
      if inotate = -1 then inotate := length(notat) + 1;
      if z < wrap.count - 1 then l := inotate - inotata
      else l := length(notat);

      SetFontsInLine(slf, inotata, l, wrap.objects[z] as TFont, FontComment);
      islf := 0;
      tw := Indent;
      diff := 0;
      while islf < slf.count - 1 do begin
        bf.canvas.font.assign(slf.Objects[islf] as TFont);
        s := copy(notat, StrToInt(slf[islf]), StrToInt(slf[islf + 1]) - StrToInt(slf[islf]));
        j := length(s);
        s := DeleteCommKlammer(s);
        diff := diff + (j - length(s));
        j := 1;
        while j <= length(s) do begin
          tw := tw + bf.canvas.TextWidth(s[j]);
          if tw > x then break;          
          inc(i);
          inc(j);
        end;
        if tw > x then break;
        inc(islf);
      end;
      i := i + diff;
      if retract(i) then begin    {gibt nur true zurck, wenn auch ein Zug angeklickt wurde}
        if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false)
      end
    end;
  finally
    slf.free;
  end;
end;

{------------------------
 Methoden Pb und SLeiste
------------------------}

procedure TNotatPaintbox.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if Button = mbLeft then (Parent as TNotation).DoMouseDown(X, Y);
end;

procedure TNotatPaintbox.paint;
begin
  inherited paint;
  (parent as TNotation).paintpb;
end;

procedure TNotatScrollbar.Change;
begin
  inherited Change;
  (parent as TNotation).SetNotatBounds(Position);
  (parent as TNotation).paintpb;
end;

{--------------------------------}


procedure TNotation.loescheBaum(Pbl1 : PPBaumList);
var  bl1 : PBaumlist;

procedure rek(bl : PBaumlist);
var l : PBaumList;
    lr : TBaumlist;
    br, b : PBaum;
begin
 try
  b:=bl^.B;
  if b=Nil then exit;
  repeat
    if b^.VarWurzel<>Nil then begin
      l:=b^.Varwurzel;
      repeat
        lr:=l^;
        if l^.BL<>Nil then rek(l^.BL);
        l:=lr.BL;
      until l=Nil;
    end;
    b^.kommentar:='';
    br:=b;
    b:=b^.B;
    dispose(br);
  until b=Nil;
 except
 end;
end;

begin
 bl1:=Pbl1^;
 if bl1=Nil then exit;  {drfte nicht auftreten}
 rek(bl1);
 try
  if bl1^.BL=Nil then begin
    if bl1^.rBL=Nil then begin  {dann mu bl Wurzel oder VarWurzel sein}
      dispose(bl1);
      Pbl1^:=Nil;
    end
    else begin
      bl1^.rBL^.BL:=Nil;  {neues Ende im vorhergehenden Eintrag}
      dispose(bl1);
    end;
  end
  else begin
    if bl1^.rBL=Nil then begin  {nchster Eintrag mu dann in Wurzel o. VarWurzel kopiert werden}
      Pbl1^:=bl1^.BL;
      bl1^.Bl^.rBL:=Nil; 
      dispose(bl1);
    end
    else begin
      bl1^.BL^.rBL:=bl1^.rBL;
      bl1^.rBL^.BL:=bl1^.BL;
      dispose(bl1);
    end;
  end;
 except
 end;
end;

function TNotation.retract(NotatSelstart  : longint) : Boolean;
var i, j, k : longint;
    sZug, fehler, zugzahl, zahl : integer;
    space, punkt : boolean;
    zahlwort, fahrplan : string;

procedure suche;
var iFahrplan : integer;
    e : boolean;
    z : integer;
    rBaumindex : PBaum;
begin
  NoStellung^:=Partiedaten.Stellung;
  wurzelindex:=wurzel;
  iFahrplan:=1;
  z:=0;
  if wurzelindex^.B=Nil then exit; 
  Baumindex:=Wurzelindex^.B;
  rBaumindex:=Baumindex;
  while (Baumindex<>Nil) and (z<zugzahl) do begin
    if Baumindex^.VarWurzel<>Nil then begin
      e:=false;
      Wurzelliste:=Baumindex^.VarWurzel;
      while (not(iFahrplan>length(Fahrplan))) and (not e) do begin
        if Fahrplan[iFahrplan]='0' then begin
          if Wurzelliste^.BL=Nil then e:=true
          else Wurzelliste:=Wurzelliste^.BL;
        end
        else begin
          if Wurzelliste^.B=Nil then exit; {drfte nicht auftreten}
          inHauptvariante:=false;
          Baumindex:=Wurzelliste^.B;
          e:=true;
        end;
        inc(iFahrplan);
      end;
    end;
    NoZug^:=Baumindex^.Zug;
    zugvor;
    rBaumindex:=Baumindex;
    Baumindex:=Baumindex^.B; {Baumindex bleibt auf einem Zug nach dem angeklickten stehen}
    inc(z);
  end;
  Baumindex:=rBaumindex;      {Baumindex auf angeklickten Zug}
  NoZug^:=Baumindex^.Zug;
(*  zugnummer:=z-1;*)
end;

function springe(c : char; j : longint) : longint;
var
    c1 : char;
    e : integer;
begin
  case c of
    ')' : c1:='(';
    '}' : c1:='{';     {in Kommentaren geschweifte Klammern nicht zulassen!}
    ']' : c1:='[';
  end;
  e:=1;
  while (e<>0) and (j>1) do begin
    dec(j);
    if (c1 <> '{') and (notat[j] = '}') then j := springe('}', j);
    if notat[j]=c then inc(e);
    if notat[j]=c1 then dec(e);
  end;
  Result:=j;
end;

begin
  Result:=false;
  i:=1;
  zugzahl:=0;
  space:=false;
  punkt:=false;
  fahrplan:='';
  k:=0;
  if notat='' then exit;
  (**)
  if (ueberschrift) and (NotatSelstart <= UeberschriftEnde)  then exit;  {da stand selstart auf berschrift - die kann auch am Anfang sein}
  if length(notat) <= NotatSelstart then exit;  {dann stehen keine Zge drinnen}

  i:=NotatSelstart;
  if (notat[i]='}') or (notat[i]='{') then exit; {im Kommentar (dort drfen keine { stehen) ? --> raus}
  j:=i;
  k:=0;
  while (j>0) and (notat[j]<>'{') and (k=0) do begin
    if notat[j]='}' then k:=1;
    dec(j);
  end;
  if ((j > 0)(**) and (notat[j]='{')) and (k = 0) then exit;
  k:=0;
  while (i<length(notat)) and (notat[i] in sonderzeichen) do inc(i); {von ev. Sonderzeichen weg}
  if (i > 1) and (notat[i - 1] = '{') then exit; (**)
  while (i<length(notat)) and (not(notat[i] in sonderzeichen)) do begin
    inc(i); {hinter Zug setzen - es gibt nach Komm. auch Zge ohne 1. (Punkt)}
  end;
  if notat[i]='}' then exit;  {dann wars im Kommentar}
  if (i<2) or (i>=length(notat)) then exit;  {deckt auch Klick auf Ergebnis ab}
  j:=i-1;
  dec(i);  {steht sonst auf Leer}
  sZug:=-1;
  {wenn Cursor auf "1.wZug" steht wird Zugnummer verdoppelt und es mu ein Halbzug (kein schw. Zug dazu!) abgezogen werden}
  while (i>UeberschriftEnde) do begin
    if (notat[i]='(') or (notat[i]='[') then fahrplan:='1' + fahrplan;
    if (notat[i]=')') or (notat[i]='}') or (notat[i]=']') then begin
      i:=springe(notat[i], i);
      if (notat[i]='(') or (notat[i]='[')
      then fahrplan:='0' + fahrplan;
    end;
    if (notat[i]=' ') or (notat[i]=#$D) then  {auch Zeilenspung beachten}
    if (punkt=false) and (space=false) then begin
      sZug:=0; {s. Zug - davor steht keine Nummer - gerade Halbzugzahl}
      space:=true;
      k:=i;
    end;
    if notat[i]='.' then if punkt=false then begin
      while (i>0) and (not(notat[i] in ['0'..'9'])) do begin
        dec(i);  {Zugnummer lesen}
      end;
      if i+2<length(notat) then
        if notat[i+2]='.' then sZug:=0;
        {auch vor s. Zug kann 1... (Zugnummer) stehen - in dem Fall gerade Halbzugzahl (Zugnummer shl 1)}
      while (i>0) and (notat[i] in ['0'..'9']) do begin  {wegen 2/3 stelligen Nummern}
        zahlwort:=notat[i]+zahlwort;
        dec(i);
      end;
      if i=1 then dec(i);  {an erster Stelle wurde Schleife auf Zugnummer - nicht davor - abgebrochen}
      if k=0 then k:=i;  {nur wenn kein s. Zug markiert werden mu}
      inc(i);  {weil es am Ende noch einmal dec. wird - wrde sonst Klammern usw. bersehen}
      val(zahlwort , zahl, fehler);
      if fehler<>0 then exit;  {drfte nicht auftreten}
      zahl:=zahl-(Partiedaten.Zugnummer-1);
      zahl:=zahl shl 1;
      if Partiedaten.Zug.amZug=-1 then dec(zahl); {wenn Schwarz am Zug in Ausgangsstellung, mu dec. werden}
      zugzahl:=zahl+sZug;  {Anzahl Halbzge ist gefragt}
      punkt:=true;
      space:=true;
    end;
    dec(i);
  end;
  if notat[k] = #$D then inc(k);        (**)
 (* wrapselstart:=k;
  wrapsellength:=abs(k-j);*)
  inHauptvariante:=true;  {wird in Suche ev. falsch, falls im Fahrplan 1 enthalten ist u. dadurch Var. eingetaucht wird}
  suche;
  SetPbCaret;     (**)
  Result:=true;
end;

procedure TNotation.KeyDown(Var Key: Word; Shift: TShiftState);

procedure ChangeLine(summand : integer);
Var i, j, Linestart, NextLinestart, Next2Linestart, NotatSelstart : longint;
    e : Boolean;
function Checkmove(nss : longint) : Boolean;
begin
  Result := false;
  if retract(NotatSelstart) then begin
    i := IsNewScrollbarPos(Baumindex);
    if (i <> -1) and (SLeiste.Position <> i)
      then SLeiste.Position := i;
    if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
    Result := true;
  end
end;

begin
  i := GetLineNumber(Baumindex, Linestart);
  if i = -1 then exit;
  if (wrap.Count > i + summand) and (i + summand >= 0) then begin
    j := (Baumindex^.sl shr 1) + Baumindex^.ss - Linestart;
    NextLinestart := StrToInt(trim(wrap.strings[i + summand]));
    if summand = -1 then begin
      if NextLineStart + j < LineStart
        then NotatSelstart := NextLineStart + j
      else NotatSelstart := Linestart - 3;
    end
    else begin
      if wrap.Count > i + summand + 1 then
        Next2Linestart := StrToInt(trim(wrap.strings[i + summand + 1]))
      else exit;
      if NextLineStart + (Baumindex^.ss - Linestart) < Next2LineStart
        then NotatSelstart := NextLineStart + j
      else NotatSelstart := Next2Linestart - 3;
    end;
    if NotatSelstart > length(notat) then NotatSelstart := length(notat) - 3;
    if NotatSelstart < 1 then NotatSelstart := 1;
    while(NotatSelstart > 1) and (notat[NotatSelstart] = ' ') do dec(NotatSelstart);
    if not CheckMove(NotatSelstart) then begin
      e := false;
      if summand = -1 then begin
        i := 0;
        if wrap.count > FirstLine - 1 then i := StrToInt(trim(wrap.strings[FirstLine - 1]));
        while (NotatSelstart > i) and (length(notat) >= NotatSelstart) do begin
          if ((notat[Notatselstart] in ['1'..'8']) and (notat[Notatselstart - 1] in ['a'..'h'])) or
          (upcase(notat[Notatselstart]) = 'O') and (notat[Notatselstart - 1] = '-') then begin
            if CheckMove(NotatSelstart) then begin
              e := true;
              break;
            end;
          end;
          dec(NotatSelstart);
        end;
      end
      else begin
        i := length(notat);
        if wrap.count > LastLine - 1 then i := StrToInt(trim(wrap.strings[LastLine - 1]));
        while (NotatSelstart < i) and (length(notat) > NotatSelstart) do begin
          if ((notat[Notatselstart + 1] in ['1'..'8']) and (notat[Notatselstart] in ['a'..'h'])) or
          (upcase(notat[Notatselstart + 1]) = 'O') and (notat[Notatselstart] = '-') then begin
            if CheckMove(NotatSelstart) then begin
              e := true;
              break;
            end;
          end;
          inc(NotatSelstart);
        end;
      end;
      if not e then SLeiste.Position := SLeiste.Position + summand;
    end;
  end;
end;

begin        (**)
  inherited keyDown(key, shift);
  case key of
    38 : ChangeLine(-1);
    40 : ChangeLine(1);
    33 : GoPreviousVar;
    34 : GoNextVar;
    36 : GotoStart;
    35 : GotoEnd;
    39 : GoAhead;
    37 : GoBack;
  end;
end;

procedure TNotation.NeueStellung(Stellung : TSchachbrett; Zug : TZug; z : integer);
begin
  geaendert:=true;
  UD:=0;
  if z<>-1 then FPartiedaten.Zugnummer:=z;
  FPartiedaten.Stellung:=Stellung;
  FPartiedaten.Zug:=Zug;
  NoStellung^:=Stellung;
//.  ResetEventData(FPartiedaten.EventData);
  LoescheNotatImFenster;
end;

procedure TNotation.LoescheNotatImFenster;
begin
  UD:=0;
  if UDWurzel<>Nil then begin
    ZBaumlist:=addr(UDWurzel);
    loescheBaum(ZBaumlist);
  end;
  if wurzel<>Nil then begin
    ZBaumlist:=addr(wurzel);
    loescheBaum(ZBaumlist);
  end;
  Baumindex:=Nil;
  Klettere(wurzel, true);
end;


procedure TNotation.Dialog_ini;
Var P : TPoint;
begin
  VarDialog:=TForm.Create(self);
  with VarDialog do begin
    Font.Name:='MS Sans Serif';
    Font.Size:=8;
    width:=255;
    height:=147;
    BorderIcons:=[biSystemMenu];
  end;
  P.X:=0;
  P.Y:=Height;
  P:=ClientToScreen(P);
  if P.X+VarDialog.Width>Screen.Width then P.X:=P.X-(P.X+VarDialog.Width-Screen.Width);
  if P.Y+VarDialog.Height>Screen.Height then P.Y:=P.Y-(P.Y+VarDialog.Height-Screen.Height);
  VarDialog.Top:=P.Y;
  VarDialog.Left:=P.X;
end;

procedure TNotation.Varianten_anzeigen(keineZuege : Boolean);
Var hs : string;
    j : integer;
begin
  with lZuege do begin
    left:=10;
    top:=10;
    Font.Style:=Font.Style+[fsBold];
    hs:='';
    if keineZuege then begin
      if Partiedaten.Zug.amZug=WEISS then hs:='.'
      else hs:='...';
    end
    else begin
      if baumindex^.Zug.amZug=WEISS then begin (**)
        hs:='.';
      end
      else hs:='...';
    end;
    j:=65;
    if keineZuege then begin
      wurzelindex:=Baumindex^.VarWurzel;
      Items.add('A) '+IntTostr(Baumindex^.zugnummer)+hs+notiereZug(Baumindex^.Zug));
    end
    else begin
      wurzelindex:=Baumindex^.B^.VarWurzel;
      Items.add('A) '+IntTostr(Baumindex^.B.zugnummer)+hs+notiereZug(Baumindex^.B.Zug));
    end;
    while assigned(wurzelindex) do begin
      inc(j);
      if assigned(wurzelindex^.B) then
        Items.add(chr(j)+') '+IntTostr(wurzelindex^.B.zugnummer)+hs+notiereZug(wurzelindex^.B^.Zug));
      wurzelindex:=wurzelindex^.BL;
    end;
    Itemindex:=0;
  end;
end;

function TNotation.AddZug(Zug : TZug) : Boolean;
var linie, reihe, hr, hl, j : byte;
    keineZuege : Boolean;
    rS : TSchachBrett;
    z3, z50, rnach, rFigur, ramZug, rep : integer;
    rRochademoeglichkeiten : TRochademoeglichkeiten;
    e, first, gleich : Boolean;
    rB : PBaum;
begin
  Result:=true;
  UD:=0;
  Zug.attr1:=0;  {ntig, weil es von TBrett u. TMiniMax nicht behandelt u. undefiniert bergeben wird}
  Zug.attr2:=0;
  if not assigned(wurzel) then begin  {bei Hauptvar. - also Partie lschen -, wir Wurzel freigegeben}
    New(wurzel);
    wurzel^.BL:=Nil;
    Wurzel^.rBL:=Nil;
    wurzel^.B:=Nil;
  end;
  if not assigned(Baumindex) then begin
    Baumindex:=Wurzel^.B; {Sonderfall - kein Zug markiert}
    keineZuege:=true;
  end else keineZuege:=false;
  if not assigned(Baumindex) then begin
    BaumEinfuegen(Zug);
    Wurzel^.B:=Baum;
    Baumindex:=Baum;
  end
  else begin
    if (not assigned(Baumindex^.B)) and (keineZuege=false) then begin
      BaumEinfuegen(Zug);
      Baum^.rB:=Baumindex;
      Baumindex^.B:=Baum;
      Baumindex:=Baum;
    end
    else begin
      Dialog_ini;
      if English then VarDialog.Caption:='Enter new move' else VarDialog.Caption:='Neuen Zug eingeben';
      Einfuegen:=TButton.Create(self);
      with Einfuegen do begin
        ModalResult:=mrOk;
        left:=140;
        top:=10;
        width:=100;
        if English then Caption:='New variation' else Caption:='Neue Variante';
      end;
      VarDialog.insertControl(Einfuegen);
      Ueberschreiben:=TButton.Create(self);
      with Ueberschreiben do begin
        ModalResult:=mrIgnore;
        left:=140;
        top:=40;
        width:=100;
        if English then Caption:='Overwrite' else Caption:='berschreiben';
      end;
      VarDialog.insertControl(Ueberschreiben);
      Abbruch:=TButton.Create(self);
      with Abbruch do begin
        ModalResult:=mrCancel;
        left:=140;
        top:=83;
        width:=100;
        if English then Caption:='Cancel' else Caption:='Abbruch';
      end;
      VarDialog.insertControl(Abbruch);
      lZuege:=TListBox.Create(self);
      VarDialog.insertControl(lZuege);
      Varianten_anzeigen(keineZuege);
      case VarDialog.Showmodal of
        mrOK     : begin
                     if keineZuege=false then Baumindex:=Baumindex^.B; {Sonderfall - kein Zug markiert}
                     wurzelindex:=Baumindex^.VarWurzel;
                     VarEinfuegen;  {wurzelindex zeigt danach auf neue Variantenwurzel}
                     BaumEinfuegen(Zug);
                     Baum^.rB:=Baumindex;
                     wurzelindex^.B:=Baum;
                     Baumindex:=Baum;
                   end;
        mrIgnore : begin  {berschreiben}
                     New(Wurzelindex);
                     Wurzelindex^.BL:=Nil;
                     Wurzelindex^.rBL:=Nil;
                     if keineZuege then Wurzelindex^.B:=Baumindex
                     else Wurzelindex^.B:=Baumindex.B;
                     ZBaumlist:=addr(Wurzelindex);
                     loescheBaum(ZBaumlist);  {dabei wird auch wurzelindex wieder frei}
                     BaumEinfuegen(Zug);
                     if keineZuege then begin
                       Baum^.rB:=Nil;
                       Wurzel^.B:=Baum;
                     end
                     else begin
                       Baum^.rB:=Baumindex;
                       Baumindex^.B:=Baum;
                     end;
                     Baumindex:=Baum;
                   end;
        mrCancel : begin
                     if keineZuege then Baumindex:=Nil;
                     if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
                     Result:=false;
                     exit;
                   end;
      end;
      Ueberschreiben.Free;
      Einfuegen.Free;
      Abbruch.Free;
      lZuege.Free;
      VarDialog.free;
    end;
  end;
  NoZug^:=Zug;
  NoZug^.attr1:=0;  {ntig, weil es von TBrett u. TMiniMax nicht behandelt u. undefiniert bergeben wird}
  NoZug^.attr2:=0;
  inBetrachtindex:=0;  {Index fr das Array, in dem alle Felder gespeichert werden, wo Figuren stehen,die auf Zielfeld knnen}
  NoZug^.amZug:=-NoZug^.amZug;
  case abs(NoStellung^[NoZug^.von]) of
    wD : sucheDame(NoZug^.nach, false);
    wT : sucheTurm(NoZug^.nach, false);
    wL : sucheLaeufer(NoZug^.nach, false);
    wS : sucheSpringer(NoZug^.nach, false);
    wK : inBetrachtindex:=1;
    wB : inBetrachtindex:=1;
  end;
  NoZug^.amZug:=-NoZug^.amZug;
  if inBetrachtindex>1 then begin
    hl:=cc(NoZug^.von) mod 8;
    hr:=cc(NoZug^.von) div 8;
    for j:=1 to inBetrachtindex do begin
      if inBetracht[j]<>NoZug^.von then begin
        linie:=cc(inBetracht[j]) mod 8;
        reihe:=cc(inBetracht[j]) div 8;
        {eine andere Figur knnte aufs Zielfeld - Ausganslinie/-Reihe wird in NotiereZug eingefgt bei attr1<>0}
        if hr=reihe then Baumindex^.Zug.attr1:=Baumindex^.Zug.attr1 or nLetter;
        if hl=linie then Baumindex^.Zug.attr1:=Baumindex^.Zug.attr1 or nDigit;
      end;
    end;
    {Falls zweite in Frage kommende Figur weder auf derselben Linie noch Reihe (Springer) steht - Buchstabe}
    if Baumindex^.Zug.attr1 and nDigit = 0 then Baumindex^.Zug.attr1:=Baumindex^.Zug.attr1 or nLetter;
  end;
  zugvor;
  j:=0;  {Schachprfung}
  while (NoStellung^[c(j)]<>NoZug^.amZug*wK) and (j<=63) do inc(j);
  if sucheDame(c(j), true) or sucheTurm(c(j), true) or sucheLaeufer(c(j), true)
  or sucheSpringer(c(j), true) or sucheBauer(c(j), true) then
    Baumindex^.Zug.attr1:=Baumindex^.Zug.attr1 or nSchach;
  klettere(wurzel, true);
  geaendert:=true;
                  {Prfen auf 50 Zge-Regel u. 3-fache Stellungswiederholung}
  rS:=NoStellung^;
  z3:=1;
  rnach:=Baumindex^.Zug.nach;
  rFigur:=NoStellung^[Baumindex^.Zug.nach];
  rRochademoeglichkeiten:=Baumindex^.Zug.Rochademoeglichkeiten;
  rep:=Baumindex^.Zug.epFeld;
  ramZug:=Baumindex^.Zug.amZug;
  z50:=0;
  e:=false;
  rB:=Baumindex;
  first:=true;        {rckwrts prfen}
  while (assigned(rB)) and (z50<100) and (not e) and (z3<3) do begin
    if (rB^.Zug.Rochadeart<>LEER) or (rB^.Zug.epSchlag<>LEER)
    or (rB^.Zug.geschlFigur<>LEER) or (abs(rS[rB^.Zug.nach])=wB)
    or (rB^.Zug.UFigur<>LEER) then e:=true;
    if not e then begin
      if not first then begin
        if rS[rnach]=rFigur then begin
          gleich:=true;
          For j:=0 to 63 do if NoStellung^[c(j)]<>rS[c(j)] then gleich:=false;
          if (rRochademoeglichkeiten=rB^.Zug.Rochademoeglichkeiten)
          and (rep=rB^.Zug.epFeld) and (ramZug=rB^.Zug.amZug) and (gleich) then inc(z3);
        end;
      end else first:=false;
      rS[rB^.Zug.von]:=rS[rB^.Zug.nach];
      rS[rB^.Zug.nach]:=LEER;  {Zug zurck}
      if assigned(rB^.rB) and (rB^.Zug.amZug=rB^.rB^.Zug.amZug) then {an Verzweigung gekommen}
        rb:=rB^.rB^.rB
      else rB:=rB^.rB;
      inc(z50);
    end;
  end;
  if (not assigned(rB)) and (not e) then begin
    gleich:=true;
    For j:=0 to 63 do if NoStellung^[c(j)]<>Partiedaten.Stellung[c(j)] then gleich:=false;
    if (rRochademoeglichkeiten=Partiedaten.Zug.Rochademoeglichkeiten)
    and (rep=Partiedaten.Zug.epFeld) and (ramZug=Partiedaten.Zug.amZug) and (gleich)
      then inc(z3);
  end;
  if z3=3 then if assigned(On3Repetition) then On3Repetition(self);
  if z50=100 then if assigned(On50MovesRule) then On50MovesRule(self);
end;

procedure TNotation.loesche_UD;
begin
  if assigned(UDWurzel) then begin
    ZBaumlist:=addr(UDWurzel);
    loescheBaum(ZBaumlist);
  end;
  New(UDWurzel);
  UDWurzel^.rBL:=Nil;
  UDWurzel^.BL:=Nil;
  UD:=0;
end;

procedure TNotation.schneide(wie : Boolean);
begin
  if not assigned(Baumindex) then exit;  {kein Zug gewhlt - Ausgangsstellung}
  if wie then begin
    if assigned(Baumindex^.B) then begin
      geaendert:=true;
      New(Wurzelindex);
      Wurzelindex^.BL:=Nil;
      Wurzelindex^.rBL:=Nil;
      Wurzelindex^.B:=Baumindex.B;

      loesche_UD;
      UD:=-1;
      UDWurzel^.B:=Baumindex^.B;
      UDBi:=Baumindex;

      Baumindex.B:=Nil;
      klettere(wurzel, true);
    end;
  end
  else begin
    if not inHauptvariante then exit;
    geaendert:=true;
    UDPartieDaten:=Partiedaten;

    FPartiedaten.Zugnummer:=Baumindex^.Zugnummer;
    if Baumindex^.Zug.amZug = WEISS then inc(FPartiedaten.Zugnummer);(**)

    FPartiedaten.zug:=NoZug^;
    FPartiedaten.Stellung:=NoStellung^;
    New(Wurzelindex);
    Wurzelindex^.BL:=Nil;
    Wurzelindex^.rBL:=Nil;
    Wurzelindex^.B:=Baumindex^.B;
    if assigned(Baumindex^.B) then Baumindex^.B^.rB:=Nil;
    Baumindex^.B:=Nil;

    loesche_UD;
    UD:=-2;
    UDBi:=Baumindex;
    UDWurzel^.B:=Wurzel^.B;
    if assigned(wurzel) then dispose(wurzel);
    wurzel:=Nil;

    Baumindex:=Nil;
    klettere(wurzelindex, true);
    {wenn wurzelindex^.B Nil, dann wurde vom letzten Zug an geschnitten u. Wurzel mu Nil bleiben}
    if assigned(wurzelindex^.B) then wurzel:=wurzelindex
    else dispose(wurzelindex);
  end;
end;

procedure TNotation.aufwerten;
var rb, rb1 : PBaum;
    rBaumindex : PBaum;
    rZug : TZug;
begin
  if (inHauptvariante) or (not assigned(Baumindex)) then exit;
  geaendert:=true;
  UD:=0;
  rBaumindex:=Baumindex;
  rb1:=Baumindex;
  if assigned(Baumindex^.rB) then Baumindex:=Baumindex^.rB;  {es knnte Var. losgehen - Varwurzel bereits <> NIL}
  while (assigned(Baumindex^.rB)) and
  (not ((assigned(Baumindex^.varwurzel)) and (rBaumindex^.Zug.amZug=Baumindex^.Zug.amZug))) do begin
    rBaumindex:=Baumindex;
    Baumindex:=Baumindex^.rB; {zur Wurzel zurck}
  end;
  rb:=Baumindex^.B;
  Baumindex^.B:=rBaumindex^.B;
  rBaumindex^.B:=rb;
  if assigned(rBaumindex^.B) then rBaumindex^.B^.rB:=rBaumindex;
  if assigned(Baumindex^.B) then Baumindex^.B^.rB:=Baumindex;
  rzug:=Baumindex^.zug;
  Baumindex^.zug:=rBaumindex^.zug;
  rBaumindex^.zug:=rzug;
  if rb1<>rBaumindex
    then Baumindex:=rb1;  {nur Tauschen, wenn nicht erster Variantenzug markiert war}
  klettere(wurzel, true);
end;

procedure TNotation.loeschen;
var vi : PBaumlist;
    rBaumindex : PBaum;
begin
  if (inHauptvariante) or (not assigned(Baumindex)) then exit;
  geaendert:=true;
  rBaumindex:=Baumindex;
  if assigned(Baumindex^.rB) then Baumindex:=Baumindex^.rB;  {es knnte Var. losgehen - Varwurzel bereits <> NIL}
  while (assigned(Baumindex^.rB)) and
  (not ((assigned(Baumindex^.varwurzel)) and (rBaumindex^.Zug.amZug=Baumindex^.Zug.amZug))) do begin
    rBaumindex:=Baumindex;
    Baumindex:=Baumindex^.rB; {zur Wurzel zurck}
  end;
  {!!!}
  if not assigned(Baumindex^.rB) then vi:=wurzel^.B^.Varwurzel
  else vi:=Baumindex^.varwurzel;

  loesche_UD;   {ev. vorherige undo-Var. lschen}
  UD:=1;
  while (vi^.B<>rBaumindex) and (assigned(vi^.Bl)) do begin
    vi:=vi^.Bl;
    inc(UD);
  end;
  UDBi:=Baumindex;
  UDWurzel^.B:=vi^.B;  {Variante auskoppeln und an UDWurzel bergeben}
  vi^.B:=Nil;

  if vi=Baumindex^.varwurzel then  ZBaumlist:=addr(Baumindex^.varwurzel)
  else ZBaumlist:=addr(vi^.rBl^.Bl);
  loescheBaum(ZBaumlist);
  Baumindex:=Baumindex^.rB;
  klettere(wurzel, true);
  if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
end;

procedure TNotation.UnDo;
var i : integer;
    wi, rwi : PBaumlist;                     {  wurzel^.b^.b^.varwurzel^.bl^}
begin
  if (not assigned(UDWurzel)) or (UD=0) then exit;
  if UD>0 then begin
    i:=1;
    wi:=UDBi^.VarWurzel;
    rwi:=wi;
    while (i<UD) and (assigned(wi)) do begin
      rwi:=wi;
      wi:=wi^.BL;
      inc(i);
    end;
    if not (assigned(wi)) then begin  {letzter Eintrag}
      if wi=UDBi^.VarWurzel then UDBi^.VarWurzel:=UDWurzel
      else begin
        rwi^.BL:=UDWurzel;
        UDWurzel^.rBL:=rwi;
      end;
    end
    else begin
      if wi=UDBi^.VarWurzel then begin
        UDBi^.VarWurzel^.rBL:=UDWurzel;
        UDWurzel^.BL:=UDBi^.VarWurzel;
        UDBi^.VarWurzel:=UDWurzel;
      end
      else begin
        UDWurzel^.BL:=wi;
        wi^.rBL:=UDWurzel;
        UDWurzel^.rBL:=rwi;
        rwi^.BL:=UDWurzel;
      end;
    end;
  end
  else begin
    if UD=-1 then begin
      UDBi^.B:=UDWurzel^.B;
      dispose(UDWurzel);
    end
    else begin
      if not assigned(wurzel) then UDBi^.B:=Nil
      else begin
        UDBi^.B:=wurzel^.B;
        if assigned(wurzel^.B) then wurzel^.B^.rB:=UDBi;
      end;
      Partiedaten:=UDPartiedaten;
      if not assigned(Baumindex) then
        if assigned(FOnMoveChange) then FOnMoveChange(self, Partiedaten.Zug, Partiedaten.Stellung, false);
      Wurzel:=UDWurzel;
    end;
  end;
  UDWurzel:=Nil;
  UD:=0;
  klettere(wurzel, true);
end;

procedure TNotation.Matt;
var k : longint;
begin
 try                 (**)
   if assigned(Baumindex) then begin
     k:=Baumindex^.ss + Baumindex^.sl - 1;
     if notat[k]='+' then begin
       notat[k]:='#';
       Baumindex^.Zug.attr1:=Baumindex^.Zug.attr1 or nMatt xor nSchach;
       Klettere(wurzel, true);
     end;
  end;
 except
 end;
end;

procedure TNotation.KD(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
  case key of
    27, VK_LEFT : uebergabe:=-1;
    VK_RIGHT, 13, VK_SPACE :  uebergabe:=lZuege.ItemIndex;
  else exit;
  end;
  VarDialog.Close;
end;

procedure TNotation.MD(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  uebergabe:=lZuege.ItemIndex;
  VarDialog.Close;
end;

procedure TNotation.GoBack;
Var rBaum : PBaum;
begin
  if not assigned(Baumindex) then exit;
  rBaum:=Baumindex;
  Baumindex:=Baumindex^.rB;
  if (assigned(Baumindex)) and (rBaum<>Baumindex^.B) {springt in bergeordnete Var. und mu deshalb noch einen Zug zurck}
    then Baumindex:=Baumindex^.rB;
  zugzurueck(rBaum^.Zug);
  if assigned(Baumindex) then NoZug^ := Baumindex^.Zug
  else NoZug^ := Partiedaten.Zug;
  AdjustPb(Baumindex);
  if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false)
end;

function TNotation.Goahead_inHauptVariante(Var von, nach, UFigur : shortint) : Boolean; {lst kein OnmoveChangeEreignis aus, gibt aber den gespielten Zug zurck}
Var hBaumindex : PBaum;
begin
  Result := false;
  if not assigned(Baumindex) then begin
    if (not assigned(wurzel)) or (not assigned(wurzel^.B)) then exit;
    hBaumindex:=Wurzel^.B;
  end
  else hBaumindex:=Baumindex^.B;
  if assigned(hBaumindex) then begin
    Baumindex := hBaumindex;
    NoZug^ := Baumindex^.Zug;
    zugvor;
    AdjustPb(Baumindex);
    von := Baumindex^.Zug.von;
    nach := Baumindex^.Zug.nach;
    UFigur := Baumindex^.Zug.UFigur;
    Result := true;
  end;
end;

procedure TNotation.Goahead;
Var i : longint;
    keineZuege : Boolean;
    hBaumindex : PBaum;
begin
  keineZuege:=false;
  if not assigned(Baumindex) then begin
    if (not assigned(wurzel)) or (not assigned(wurzel^.B)) then exit;
    Baumindex:=Wurzel^.B;
    keineZuege:=true;
  end;
  if not keineZuege then hBaumindex:=Baumindex^.B else hBaumindex:=Baumindex;
  if assigned(hBaumindex) then begin
    uebergabe:=-2;
    if assigned(hBaumindex^.Varwurzel) then begin
      uebergabe:=-1;
      Dialog_ini;
      VarDialog.KeyPreview:=true;
      VarDialog.OnKeydown:=KD;
      if English then VarDialog.Caption:='Select move' else VarDialog.Caption:='Variante whlen';
      lZuege:=TListBox.Create(self);
      VarDialog.insertControl(lZuege);
      lZuege.OnMouseDown:=MD;
      lZuege.Align:=alClient;
      Varianten_anzeigen(keineZuege);
      Vardialog.showmodal;
      lzuege.free;
      VarDialog.free;
      if uebergabe>=0 then begin
        wurzelindex:=hBaumindex^.Varwurzel;
        if uebergabe=0 then begin
          if not keineZuege then Baumindex:=Baumindex^.B;  {Hauptvariante}
        end
        else begin
          if uebergabe=1 then begin  {VarWurzel - nur eine Verzweigung}
            Baumindex:=Wurzelindex^.B;
          end
          else begin
            i:=1;
            while (i<uebergabe) and (assigned(wurzelindex^.BL)) do begin
              wurzelindex:=wurzelindex^.BL;
              inc(i);
            end;
            Baumindex:=Wurzelindex^.B;
          end;
        end;
      end
      else if keineZuege then Baumindex:=Nil;  {Abbruch gewhlt}
    end
    else if not keineZuege then Baumindex:=Baumindex^.B;  {keine Verzweigungen}
    if uebergabe <> -1 then begin {Abbruch im Var.dialog gewhlt}
      NoZug^ := Baumindex^.Zug;
      zugvor;
      AdjustPb(Baumindex);
      if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, true);
    end;
  end
  else begin  {Bei Variantenende auf bergeordnete Var. dahinter (falls vorhanden) springen}
    i:=Baumindex^.ss + 1 + Baumindex^.sl;
    while (i<length(notat)) and (notat[i]<>'.') do begin
      inc(i);
      if notat[i]='{' then
        repeat inc(i) until (i>=length(notat)) or (notat[i]='}');
    end;
    if (notat[i]<>'.') or (i>=length(notat)) then exit;
    retract(i);
    MessageBeep(0);
    if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
  end;
end;

procedure TNotation.GoPreviousVar;
begin
  if not assigned(Baumindex) then exit;
  if assigned(Baumindex^.rB) then Baumindex:=Baumindex^.rB;  {es knnte Var. losgehen - Varwurzel bereits <> NIL}
  while (assigned(Baumindex^.rB)) and
  (not (assigned(Baumindex^.varwurzel))) do begin
    Baumindex:=Baumindex^.rB; {zur Wurzel zurck}
  end;
  Baumindex:=Baumindex^.rB;
  klettere(wurzel, false);
  if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
end;

procedure TNotation.GoNextVar;
var rBaumindex : PBaum;
begin
  if (not assigned(wurzel)) or (not assigned(wurzel^.B)) then exit;
  rBaumindex:=Baumindex;
  if assigned(Baumindex) then Baumindex:=Baumindex^.B else Baumindex:=Wurzel^.B;
  if not assigned(Baumindex) then begin
    Baumindex:=rBaumindex;
    exit;
  end;  
  while (assigned(Baumindex^.B)) and (not assigned(Baumindex^.B^.VarWurzel)) do
    Baumindex:=Baumindex^.B;
  klettere(wurzel, false);
  if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
end;

procedure TNotation.GoToStart;
begin
  if (not assigned(wurzel)) or (not assigned(Baumindex)) or
  (not assigned(wurzel^.B)) then exit;
  Baumindex:=Nil;
  klettere(wurzel, false);
  if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
end;

procedure TNotation.GoToEnd;
begin
  if (not assigned(wurzel)) or (not assigned(wurzel^.B)) then exit;
  Baumindex:=wurzel^.B;
  while assigned(Baumindex^.B) do Baumindex:=Baumindex^.B;
  klettere(wurzel, false);
  if assigned(FOnMoveChange) then FOnMoveChange(self, NoZug^, NoStellung^, false);
end;

function TNotation.SchreibePartie(ToClipBoard : Boolean; Var PGNString : string) : integer;
var h, h1 : string;
    i, n : longint;
    gleich : Boolean;
    cs : PChar;
    sl : TStringlist;

procedure cwriteln(s : string);
begin
  sl.Add(s)
end;

procedure split(gh, hs : string);
Var i : integer;
begin
  i := 1;
  while i <= length(hs) do begin
    cwriteln(gh + copy(hs, i, 150) + '"]');
    inc(i, 150);
  end;
end;

begin
 Result:=-1;
 sl := TStringlist.Create;
 try
  with Partiedaten.EventData do begin
    if quelle<>'' then h:=quelle else h:='?';
    cwriteln('[Event "'+h+'"]');
    if ort<>'' then h:=ort else h:='?';
    cwriteln('[Site "'+h+'"]');
    if jahr<>0 then h:=IntToStr(jahr) + '.' else h:='??.';
    if Monat<>0 then begin
      if monat < 10 then h := h + '0';
      h:=h + IntToStr(Monat) + '.';
    end
    else h:=h+'??.';
    if Tag<>0 then begin
      if tag < 10 then h := h + '0';
      h:=h + IntToStr(Tag);
    end
    else h:=h+'??';
    cwriteln('[Date "'+h+'"]');
    if runde <> 0 then cwriteln('[Round "'+IntToStr(Runde)+'"]');
    if weiss<>'' then h:=weiss else h:='?';
    cwriteln('[White "'+h+'"]');
    if schwarz<>'' then h:=schwarz else h:='?';
    cwriteln('[Black "'+h+'"]');
    cwriteln('[Result "'+ergebnis+'"]');
    if wElo<>0 then cwriteln('[WhiteElo "'+IntToStr(wElo)+'"]');
    if sElo<>0 then cwriteln('[BlackElo "'+IntToStr(sElo)+'"]');
    if eco <> '' then cwriteln('[EC0 "'+eco+'"]');
    if annotator<>'' then cwriteln('[Annotator "'+annotator+'"]');
    gleich:=true;
    for i:=0 to 119 do if Partiedaten.Stellung[i]<>Ausgangsstellung[i] then gleich:=false;
    if gleich then if Partiedaten.Zug.amZug <> 1 then gleich := false;  (**)
    if not gleich then begin
      cwriteln('[SetUp "1"]');
      cwriteln('[FEN "'+ PosToFEN(Partiedaten.Stellung, Partiedaten.Zug, Partiedaten.Zugnummer, FRC) +'"]');
    end;
    if MetaKeywords <> '' then split('[MetaKeywords "', MetaKeywords);
    if MetaDescription <> '' then split('[MetaDescription "', MetaDescription);
  end;  
  cwriteln('');
  h:=notat;
  if ueberschrift then delete(h, 1, UeberschriftEnde);      (**)
  i:=1;
  n:=0;
  while i<=length(h) do begin
    case h[i] of
      '[' : h[i]:='(';
      ']' : h[i]:=')';
      'D' : h[i]:='Q';
      'T' : h[i]:='R';
      'L' : h[i]:='B';
      'S' : h[i]:='N';
      #$D : h[i]:=' ';
      #$A : begin
              while (i<=length(h)) and ((h[i]=' ') or (h[i]=#$A)) do delete(h, i, 1);
              dec(i);
            end;
      ' ' : if n>80 then begin
              h[i]:=#1;
              n:=0;
            end;
      '{' : while (i<=length(h)) and (h[i]<>'}') do begin
              case h[i] of
                #$D : h[i]:=' ';
                #$A : begin
                        while (i<=length(h)) and ((h[i]=' ') or (h[i]=#$A)) do delete(h, i, 1);
                        dec(i);
                      end;
                ' ' : begin
                        while (i<length(h)) and (h[i+1]=' ') do delete(h, i+1, 1);
                        if (n>80) and
                        ((i<length(h)) and (h[i+1]<>'[')) then begin
                        { <>'[' - damit nicht mal zufallig ein "[Event" am Zeilenanfang steht}
                          h[i]:=#1;
                          n:=0;
                        end;
                      end;
              end;
              inc(i);
              inc(n);
            end;
      '!' : if length(h) > i then begin
              insert(' ', h, i);
              inc(i);
              h[i] := '$';
              inc(i);
              case h[i] of
                '!' : h[i] := '3';
                '?' : h[i] := '5';
                else insert('1', h, i);
              end;
            end;
      '?' : if length(h) > i then begin
              insert(' ', h, i);
              inc(i);
              h[i] := '$';
              inc(i);
              case h[i] of
                '?' : h[i] := '4';
                '!' : h[i] := '6';
                else insert('2', h, i);
              end;
            end;
    end;
    inc(n);
    inc(i);
  end;
  h1:='';
  for i:=1 to length(h) do begin
    if h[i]<>#1 then h1:=h1+h[i]
    else begin
      cwriteln(h1);
      h1:='';
    end;
  end;
  if h1<>'' then cwriteln(h1);
  if ToClipBoard then begin
    with ClipBoard do begin
      open;
      try
        cs := stralloc(length(sl.Text) + 1);
        try
          StrCopy(cs, PChar(sl.Text));
          SetTextBuf(cs);
        finally
          StrDispose(cs);
        end;
      finally
        close;
      end;
    end;
  end
  else PGNString := sl.Text;
  sl.Free;
  Result:=0;
 except
   sl.free;
 end;
end;

procedure TNotation.CopyGameToClipboard;
Var dummy : string;
begin
  schreibePartie(true, dummy);
end;

function TNotation.GetGame : string;
begin
  Result := '';
  schreibePartie(false, Result);
end;

function TNotation.PasteGameFromClipBoard;
Var cs : PChar;
begin
  Result := false;
  if not ClipBoard.HasFormat(CF_TEXT) then exit;
  with Clipboard do begin
    open;
    cs := stralloc(10000); { !!! Partie sollte nicht lnger sein}
    try
      GetTextBuf(cs, 10000);
      SetGame(StrPas(cs));
    finally
      strdispose(cs);
      close;
    end;
  end;
  Result := true;
end;

function  TNotation.GetMove : TZug;
begin
  Result := Baumindex^.Zug;
end;

function TNotation.GetKommentar : string;
Var i : longint;
begin
  if assigned(Baumindex) then Result:=Baumindex^.Kommentar
  else Result:=Partiedaten.Kommentar;
  if Result='' then exit;
  i:=0;
  repeat inc(i) until (Result[i]='{') or (i>=length(Result));
  delete(Result, i, 1);
  i:=length(Result)+1;
  repeat dec(i) until (i<=0) or (Result[i]='}');
  delete(Result, i, 1);
end;

Procedure TNotation.SetKommentar(k : String);
var i : longint;
begin
  trim(k);
  if k<>'' then begin
    i:=0;
    repeat
      inc(i);
      case k[i] of
        '}' : begin delete(k, i, 1);dec(i);end;
        '{' : begin delete(k, i, 1);dec(i);end;
        '' : begin delete(k, i, 1); insert('Ae', k, i); end;
        '' : begin delete(k, i, 1); insert('Oe', k, i); end;
        '' : begin delete(k, i, 1); insert('Ue', k, i); end;
        '' : begin delete(k, i, 1); insert('ae', k, i); end;
        '' : begin delete(k, i, 1); insert('oe', k, i); end;
        '' : begin delete(k, i, 1); insert('ue', k, i); end;
        '' : begin delete(k, i, 1); insert('ss', k, i); end;
        #$D : begin delete(k, i, 2); insert(' ', k, i); end;   {Zeilensprung wrde Formatierungsroutine stren}
      end;
    until i>=length(k);
  end;
  if k<>'' then k:='{'+k+'}';
  if assigned(Baumindex) then Baumindex^.Kommentar:=k
  else FPartiedaten.Kommentar:=k;
  if not assigned(wurzel) then begin
    New(wurzel);
    wurzel^.rBL:=Nil;
    wurzel^.BL:=Nil;
    wurzel^.B:=Nil;
  end;
  klettere(wurzel, true);
  geaendert:=true;
end;

procedure TNotation.SetZugBewertung(s : string);
begin
  if not assigned(Baumindex) then exit;
  if s = '!' then Baumindex^.Zug.Attr2 := nAusruf
  else if s = '!!' then Baumindex^.Zug.Attr2 := n2Ausruf
  else if s = '?' then Baumindex^.Zug.Attr2 := nFrage
  else if s = '??' then Baumindex^.Zug.Attr2 := n2Frage
  else if s = '!?' then Baumindex^.Zug.Attr2 := nAusrufFrage
  else if s = '?!' then Baumindex^.Zug.Attr2 := nFrageAusruf
  else Baumindex^.Zug.Attr2 := 0;
  klettere(wurzel, true);
  geaendert:=true;
end;

{Property-Routinen}

procedure TNotation.SetUberschrift(w : Boolean);
begin
  if w<>FUeberschrift then FUeberschrift:=w;
  klettere(wurzel, true);
end;

procedure TNotation.SetGeaendert(w : Boolean);
begin
  FGeaendert := w;
  if w then if assigned(OnGameChanged) then OnGameChanged(self);
end;

procedure TNotation.SetFontHeadLine(f : TFont);
begin
  FFontHeadLine.assign(f);
  klettere(wurzel, true);
end;

procedure TNotation.SetFontComment(f : TFont);
Var i : integer;
begin
  FFontComment.assign(f);
  i := FFont0Var.Size;
  if i < FFont1Var.Size then i := FFont1Var.Size;
  if i < FFont2Var.Size then i := FFont2Var.Size;
  if FFontComment.Size > i then FFontComment.Size := i;
  klettere(wurzel, true);
end;

procedure TNotation.SetFont0Var(f : TFont);
begin
  pb.canvas.Font.assign(f); (**)
  FFont0Var.assign(f);
  FFont1Var.Name := f.Name;
  FFont1Var.Size := f.Size;
  FFont2Var.Name := f.Name;
  FFont2Var.Size := f.Size;
  if FFontComment.Size > FFont0Var.Size then FFontComment.Size := FFont0Var.Size;
  Texthoehe := pb.canvas.TextHeight('Mg') + ZeilenAbstand;
  SLeiste.LargeChange := (SLeiste.height div Texthoehe) - 1;
  klettere(wurzel, true);
end;

procedure TNotation.SetFont1Var(f : TFont);
begin
  FFont1Var.Color := f.Color;
  FFont1Var.Style := f.Style;
  klettere(wurzel, true);
end;

procedure TNotation.SetFont2Var(f : TFont);
begin
  FFont2Var.Color := f.Color;
  FFont2Var.Style := f.Style;
  klettere(wurzel, true);
end;

procedure TNotation.SetIndent0Var(i : word);
begin
  if FIndent0Var = i then exit;
  FIndent0Var := i;
  klettere(wurzel, true);
end;

procedure TNotation.SetIndent1Var(i : word);
begin
  if FIndent1Var = i then exit;
  FIndent1Var := i;
  klettere(wurzel, true);
end;

procedure TNotation.SetIndent2Var(i : word);
begin
  if FIndent2Var = i then exit;
  FIndent2Var := i;
  klettere(wurzel, true);
end;

procedure TNotation.SetZeilenabstand(i : word);
begin
  if FZeilenabstand = i then exit;
  FZeilenabstand := i;
  with TBitmap.Create do begin
    try
      Canvas.Font.Assign(FFont0Var);
      Texthoehe := canvas.TextHeight('Mg') + FZeilenAbstand;
      SLeiste.LargeChange := (SLeiste.height div Texthoehe) - 1;
      klettere(wurzel, true);
    finally
      free;
    end;
  end;    
end;

procedure TNotation.SetBorderWidthNotat(i : word);
begin
  Borderwidth := i;
  FBorderWidthNotat := i;
  SendMessage(handle, WM_SIZE, 0, 0);
end;

procedure TNotation.SetBevelWidthNotat(i : word);
begin
  if i < 1 then exit;
  Bevelwidth := i;
  FBevelWidthNotat := i;
  SendMessage(handle, WM_SIZE, 0, 0);
end;

function TNotation.GetEnglish : Boolean;
begin
  if FEnglish=0 then Result:=false else Result:=true;
end;

procedure TNotation.SetEnglish(w : Boolean);
begin
  if ((w) and (FEnglish=1)) or ((not w) and (FEnglish=0)) then exit;
  if w then FEnglish:=1 else FEnglish:=0;
  Klettere(wurzel, true);
end;

end.
