unit PGN;

{$B-}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  stdctrls, SchachProcs;

const

  pgnAddGame      = -1;  {ungltige ID fe SaveGame - dann wird Partie angehngt}

type
  TCancelMode = (cmCancelDenied, cmNoCancel, cmCancel);  {in PGN fr Abbrechen}

  TGameHeader = record
     ID, FilePositionA, FilePositionE : longint;  {fr TPGN - Partieindex}
   end;
   PGameHeader = ^TGameHeader;

  TKriterium = (soNothing, soWeiss, soSchwarz, soquelle, soAnnotator, soort, soergebnis, soEco,
                soJahr, soWElo, soSElo, soPlyCount);

  TBeforeCreatePGNFileEvent = procedure (Sender: TObject; FileName : string; Var CreateNewPGNFile : Boolean) of object;
  TPGNTraceEvent = procedure (Sender: TObject; Percent : integer; Var CancelMode : TCancelMode) of object;
  TPGNDblClickEvent = procedure (Sender: TObject; PGNGame : string; GameID : longint) of object;
  TFilterRequestEvent = procedure (Sender: TObject; GameHeader : TEventData; Var ShowThisGame : Boolean) of object;
  TPGNDrawItemEvent = procedure (Control : TWinControl; Index: Integer; Rect: TRect; GameHeader : TEventData; GameIndex : longint) of object;
  TPi = ^longint;

  TPGN = class(TCustomListbox)
    constructor Create(AOwner : TComponent); override;
    destructor destroy; override;
  private
    { Private-Deklarationen }
    FPGNFile          : String;
    FOnPGNTrace       : TPGNTraceEvent;
    FOnFilterRequest  : TFilterRequestEvent;
    FOnPGNDblClick    : TPGNDblClickEvent;
    FOnPGNDrawItem    : TPGNDrawItemEvent;
    FBeforeCreatePGNFile: TBeforeCreatePGNFileEvent;
    FPGNSorted        : TKriterium;

    FOnlyPartsRead    : Boolean;
    filePGN    : File;
    LastID     : longint;     { wird bei neuer immer inc.}
    Abbruch    : TCancelMode;
    slTemp     : TStringList;
    lHeader    : TList;
    FileOpen, FileReading, Deleting  : Boolean;
    EvD        : TEventData;

    procedure SetPGNFile(s : string);

    function  AddGame(Var ID : longint; sGame : String) : Boolean;
    procedure ClosePGNFile;
    procedure AddIndexObject(lHeaderIndex, GameID, PosA, posE : longint);
    procedure DeleteIndexObject(lHeaderindex : longint);
    function  AdjustGameString(lHeaderIndex : longint; sGame : string; Modus : integer) : string;
    function  GetFilePosIndex(ID : longint; Var FilePosindexA : longint) : longint;
    procedure UpdateFileIndexe(lHeaderIndex, summand : longint);
    procedure UpdateItems(ListeIndex, Summand : longint);
    function  DoGetGameAsString(lHeaderIndex : longint) : string;
    procedure DoslIndexeClear;
    procedure RefreshEventData(lHeaderIndex : longint);
    function  DoSaveGame(ListeIndex : longint; Var ID : longint; sGame : String; Modus : integer) : Boolean;
    procedure AddItem(ListeIndex, lHeaderIndex : longint);
    procedure DeleteItem(ListeIndex : longint);
    function  GetItemsVisibleCount : longint;
    function  GetItemsAllCount : longint;

    function  GetItemsObject(Listeindex : longint) : longint;
  protected
    { Protected-Deklarationen }
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
    procedure DblClick; override;
    procedure KeyPress(var Key: Char); override;
  public
    { Public-Deklarationen }
    property  PGNSorted : TKriterium read FPGNSorted;
    property  ItemsVisibleCount : longint read GetItemsVisibleCount;
    property  ItemsAllCount : longint read GetItemsAllCount;
    property  OnlyPartsRead : Boolean read FOnlyPartsRead;
    property  PGNFile : string read FPGNFile write SetPGNFile;
    function  SaveGame(ListeIndex : longint; Var ID : longint; sGame : String) : Boolean;
    function  ReplaceGame(Var ID : longint; sGame : String) : Boolean;
    function  DeleteGame(ListeIndex : longint) : Boolean;
    function  GetGameAsString(lHeaderIndex : longint; Var ID : longint) : string;
    function  ListeIndexToDatabaseIndex(ListeIndex : longint) : longint;
    procedure Filtern;
    procedure Sortieren(Kriterium : TKriterium);
  published
    { Published-Deklarationen }
    property OnPGNTrace : TPGNTraceEvent read FOnPGNTrace write FOnPGNTrace;
    property OnPGNDblClick : TPGNDblClickEvent read FOnPGNDblClick write FOnPGNDblClick;
    property OnPGNDrawItem : TPGNDrawItemEvent read FOnPGNDrawItem write FOnPGNDrawItem;
    property OnFilterRequest : TFilterRequestEvent read FOnFilterRequest write FOnFilterRequest;
    property BeforeCreatePGNFile : TBeforeCreatePGNFileEvent read FBeforeCreatePGNFile write FBeforeCreatePGNFile;

    property Align;
    property BorderStyle;
    property Color;
    property Columns;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ExtendedSelect;
    property Font;
    property IntegralHeight;
    property ItemHeight;
    property MultiSelect;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;

    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;


implementation

const

  BufferSize      = 16384;
  pgnRetString    = #$D#$A;
  pgnAdd          = 1;
  pgnInsert       = 2;
  pgnReplace      = 3;

procedure TPGN.Sortieren(Kriterium : TKriterium);
Var i, j : longint;
    sl : TStringList;
    s : string;
    prcnt, Prcnt100, NewPrcnt, LastPrcnt : Integer;
    Abbruch : TCancelMode;

function DoTrace : Boolean;
begin
  Result := false;
  inc(prcnt);
  NewPrcnt := GetPercent(prcnt, prcnt100);
  if NewPrcnt <> LastPrcnt then begin
    if assigned(FOnPGNTrace) then FOnPGNTrace(self, NewPrcnt, Abbruch);
    if Abbruch = cmCancel then Result := true;
    LastPrcnt := NewPrcnt;
  end;
end;

procedure QuickSort(iLo, iHi: Integer);
  var
    Lo, Hi : Integer;
    Mid, T : string;
  begin
    Lo := iLo;
    Hi := iHi;
    Mid := sl[(Lo + Hi) div 2];
    repeat
      while sl[Lo] < Mid do Inc(Lo);
      while sl[Hi] > Mid do Dec(Hi);
      if Lo <= Hi then
      begin
        T := sl[Lo];
        sl[Lo] := sl[Hi];
        sl[Hi] := T;
        T := Items[Lo];
        Items[Lo] := Items[Hi];  
        Items[Hi] := T;
        Inc(Lo);
        Dec(Hi);
        if Abbruch = cmCancel then exit;
      end;
    until Lo > Hi;
    DoTrace;
    if Hi > iLo then QuickSort(iLo, Hi);
    if Lo < iHi then QuickSort(Lo, iHi);
  end;

begin
  if (FileReading) or (not FileOpen) or (Items.Count = 0) then exit;
  LastPrcnt := -1;
  Prcnt := 0;
  FileReading := true;
  Deleting := true;  {wie beim Lschen Anzeige aktual. unterbinden}
  sl := TStringList.Create;
  Screen.Cursor := crHourGlass;
  try
    if Kriterium <> FPGNSorted then begin
      Prcnt100 := Items.Count * 2;
      FPGNSorted := Kriterium;
      Abbruch := cmNoCancel;
      for i := 0 to Items.Count - 1 do begin
        if Kriterium = soNothing then begin
          Items[i] := '';
        end
        else begin
          Items[i] := IntToStr(i);
          j := GetItemsObject(I);
          RefreshEventData(j);
          case Kriterium of
            soWeiss    : sl.Add(EvD.Weiss);
            soSchwarz  : sl.Add(EvD.Schwarz);
            soquelle   : sl.Add(EvD.quelle);
            soAnnotator: sl.Add(EvD.Annotator);
            soOrt      : sl.Add(EvD.Ort);
            soergebnis : sl.Add(EvD.ergebnis);
            soEco      : sl.Add(EvD.Eco);
            soJahr     : sl.Add(IntToStr(EvD.Jahr));
            soWElo     : sl.Add(IntToStr(EvD.WElo));
            soSElo     : sl.Add(IntToStr(EvD.SElo));
            soPlyCount : sl.Add(IntToStr(EvD.PlyCount));
          end;
          if DoTrace
            then exit;
        end;
      end;
      Abbruch := cmNoCancel;
      if Kriterium <> soNothing then QuickSort(0, sl.Count - 1);
    end
    else if Kriterium <> soNothing then begin
      Prcnt100 := Items.Count;
      Abbruch := cmNoCancel;
      j := Items.Count - 1;
      i := 0;
      while i < j do begin
        s := Items[j];
        Items[j] := Items[i];
        Items[i] := s;
        dec(j);
        inc(i);
        if DoTrace then exit;
      end;
    end;
  finally
    if assigned(FOnPGNTrace) then FOnPGNTrace(self, 0, Abbruch);
    Deleting := false;
    Refresh;
    sl.Free;
    Screen.Cursor := crDefault;
    FileReading := false;
  end;
end;

function TPGN.GetItemsObject(Listeindex : longint) : longint;
Var i, f : longint;
begin
  if Items[ListeIndex] = '' then Result := longint(Items.Objects[ListeIndex])
  else begin
    Result := longint(Items.Objects[StrToInt(Items[ListeIndex])]);
  end;
end;

function TPGN.ListeIndexToDatabaseIndex(ListeIndex : longint) : longint;
begin
  if (ListeIndex >= 0) and (ListeIndex < Items.Count)
  then Result := GetItemsObject(ListeIndex)//longint(Items.Objects[ListeIndex])
  else Result := -1;
end;

procedure TPGN.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var i : longint;
begin
  if Deleting then exit;  {darf whrend Lschvorgang nicht ausgefhrt werden}
  if assigned(FOnPGNDrawItem) then begin
    i := GetItemsObject(Index);//longint(items.Objects[Index]);
    RefreshEventData(i);
    FOnPGNDrawItem(self, Index, Rect, EvD, i);
  end
  else inherited DrawItem(Index, Rect, State);
end;

procedure TPGN.Filtern;
Var i : longint;
    prcnt, Prcnt100, NewPrcnt, LastPrcnt : Integer;
    Abbruch : TCancelMode;
begin
  if (FileReading) or (not FileOpen) then exit;
  LastPrcnt := -1;
  Prcnt100 := lHeader.Count;
  Prcnt := 0;
  Abbruch := cmNoCancel;
  FileReading := true;
  screen.cursor := crHourglass;
  try
    Clear;
    FPGNSorted := soNothing;
    for i := 0 to lHeader.Count - 1 do begin
      AddItem(Items.Count, i);
      inc(prcnt);
      NewPrcnt := GetPercent(prcnt, prcnt100);
      if NewPrcnt <> LastPrcnt then begin
        if assigned(FOnPGNTrace) then FOnPGNTrace(self, NewPrcnt, Abbruch);
        if Abbruch = cmCancel then break;
        LastPrcnt := NewPrcnt;
      end;
    end;
    if assigned(FOnPGNTrace) then FOnPGNTrace(self, 0, Abbruch);
  finally
    FileReading := false;
    screen.cursor := crDefault;
  end;
end;

procedure TPGN.KeyPress(var Key: Char);
Var ID : longint;
    s : string;
begin
  inherited Keypress(Key);
  if (key = #13) and (SelCount <> 0) then begin
    if (assigned(FOnPGNDblClick)) and (FileOpen) then begin
      s := GetGameAsString(GetItemsObject(ItemIndex){longint(Items.Objects[Itemindex])}, ID);
      if (s <> '') and (ID <> -1) then FOnPGNDblClick(self, s, ID);
    end;
  end;
end;

procedure TPGN.DblClick;
Var ID : longint;
    s : string;
begin
  inherited DblClick;
  if (assigned(FOnPGNDblClick)) and (FileOpen) then begin
    s := GetGameAsString(GetItemsObject(ItemIndex) {longint(Items.Objects[Itemindex])}, ID);
    if (s <> '') and (ID <> -1) then FOnPGNDblClick(self, s, ID);
  end;
end;

constructor TPGN.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  slTemp := TStringlist.Create;
  lHeader := TList.Create;
  Style := lbOwnerDrawVariable;
  Sorted := false; {war vorher true!!!}
  FPGNSorted := soNothing;
end;

destructor TPGN.destroy;
begin
  try
    DoslIndexeClear;
    lHeader.Free;
    slTemp.free;
    ClosePGNFile;
    inherited destroy;
  except
  end;
end;

procedure TPGN.ClosePGNFile;
begin
  if FileOpen then
  try
    CloseFile(filePGN);
  except
  end;
  FileOpen := false;
end;

procedure TPGN.RefreshEventData(lHeaderIndex : longint);
Var j : longint;
    s : string;
begin
  slTemp.Text := DoGetGameAsString(lHeaderIndex);
  ResetEventData(EvD);
  j := 0;
  while j < slTemp.Count do begin
    s := trim(slTemp[j]);
    if (s = '') or ((s <> '') and (s[1] <> '[')) then break;
    SetEventData(EvD, s);
    inc(j);
  end;
  if (slTemp.Count = 0) then begin
    EvD.Weiss := 'Error';
    EvD.Schwarz := '...';
  end;
end;

procedure TPGN.UpDateFileIndexe(lHeaderIndex, summand : longint);
Var i : longint;
begin
  for i := lHeaderIndex to lHeader.Count - 1 do begin
    PGameHeader(lHeader[i])^.FilePositionA :=
      PGameHeader(lHeader[i])^.FilePositionA + summand;
    PGameHeader(lHeader[i])^.FilePositionE :=
      PGameHeader(lHeader[i])^.FilePositionE + summand;
  end;
  if (lHeaderIndex > 0) and (lHeaderIndex = lHeader.Count) then
    PGameHeader(lHeader[lHeader.Count - 1])^.FilePositionE := Filesize(filePGN); {letze Partie ersetzt - Lnge gendert}
end;

procedure TPGN.UpdateItems(ListeIndex, Summand : longint);
Var i, j : longint;
begin
  j := ListeIndex;
  while j < Items.count do begin
    i := longint(Items.Objects[j]);
    i := i + Summand;
    Items.Objects[j] := Pointer(i);
    inc(j);
  end;
end;

procedure TPGN.DeleteIndexObject(lHeaderindex : longint);
Var gh : PGameHeader;
begin
  gh := PGameHeader(lHeader[lHeaderindex]);
  if assigned(gh) then Dispose(gh);
  lHeader.Delete(lHeaderindex);
end;

procedure TPGN.DeleteItem(ListeIndex : longint);
Var i : longint;
begin
  i := ListeIndex;
  if Items[i] <> '' then i := StrToInt(Items[i])
  else dec(i);
  Items.Delete(ListeIndex);
  UpdateItems(i + 1, -1);
end;

procedure TPGN.AddItem(ListeIndex, lHeaderIndex : longint);
Var ShowThisGame : Boolean;
begin
  if assigned(FOnFilterRequest) then begin
    RefreshEventData(lHeaderIndex);
    ShowThisGame := true;
    FOnFilterRequest(self, EvD, ShowThisGame);
    if ShowThisGame then begin
      Items.InsertObject(ListeIndex, '', Pointer(lHeaderIndex));
      UpdateItems(ListeIndex + 1, 1);  {hier ist Item immer ''}
    end;
  end
  else begin
    Items.InsertObject(ListeIndex, '', Pointer(lHeaderIndex));
    UpdateItems(ListeIndex + 1, 1);
  end;
end;

procedure TPGN.AddIndexObject(lHeaderIndex, GameID, posA, posE : longint);
Var gh : PGameHeader;
begin
  gh := New(PGameHeader);
  with gh^ do begin
    ID := GameID;
    FilePositionA := PosA;
    FilePositionE := PosE;
  end;
  lHeader.Insert(lHeaderIndex, Pointer(gh));
end;

procedure TPGN.DoslIndexeClear;
Var i : integer;
    gh : PGameHeader;
    c : TCursor;
begin
  c := screen.cursor;
  screen.cursor := crHourglass;
  try
    for i := 0 to lHeader.Count - 1 do begin
      gh := PGameHeader(lHeader[i]);
      if assigned(gh) then Dispose(gh);
    end;
    lHeader.Clear;
  finally
    screen.cursor := c;
  end;
end;

procedure TPGN.SetPGNFile(s : string);
var
  NumRead, prcnt, Prcnt100, NewPrcnt, LastPrcnt : Integer;
  Buf : array[1..BufferSize + 1] of Char;
  hBuf: array[0..length(PGNPartieStart)] of Char;  { zum Vergleich des Reststrings (beachten: letztes Nullbyte u. PGNPartiestart ist eigentlich um 1 Zeichen (#$A) lnger, aber hier mu es eins weniger sein, damit der Vergleichstring nicht im normalen Block nochmal gefunden wird}
  cs, cs1, csRest : PChar;
  i, j, rFilePos, rFilePosA : longint;
  first, CreateNewPGNFile : Boolean;
  sRest : string;
  f : File;
  rFilterRq : TFilterRequestEvent;

procedure AddListItems(a, e : longint);
begin
  if rFilePosA <> -1 then begin
    AddIndexObject(lHeader.Count, lHeader.Count, a, e);
    AddItem(Items.Count, lHeader.Count - 1);
  end;
  rFilePosA := e;
end;

begin
  if FileReading then exit;
  if uppercase(s) = uppercase(FPGNFile) then begin
    if not FOnlyPartsRead then exit;
  end
  else begin
    If not FileExists(s) then begin
      if uppercase(ExtractFileExt(s)) <> '.PGN' then s := s + '.pgn';
      CreateNewPGNFile := true;
      if assigned(BeforeCreatePGNFile) then BeforeCreatePGNFile(self, s, CreateNewPGNFile);
      if CreateNewPGNFile then begin
        assignFile(f, s);
        rewrite(f);
        Close(f);
      end
      else exit;
    end
    else if not CheckPGN(s) then exit;
  end;
  screen.cursor := crHourglass;
  Abbruch := cmNoCancel;
  LastPrcnt := -1;
  rFilterRq := OnFilterRequest;
  OnFilterRequest := Nil;
  try
    Buf[BufferSize + 1] := #0;
    first := true;
    cs := @Buf;
    sRest := '';
    ClosePGNFile;
    AssignFile(filePGN, s);
    Reset(filePGN, 1);	{ Datensatzgre = 1 }
    FPGNFile := s;
    FileOpen := true;
    FileReading := true;
    FOnlyPartsRead := true;
    rFilePosA := -1;
    Items.Clear;
    DoslIndexeClear;
    Prcnt100 := FileSize(filePGN) div BufferSize;
    Prcnt := 0;
    repeat
      rFilePos := FilePos(filePGN);
      BlockRead(filePGN, Buf, BufferSize, NumRead);
      buf[NumRead + 1] := #0;
      if first then cs1 := StrPos(cs, PGNPartieStart)
      else begin
        cs1 := StrPos(cs, #$A + PGNPartieStart);
        if cs1 <> Nil then begin
          StrLCopy(hBuf, cs, SizeOf(hBuf) - 1);
          csRest := @hBuf;
          sRest := sRest + string(csRest);
          i := Pos(#$A + PGNPartieStart, sRest);
          if i <> 0 then
            AddListItems(rFilePosA, rFilePos + (i - length(PGNPartieStart)));
        end;
      end;

      while cs1 <> Nil do begin
        if first then j := rFilePos + longint(cs1 - cs)
        else j := rFilePos + longint(cs1 - cs) + 1;  {ohne +1 stnde es auf #10}
        AddListItems(rFilePosA, j);
        inc(cs1);
        cs1 := StrPos(cs1, #$A + PGNPartieStart);
        First := false;
      end;
      if numRead > length(PGNPartieStart) - 1 then begin
        csRest := @buf[NumRead - (length(PGNPartieStart) - 1)];
        sRest := string(csRest);          {problematisch knnte werden: 1. erstes PGNPartiestart steht erst kurz vor Bufferende; 2. In Partie-Zgenotat. beginnt erste Zeile mit PGNPartiestart (in Kommentar oder so) - beides ist unwahrscheinlich}
      end;

      inc(prcnt);
      NewPrcnt := GetPercent(prcnt, prcnt100);
      if (lHeader.Count > 50) and (NewPrcnt <> LastPrcnt) then begin
        if assigned(FOnPGNTrace) then FOnPGNTrace(self, NewPrcnt, Abbruch);
        LastPrcnt := NewPrcnt;
      end;
    until (NumRead = 0) or (Abbruch = cmCancel);
    if Abbruch <> cmCancel then begin
      FOnlyPartsRead := false;
      AddListItems(rFilePosA, FileSize(filePGN));
    end;
  finally
    OnFilterRequest := rFilterRq;
    FileReading := false;
    LastID := lHeader.Count - 1;
    screen.cursor := crDefault;
    if assigned(FOnPGNTrace) then FOnPGNTrace(self, 0, Abbruch);
    Refresh;
  end;
end;

function TPGN.AdjustGameString(lHeaderIndex : longint; sGame : string; Modus : integer) : string;
begin
  sGame := trim(sGame);
  if lHeader.Count = 0 then
    Result := sGame
  else if Modus = pgnAdd then  {in dem Fall ist ID undefiniert}
    Result := pgnRetString + pgnRetString + sGame
  else if Modus = pgnInsert then Result := sGame + pgnRetString + pgnRetString
  else if lHeader.Count = 1 then Result := sGame
  else begin
    if lHeaderIndex = lHeader.Count - 1 then Result := sGame
    else Result := sGame + pgnRetString + pgnRetString;
  end;
end;

function TPGN.GetFilePosIndex(ID : longint; Var FilePosindexA : longint) : longint;
Var i : longint;
begin
  Result := -1;
  i := 0;
  while i < lHeader.Count do begin
    if PGameHeader(lHeader[i])^.ID = ID then begin
      Result := i;
      FilePosIndexA := PGameHeader(lHeader[i])^.FilePositionA;
      break;
    end;
    inc(i);
  end;
end;

function TPGN.AddGame(Var ID : longint; sGame : String) : Boolean;
Var s : string;
    cswrite : Pointer;
    i : longint;
begin
  Result := false;
  s := AdjustGameString(ID, sGame, pgnAdd);
  i := FileSize(filePGN);
  Seek(filePGN, i);
  GetMem(cswrite, length(s) + 1);
  screen.cursor := crHourglass;
  try
    StrCopy(csWrite, PChar(s));
    BlockWrite(filePGN, cswrite^, length(s));
    if lHeader.Count <> 0 then i := i + 4;  {bei leerer Datei wurde anfangs keine Leerzeile eingefgt}
    AddIndexObject(lHeader.Count, LastID + 1, i, FileSize(filePGN));
    AddItem(Items.Count, lHeader.Count - 1);
    inc(LastID);
    ID := LastID;
    Result := true;
  finally
    screen.cursor := crDefault;
    FreeMem(cswrite, length(s) + 1);
  end;
end;

function TPGN.DeleteGame(ListeIndex : longint) : Boolean;
Var NumRead, NumWritten, readindex, writeindex, l, lHeaderNummer : longint;
    Buffer : Pointer;
    prcnt, prcnt100, NewPrcnt, LastPrcnt : integer;
begin
  Result := false;
  if (FileReading) or (not FileOpen) then exit;
  if (ListeIndex < 0) or (Listeindex >= Items.Count) then exit;
  lHeaderNummer := GetItemsObject(ListeIndex);//longint(Items.Objects[ListeIndex]);
  if not ((lHeadernummer >= 0) and (lHeadernummer < lHeader.Count)) then exit;
  GetMem(Buffer, BufferSize);
  screen.cursor := crHourglass;
  Abbruch := cmCancelDenied;
  LastPrcnt := -1;
  FileReading := true;
  Deleting := true; {verhindert Draw-Ereignis}
  try
    if lHeadernummer < lHeader.Count - 1 then
    readindex := PGameHeader(lHeader[lHeadernummer + 1]).FilePositionA
    else readindex := PGameHeader(lHeader[lHeadernummer]).FilePositionE;
    writeindex := PGameHeader(lHeader[lHeadernummer]).FilePositionA;
    l := writeindex - readindex;
    Prcnt100 := FileSize(filePGN) div BufferSize;
    Prcnt := 0;
    repeat
      seek(filePGN, readindex);
      BlockRead(filePGN, Buffer^, BufferSize, NumRead);
      inc(readindex, BufferSize);
      seek(filePGN, writeindex);
      if NumRead <> 0 then BlockWrite(filePGN, Buffer^, NumRead, NumWritten);
      inc(writeindex, BufferSize);
      inc(prcnt);
      NewPrcnt := GetPercent(prcnt, prcnt100);
      if NewPrcnt <> LastPrcnt then begin
        if assigned(FOnPGNTrace) then FOnPGNTrace(self, NewPrcnt, Abbruch);
        LastPrcnt := NewPrcnt;
      end;
    until (NumRead = 0) or (NumRead <> NumWritten) or (readindex >= Filesize(filePGN));
    truncate(filePGN);
    DeleteIndexObject(lHeadernummer);
    UpDateFileIndexe(lHeadernummer, l);
    DeleteItem(ListeIndex);
    Result := true;
  finally
    screen.cursor := crDefault;
    FreeMem(Buffer, BufferSize);
    Deleting := false;
    if assigned(FOnPGNTrace) then FOnPGNTrace(self, 0, Abbruch);

    FileReading := false;
    Refresh;
  end;
end;

function TPGN.DoSaveGame(ListeIndex : longint; Var ID : longint; sGame : String; Modus : integer) : Boolean;
Var
  NumRead, NumWritten, NumWrite, BufSize, Nummer: Longint;
  csread, cswrite, cstemp : Pointer;
  l, lr, readindex, writeindex : longint;
  s : string;
  prcnt, prcnt100, NewPrcnt, LastPrcnt : integer;
begin
  Result := false;
  if (FileReading) or (not FileOpen) then exit;
  if (ListeIndex = pgnAddGame) or
  ((Modus = pgnInsert) and (FPGNSorted <> soNothing)){kein Einfgen bei Sortierter Liste}
  then begin
    Result := AddGame(ID, sGame);
    exit;
  end;
  nummer := GetFilePosIndex(ID, readindex);
  if nummer = -1 then begin
    Result := AddGame(ID, sGame);
    exit;
  end;
  s := AdjustGameString(ID, sGame, Modus);
  l := length(s);
  if l < Buffersize then BufSize := BufferSize
  else BufSize := l;
  GetMem(csread, BufSize + 1);
  GetMem(cswrite, BufSize + 1);
  StrCopy(cswrite, PChar(s));
  screen.cursor := crHourglass;
  Abbruch := cmCancelDenied;
  LastPrcnt := -1;
  FileReading := true;
  try
    writeindex := readindex;
    Reset(filePGN, 1);	{ Datensatzgre = 1 }

    lr := 0;
    if modus = pgnReplace then begin
      readindex := PGameHeader(lHeader[nummer]).FilePositionE;
      lr := l - (readindex - writeindex);
    end;

    seek(filePGN, readindex);
    BlockRead(filePGN, csread^, BufSize, NumRead);
    inc(readindex, BufSize);
    seek(filePGN, writeindex);
    BlockWrite(filePGN, cswrite^, l, NumWritten);  {neue Partie schreiben}
    inc(writeindex, l);
    StrCopy(cswrite, csread);
    NumWrite := NumRead;
    Prcnt100 := FileSize(filePGN) div BufSize;
    Prcnt := 0;
    repeat
      seek(filePGN, readindex);
      BlockRead(filePGN, csread^, BufSize, NumRead);
      inc(readindex, BufSize);
      seek(filePGN, writeindex);
      BlockWrite(filePGN, cswrite^, NumWrite, NumWritten);
      inc(writeindex, BufSize);
      NumWrite := NumRead;
      cstemp := cswrite;
      cswrite := csread;
      csread := cstemp;
      inc(prcnt);
      NewPrcnt := GetPercent(prcnt, prcnt100);
      if NewPrcnt <> LastPrcnt then begin
        if assigned(FOnPGNTrace) then FOnPGNTrace(self, NewPrcnt, Abbruch);
        LastPrcnt := NewPrcnt;
      end;
    until NumRead = 0;

    if modus = pgnReplace then begin
      truncate(filePGN);
      PGameHeader(lHeader[nummer])^.FilePositionE :=
        PGameHeader(lHeader[nummer])^.FilePositionE + lr;
      UpDateFileIndexe(nummer + 1, lr);
    end
    else begin
      AddIndexObject(nummer, LastID + 1, PGameHeader(lHeader[nummer])^.FilePositionA,
      PGameHeader(lHeader[nummer])^.FilePositionA + l);
      UpDateFileIndexe(nummer + 1, l);
      AddItem(ListeIndex, nummer);
      inc(LastID);
      ID := LastID;
    end;

    Result := true;
  finally
    screen.cursor := crDefault;
    FreeMem(csread, BufSize + 1);
    FreeMem(cswrite, BufSize + 1);
    if assigned(FOnPGNTrace) then FOnPGNTrace(self, 0, Abbruch);
    FileReading := false;
  end;
end;

function TPGN.SaveGame(ListeIndex : longint; Var ID : longint; sGame : String) : Boolean;
Var i : longint;
begin
  if (ListeIndex <= pgnAddGame) or (ListeIndex >= Items.Count) then i := pgnAddGame
  else begin
    i := ListeIndex;
    ID := PGameHeader(lHeader[GetItemsObject(ListeIndex){longint(Items.Objects[ListeIndex])}])^.ID;
  end;
  Result := DoSaveGame(i, ID, sGame, pgnInsert);
end;

function TPGN.ReplaceGame(Var ID : longint; sGame : String) : Boolean;
begin
  Result := DoSaveGame(-2, ID, sGame, pgnReplace);  { -2 nur dummy - wird bei pgnReplace nicht gebraucht}
end;

function TPGN.DoGetGameAsString(lHeaderIndex : longint) : string;
Var eindex, aindex, diff, rFilePos : longint;
    csread : Pointer;
begin
  Result := '';
  try
    aindex := PGameHeader(lHeader[lHeaderIndex])^.FilePositionA;
    eindex := PGameHeader(lHeader[lHeaderIndex])^.FilePositionE;
    diff := eIndex - aIndex;
    GetMem(csread, diff + 1);
    rFilePos := FilePos(filePGN);
    try
      FillChar(csread^, diff + 1, #0);
      seek(filePGN, aindex);
      BlockRead(filePGN, csread^, diff);
      Result := trim(String(PChar(csread)));
    finally
      FreeMem(csread, diff + 1);
      seek(filePGN, rFilePos);
    end;
  except
  end;
end;

function TPGN.GetGameAsString(lHeaderIndex : longint; Var ID : longint) : string;
begin
  Result := '';
  if not FileOpen then exit;
  Screen.Cursor := crHourGlass;
  try
    ID := -1;
    if (lHeaderIndex >= 0) and (lHeaderIndex < lHeader.Count) then begin
      Result := DoGetGameAsString(lHeaderIndex);
      if Result <> '' then ID := PGameHeader(lHeader[lHeaderIndex])^.ID;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

function  TPGN.GetItemsVisibleCount : longint;
begin
  Result := Items.Count;
end;

function  TPGN.GetItemsAllCount : longint;
begin
  Result := lHeader.Count;
end;

end.

