unit SchachProcs;

{$B-}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Menus, Spin, ComCtrls, clipbrd;

Const

  KEINWERT = 1000;  {Rckgabewert, falls Funktion aktuellerWert keinen findet (Fehler im Memotext)
  - 1000 ist kein mgl. Wert (geht blo bis 320}

  //crHandcursor = 5;

  nach_rechts = 0;   {fr Stellungsverschieben}
  nach_links  = 1;
  nach_oben   = 2;
  nach_unten  = 3;
  viertel_drehen = 4;
  spiegeln_an_y  = 5;

  KEINEROCHADE = 0;
  KURZEROCHADE = 1;
  LANGEROCHADE = 2;
  KURZEFISCHERROCHADE = 3;
  LANGEFISCHERROCHADE = 4;

  WK = 6; WD = 5; WT = 2; WL = 3; WS = 4; WB = 1;
  SK =-6; SD =-5; ST =-2; SL =-3; SS =-4; SB =-1;

  {**** Figuren. Schema: <Farbe>_<Figur> *}
  S_K = -6;        { Kennung fuer Schwarze Figuren }
  S_D = -5;
  S_S = -4;
  S_L = -3;
  S_T = -2;
  S_B = -1;
  W_B =  1;          { Kennung fuer weisse Figuren }
  W_T =  2;
  W_L =  3;
  W_S =  4;
  W_D =  5;
  W_K =  6;
  LEER=  0;          { Leeres Feld }
  RAND= 100;         { Umrandung des Schachbrettes }

  legaler_Zug   = 0;
  matt          = 1;
  patt          = 2;
  illegaler_zug = 3;
  mit_Matt      = 4;
  mit_Patt      = 5; {INFO dazu wre zustzlich Prfung nach ausgef. Zug erf. - tritt aber selten auf}
  fehler        = 6;
  mit_schach    = 7;

  nr = 0;         {fr Rochademglichkeiten-Set}
  wkr = 1;
  wlr = 2;
  skr = 3;
  slr = 4;

  a1=21;b1=22;c1=23;d1=24;e1=25;f1=26;g1=27;h1=28;
  a2=31;b2=32;c2=33;d2=34;e2=35;f2=36;g2=37;h2=38;
  a3=41;b3=42;c3=43;d3=44;e3=45;f3=46;g3=47;h3=48;
  a4=51;b4=52;c4=53;d4=54;e4=55;f4=56;g4=57;h4=58;
  a5=61;b5=62;c5=63;d5=64;e5=65;f5=66;g5=67;h5=68;
  a6=71;b6=72;c6=73;d6=74;e6=75;f6=76;g6=77;h6=78;
  a7=81;b7=82;c7=83;d7=84;e7=85;f7=86;g7=87;h7=88;
  a8=91;b8=92;c8=93;d8=94;e8=95;f8=96;g8=97;h8=98;

  {*
  *** Farbe, die am Zug ist
  *}
  WEISS  =  1;
  SCHWARZ= -1;

  PGNPartieStart  = '[Event ';

  Gewinn = '1-0';    {PGN - Ergebnis}
  Remis  = '1/2-1/2';
  Verlust= '0-1';
  keinErgebnis = '*';

  feldnamen : array[0..63] of string[2] =
 ('a1','b1','c1','d1','e1','f1','g1','h1',
  'a2','b2','c2','d2','e2','f2','g2','h2',
  'a3','b3','c3','d3','e3','f3','g3','h3',
  'a4','b4','c4','d4','e4','f4','g4','h4',
  'a5','b5','c5','d5','e5','f5','g5','h5',
  'a6','b6','c6','d6','e6','f6','g6','h6',
  'a7','b7','c7','d7','e7','f7','g7','h7',
  'a8','b8','c8','d8','e8','f8','g8','h8');

   FeldFarbe : array[0..63] of byte =  (1,0,1,0,1,0,1,0,
                                        0,1,0,1,0,1,0,1,
                                        1,0,1,0,1,0,1,0,
                                        0,1,0,1,0,1,0,1,
                                        1,0,1,0,1,0,1,0,
                                        0,1,0,1,0,1,0,1,
                                        1,0,1,0,1,0,1,0,
                                        0,1,0,1,0,1,0,1);

  FENFigurennamen : array[-6..6] of char = ('k','q','n','b','r','p',' ','P','R','B','N','Q','K');

  noDiagrammzeichen = #127;
  noReturn = #13#10;

  mess : array[1..12] of string = ('Kann Datei nicht lesen.','Cannot read file.',
      'Partie nicht gefunden.','Game not found.','Fehler im PGN-Format.','Error in PGN.',
      'Beim Einlesen der Zge ist ein Fehler aufgetreten.',
      'Error reading moves.','Datei nicht gefunden.','File not found.',
      'Partie konnte nicht gespeichert werden.', 'Could not save game.');

  FRCKennung = 'f1';  { diese (ungltige) ep-Feld im FEN wird als Kennung der Fischer-R.-Chess-Ausgangsstellung benutzt}

type

  TFischerInfo = record
    enabled : Boolean;
    FischerLeftWhiteRook,
    FischerRightWhiteRook,
    FischerLeftBlackRook,
    FischerRightBlackRook,
    FischerWhiteKing,
    FischerBlackKing : shortint;  {AusgangsFelder fr Fischerrochade merken}
  end;
  PFischerInfo = ^TFischerInfo;

  TSchachbrett = array[0..119] of integer;
  PSchachbrett = ^TSchachbrett;
  TRochademoeglichkeiten = set of 1..4;
  TZug = packed record Rochademoeglichkeiten : TRochademoeglichkeiten; epFeld, amZug,
         von, nach, epSchlag, RochadeArt, UFigur, geschlFigur, attr1, attr2 : shortInt; {attr1 fr !,? oder Schach}
         end;
  PZug = ^TZug;

  TEventData = record
    Weiss, Schwarz, quelle, Annotator, ort, ergebnis, Eco : string;
    Jahr, Monat, Tag, Runde, WElo, SElo, PlyCount : Integer;
    FENString : string;
    MetaDescription, MetaKeywords : string;
  end;

const
  AusgangsStellung : TSchachbrett =  (
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,
  RAND,W_T, W_S ,W_L ,W_D ,W_K ,W_L ,W_S ,W_T, RAND,
  RAND,W_B, W_B ,W_B ,W_B ,W_B ,W_B ,W_B ,W_B, RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,S_B ,S_B ,S_B ,S_B ,S_B ,S_B ,S_B ,S_B, RAND,
  RAND,S_T, S_S ,S_L ,S_D ,S_K ,S_L ,S_S ,S_T, RAND,
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND);

  leereStellung : TSchachbrett =(
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER, RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER, RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER,RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER, RAND,
  RAND,LEER,LEER,LEER,LEER,LEER,LEER,LEER,LEER, RAND,
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,
  RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND,RAND);

  function  c(feld : byte) : byte;  {wandelt 0..63 in 21..98 um}
  function  cc(feld : byte) : byte;  {wandelt 21..98 in 0..63 um}
  function  GetPercent(part, Hundred : integer) : integer;
  function  PosToFEN(Position : TSchachbrett; PosInfo : TZug; nr : integer; FischerInfo : PFischerinfo) : string;
  function  FENToPos(epd : string; Var Stllg : TSchachBrett; Var StllgInfo : TZug; Var znr : word; FischerInfo : PFischerinfo) : Boolean;
  function  CheckPGN(s : String) : Boolean;
  procedure ResetEventData(Var e : TEventData);
  procedure SetEventData(Var e : TEventData; s : string);  { s ist eine einzelne Zeile des PGN-Headers - wird dann in das entsprechende Feld von e geschr.}
  procedure SetFischerInfo(FischerInfo : PFischerInfo; Stllg : TSchachBrett);
  function  AppendGameToPGN(FileName, Games : string) : Boolean;
  function  GetFischerRandomPosition : TSchachbrett;
  function  GetPiecesNumber(Stellung : TSchachbrett; Zug : TZug) : string;  // gibt Anzahl zurck SaZ (4 + 3)

implementation

function  cc(feld : byte) : byte;  {wandelt 21..98 in 0..63 um}
begin
  cc:=((feld div 10)-2)*8+((feld mod 10)-1);
end;

function  c(feld : byte) : byte;  {wandelt 0..63 in 21..98 um}
begin
  c:=(feld div 8)*10 + (((Feld+8) mod 8)) + 21;
end;

function GetPercent(part, Hundred : integer) : integer;
begin
  Result := 0;
  if Hundred = 0 then exit;
  Result := trunc(part * 100 / Hundred);
end;

procedure ResetEventData(Var e : TEventData);
begin
  with E do begin
    Weiss:='N.N.';Schwarz:='N.N.';Quelle:='';
    Annotator:='';Ergebnis:='*';ort:='';
    Eco := ''; FENString := '';
    Jahr:=0; Tag := 0; Monat := 0;
    Runde := 0; WElo:=0;SElo:=0;
    PlyCount := 0;
    MetaDescription := '';MetaKeywords := '';
  end;
end;

procedure SetEventData(Var e : TEventData; s : string);
Var Temp : string;
    fehler : integer;

function filtere(zeile : string) : string;
Var b : integer;
    hilf : string;
begin
  b:=1;
  while (b<=length(zeile)) and (zeile[b]<>'"') do inc(b);
  hilf:='';
  inc(b);
  while (b<=length(zeile)) and (not (zeile[b]='"')) do begin
    hilf:=hilf+zeile[b];
    inc(b);
  end;
  Filtere:=hilf;
end;

begin
  with e do begin
    if Uppercase(copy(s, 1, length(PGNPartieStart)))=Uppercase(PGNPartieStart) then begin
      quelle:=Filtere(s);
      if quelle='?' then quelle:='';
    end
    else if Uppercase(copy(s, 1, 6))='[SITE ' then begin
      ort:=Filtere(s);
      if Ort='?' then Ort:='';
    end
    else if Uppercase(copy(s, 1, 7))='[WHITE ' then begin
      weiss:=Filtere(s);
      if Weiss='?' then Weiss:='';
    end
    else if Uppercase(copy(s, 1, 7))='[BLACK ' then begin
      schwarz:=Filtere(s);
      if Schwarz='?' then Schwarz:='';
    end
    else if Uppercase(copy(s, 1, 11))='[ANNOTATOR ' then annotator:=Filtere(s)
    else if Uppercase(copy(s, 1, 8))='[RESULT ' then ergebnis:=Filtere(s)
    else if Uppercase(copy(s, 1, 10))='[WHITEELO ' then begin
      temp:=Filtere(s);
      val(temp, WElo, Fehler);
      if fehler<>0 then WElo:=0;
    end
    else if Uppercase(copy(s, 1, 10))='[BLACKELO ' then begin
      temp:=Filtere(s);
      val(temp, SElo, Fehler);
      if fehler<>0 then SElo:=0;
    end
    else if Uppercase(copy(s, 1, 10))='[PLYCOUNT ' then begin
      temp:=Filtere(s);
      val(temp, Plycount, Fehler);
      if fehler<>0 then Plycount:=0;
      if Plycount <> 0 then Plycount := (Plycount shr 1) + 1;
    end
    else if Uppercase(copy(s, 1, 6))='[DATE ' then begin
      temp:=Filtere(s);
      val(copy(temp, 1, 4), Jahr, Fehler);
      if fehler<>0 then jahr:=0;
      val(copy(temp, 6, 2), Monat, Fehler);
      if fehler<>0 then Monat:=0;
      val(copy(temp, 9, 2), Tag, Fehler);
      if fehler<>0 then Tag:=0;
    end
    else if Uppercase(copy(s, 1, 7))='[ROUND ' then begin
      temp:=Filtere(s);
      val(temp, Runde, Fehler);
      if fehler<>0 then Runde:=0;
    end
    else if Uppercase(copy(s, 1, 5))='[ECO ' then Eco:=Filtere(s)
    else if Uppercase(copy(s, 1, 5))='[FEN ' then
      FENString := Filtere(s) {das ist globale Var. , die nur ErstelleListe braucht (wird unmittelbar danach von dieser Proz. ausgelesen - ansonsten ist sie undef.}
    else if Uppercase(copy(s, 1, 14))='[METAKEYWORDS ' then
       MetaKeywords := MetaKeywords + Filtere(s)
    else if Uppercase(copy(s, 1, 17))='[METADESCRIPTION ' then
       MetaDescription := MetaDescription + Filtere(s);
  end;
end;

function CheckPGN(s : String) : Boolean;
Var f : TextFile;
    p : string;
    i : integer;
    EmptyLines : Boolean;
begin
  Result := false;
  if not FileExists(s) then exit;
  try
    assignFile(f, s);
    reset(f);
    p:= '';
    i := 0;
    EmptyLines := true;
    while (not eof(f)) and (Pos(PGNPartieStart, p) = 0) and (i < 1000) do begin
      readln(f, p);
      if p <> '' then EmptyLines := false;
      inc(i);
    end;
    CloseFile(f);
    if (Pos(PGNPartieStart, p) <> 0) or (i = 0) or (EmptyLines)
      then Result := true;
  except
  end;
end;

function PosToFEN(Position : TSchachbrett; PosInfo : TZug; nr : integer; FischerInfo : PFischerInfo) : string;
var h : string;
    i, j, k, z : integer;
begin
  j:=56;
  h:='';
  z:=0;
  repeat
    for i:=j to j+7 do begin
      k:=Position[c(i)];
      if k<>LEER then begin
         if z<>0 then begin
           h:=h+IntToStr(z);
           z:=0;
         end;
         h:=h+FENFigurennamen[k];
      end
      else inc(z);
    end;
    if z<>0 then begin
      h:=h+IntToStr(z);
      z:=0;
    end;
    dec(j, 8);
    if not j<0 then h:=h+'/';
  until j<0;
  if PosInfo.amZug=1 then h:=h+' w ' else h:=h+' b ';
  if wkr in PosInfo.Rochademoeglichkeiten then h:=h+'K';
  if wlr in PosInfo.Rochademoeglichkeiten then h:=h+'Q';
  if skr in PosInfo.Rochademoeglichkeiten then h:=h+'k';
  if slr in PosInfo.Rochademoeglichkeiten then h:=h+'q';
  if PosInfo.Rochademoeglichkeiten=[] then h:=h+'-';
  if assigned(Fischerinfo) then h:=h+' '+ FRCKennung + ' 0'
  else begin
    if PosInfo.epFeld<>LEER then h:=h+' '+feldnamen[cc(PosInfo.epFeld)]+' 0'
    else h:=h+' - 0';
  end;
  h:=h+' '+IntToStr(nr);
  Result:=h;
end;

{
Liest Stellung, falls in "FEN" eine angegeben ist
}

function FENToPos(epd : string; Var Stllg : TSchachBrett; Var StllgInfo : TZug; Var znr : word; FischerInfo : PFischerInfo) : Boolean;
Var  q, Reihe, hilf, z, i, fehler : integer;
     h : string;
     tempStllg : TSchachBrett;
const reihen : array[1..8] of shortint=(55,47,39,31,23,15,7,-1);

begin
  Result := false;
  if epd = '' then exit;
  try
    if assigned(FischerInfo) then with Fischerinfo^ do begin
      FischerLeftWhiteRook := 0;  {werden nur in Fischer-Random-Chess-Ausg.stellg. korrekt belegt!}
      FischerRightWhiteRook := 0;
      FischerLeftBlackRook := 0;
      FischerRightBlackRook := 0;
      Enabled := false;
    end;
    tempstllg:=LeereStellung;
    z:=0;
    i:=55;  {es geht von links oben nach rechts unten - anders als Feldnummerierung}
    q:=0;
    Reihe := 0;
    repeat;
      inc(q);
      if not( epd[q]='/') then begin
        if epd[q] in ['1'..'8'] then begin
          Val(epd[q],hilf, fehler);
          i:=i+hilf;
          z:=z+hilf;
          if epd[q]='8' then     {falls in FEN kein Schrgstrich als Trenner ist}
            if epd[q+1]='8' then begin
              dec(i, 16);  {nchste Reihe}
              inc(Reihe);
            end;
        end
        else begin
          inc(z);
          inc(i);
          if (i < 0) or (i > 63)
            then exit;
          case epd[q] of
            'K' : begin
                    tempStllg[c(i)]:=wK;
                    if assigned(Fischerinfo) then FischerInfo.FischerWhiteKing := c(i);
                  end;
            'Q' : tempStllg[c(i)]:=wD;
            'R' : begin
                    tempStllg[c(i)]:=wT;
                    if assigned(Fischerinfo) then begin
                      if FischerInfo.FischerLeftWhiteRook = 0 then FischerInfo.FischerLeftWhiteRook := c(i) { bei FEN lesen kommt immer zuerst der linke Turm}
                      else FischerInfo.FischerRightWhiteRook := c(i);
                    end;
                  end;
            'B' : tempStllg[c(i)]:=wL;
            'N' : tempStllg[c(i)]:=wS;
            'P' : tempStllg[c(i)]:=wB;
            'k' : begin
                    tempStllg[c(i)]:=sK;
                    if assigned(Fischerinfo) then FischerInfo.FischerBlackKing := c(i);
                  end;
            'q' : tempStllg[c(i)]:=sD;
            'r' : begin
                    tempStllg[c(i)]:=sT;
                    if assigned(Fischerinfo) then begin
                      if FischerInfo.FischerLeftBlackRook = 0 then FischerInfo.FischerLeftBlackRook := c(i)  {bei FEN lesen kommt immer zuerst der linke Turm}
                      else FischerInfo.FischerRightBlackRook := c(i);
                    end;
                  end;
            'b' : tempStllg[c(i)]:=sL;
            'n' : tempStllg[c(i)]:=sS;
            'p' : tempStllg[c(i)]:=sB;
          end;
        end;
      end
      else begin
        dec(i, 16);  {nchste Reihe}
        inc(Reihe);
      end;
    until (z>=64) or (q>=length(epd));
    if Reihe <> 7 then exit;  {nur dann war es korrekter FEN}
    Stllg := tempStllg;
    inc(q);
    with StllgInfo do begin
      epFeld:=0;
      amZug:=1;
      Rochademoeglichkeiten:=[];
      epSchlag:=LEER;
      UFigur:=LEER;
      geschlFigur:=LEER;
      RochadeArt:=KEINEROCHADE;
      attr1:=0;
      attr2:=0;
      {... b KQkq e3 0 1"}   {zuletzt steht Zugnummer}
      while q<length(epd) do begin
       if not (epd[q] in [' ','0'..'9']) then begin
        if epd[q+1] in ['0'..'9'] then begin
          if  epd[q] + epd[q+1] = FRCKennung then begin  {dann ist es Fischerausgangsstellung (f1 als ep-Feld)}
            if assigned(Fischerinfo) then Fischerinfo.Enabled := true;
            znr := 1;
          end
          else begin
            if amZug=-1 then epFeld:=c(ord(upcase(epd[q]))-65 +16)
            else epFeld:=c(ord(upcase(epd[q]))-65 +40);
          end;
        end
        else begin
          case epd[q] of
            'w' : amZug:=1;
            'b' : amZug:=-1;
            'K' : Rochademoeglichkeiten:=Rochademoeglichkeiten+[wkr];
            'Q' : Rochademoeglichkeiten:=Rochademoeglichkeiten+[wlr];
            'k' : Rochademoeglichkeiten:=Rochademoeglichkeiten+[skr];
            'q' : Rochademoeglichkeiten:=Rochademoeglichkeiten+[slr];
            end;
          end;
        end;
        inc(q);
      end;
      q:=length(epd);
      h:='';
      while (q>0) and (epd[q]<>' ') do begin
        h:=epd[q]+h;
        dec(q);
      end;
      val(h, i, z);
      if z=0 then znr:=i;
    end;
    Result := true;
  except
  end;
end;

function AppendGameToPGN(FileName, Games : string) : Boolean;
Var f : File;
    cswrite : Pointer;
begin
  Result := false;
  if not CheckPGN(FileName) then exit;
  if Games = '' then exit;
  if Games[1] <> #13 then Games := #13#10#13#10 + Games;  {Leerzeile sollte dazwischen}
  GetMem(cswrite, length(Games) + 1);
  StrCopy(cswrite, PChar(Games));
  assignFile(f, FileName);
  reset(f, 1);
  try
    seek(f, FileSize(f));
    BlockWrite(f, cswrite^, length(Games));
    CloseFile(f);
    Result := true;
  finally
    FreeMem(cswrite, length(Games) + 1);
  end;
end;

procedure SetFischerInfo(FischerInfo : PFischerInfo; Stllg : TSchachBrett);
Var i : integer;
begin
  if assigned(FischerInfo) then with FischerInfo^ do begin
    FischerLeftWhiteRook := 0;
    FischerRightWhiteRook := 0;
    FischerLeftBlackRook := 0;
    FischerRightBlackRook := 0;
    enabled := true;
    for i:=0 to 63 do begin
      case Stllg[c(i)] of
        wk : FischerWhiteKing := c(i);
        sk : FischerBlackKing := c(i);
        wt : if FischerLeftWhiteRook = 0 then FischerLeftWhiteRook := c(i)
             else FischerRightWhiteRook := c(i);
        st : if FischerLeftBlackRook = 0 then FischerLeftBlackRook := c(i)
             else FischerRightBlackRook := c(i);
      end;
    end;
  end;
end;

function GetFischerRandomPosition : TSchachbrett;
Var z : integer;
    stllg : TSchachbrett;

function GetSquare(frei : integer) : integer;
Var i : integer;
begin
  z := random(frei);
  i := 0;
  while (cc(a1 + i) < 63) and
  ((i < z) or (stllg[a1 + i] <> LEER)) do inc(i);
  Result := a1 + i;
end;

begin
  stllg := AusgangsStellung;
  For z := 0 to 7 do stllg[a1 + z] := LEER;
  z := random(4);
  stllg[a1 + (z shl 1)] := wL;  {schwarzfeldriger}
  z := random(4);
  stllg[b1 + (z shl 1)] := wL;  {weifeldriger}
  stllg[GetSquare(6)] := wD;
  stllg[GetSquare(5)] := wS;
  stllg[GetSquare(4)] := wS;
  stllg[GetSquare(1)] := wT;
  stllg[GetSquare(1)] := wK;
  stllg[GetSquare(1)] := wT;
  For z := 0 to 7 do stllg[a8 + z] := -stllg[a1 + z];
  Result := stllg;
end;

function GetPiecesNumber(Stellung : TSchachbrett; Zug : TZug) : string;  // gibt Anzahl zurck SaZ (4 + 3)
var i, w, s : integer;
begin
  if Zug.amZug = WEISS then Result := 'WaZ    '
  else Result := 'SaZ    ';
  w := 0;
  s := 0;
  for i := 0 to 63 do begin
    if Stellung[c(i)] > 0 then inc(w);
    if Stellung[c(i)] < 0 then inc(s);
  end;
  Result := Result + '(' + IntToStr(w) + ' + ' +  IntToStr(s) + ')';
end;


end.
